-------------------------------------------------------------------------------
-- Title      : GenEndSignature
-- Project    : Chip-Module for first submission on 28.04.2000
-------------------------------------------------------------------------------
-- File       : GenEndSignature.vhd
-- Author     : Rolf Schneider  <rolf.schneider@kip.uni-heidelberg.de>
-- Company    : University Heidelberg - KIP
-- Last update: 2000/04/07
-- Platform   : Synopsys - 1999.10
-------------------------------------------------------------------------------
-- This is a first Chip-Module design test for the submission on 28.02.2000
-- to get experience with the AMS-0.35u technologie
-------------------------------------------------------------------------------
-- Description: generation of the end signature (la) out of the hamming code
-------------------------------------------------------------------------------
-- Revisions  :
-- Date        Version  Author    Description
-- 2000/03/03  1.0      schneide  Created
-- 2000/03/30  1.1      schneide  Reduced to Low Latency Design
-------------------------------------------------------------------------------

library IEEE;
use IEEE.std_logic_1164.all;
use WORK.Global.all;

entity GenEndSignature is
  port (
    code:               in  External_Bus;
    end_signature:      out STD_LOGIC);         -- low active
end GenEndSignature;

architecture v of GenEndSignature is

begin

  gen_end_sig: process(code)
    begin
      case code is
        when end_signature_code => end_signature <= '0';
        when others => end_signature <= '1';
      end case;
    end process;

end v;
