-------------------------------------------------------------------------------
-- Title      : Multiplexer_4_edww
-- Project    : Chip-Module for first submission on 28.04.2000
-------------------------------------------------------------------------------
-- File       : Multiplexer_4_edww.vhd
-- Author     : Rolf Schneider  <rolf.schneider@kip.uni-heidelberg.de>
-- Company    : University Heidelberg - KIP
-- Last update: 2000/04/04
-- Platform   : Synopsys - 1999.10
-------------------------------------------------------------------------------
-- This is a first Chip-Module design test for the submission on 28.04.2000
-- to get experience with the AMS-0.35u technologie
-------------------------------------------------------------------------------
-- Description: Multiplexer (4:1) with event_data_word_width
-------------------------------------------------------------------------------
-- Revisions  :
-- Date        Version  Author  Description
-- 2000/04/03  1.0      schneide	Created
-------------------------------------------------------------------------------

library IEEE;
use IEEE.std_logic_1164.all;
use WORK.Global.all;

entity Multiplexer_4_edww is
  port (
    in_data1:           in  Event_Data_Word;  -- if sel="00"
    in_data2:           in  Event_Data_Word;  -- if sel="01"
    in_data3:           in  Event_Data_Word;  -- if sel="10"
    in_data4:           in  Event_Data_Word;  -- is sel="11"
    sel:                in  STD_LOGIC_VECTOR(1 downto 0);
    out_data:           out Event_Data_Word);
end Multiplexer_4_edww;

architecture v of Multiplexer_4_edww is
begin

  muxsel: process(sel, in_data1, in_data2, in_data3, in_data4)
    begin
      case sel is
        when "00" => out_data <= in_data1;
        when "01" => out_data <= in_data2;
        when "10" => out_data <= in_data3;
        when "11" => out_data <= in_data4;
        when others => null;
      end case;
    end process;

end v;

