-------------------------------------------------------------------------------
-- Title      : Multiplexer_ebw
-- Project    : Chip-Module for first submission on 28.04.2000
-------------------------------------------------------------------------------
-- File       : Multiplexer_ebw.vhd
-- Author     : Rolf Schneider  <rolf.schneider@kip.uni-heidelberg.de>
-- Company    : University Heidelberg - KIP
-- Last update: 2000/04/04
-- Platform   : Synopsys - 1999.10
-------------------------------------------------------------------------------
-- This is a first Chip-Module design test for the submission on 28.04.2000
-- to get experience with the AMS-0.35u technologie
-------------------------------------------------------------------------------
-- Description: Multiplexer (2:1) with external_bus_width
-------------------------------------------------------------------------------
-- Revisions  :
-- Date        Version  Author  Description
-- 2000/02/26  1.0      schneide	Created
-------------------------------------------------------------------------------

library IEEE;
use IEEE.std_logic_1164.all;
use WORK.Global.all;

entity Multiplexer_ebw is
  port (
    in_data1:           in  External_Bus;
    in_data2:           in  External_Bus;
    sel:                in  STD_LOGIC;
    out_data:           out External_Bus);
end Multiplexer_ebw;

architecture v of Multiplexer_ebw is
begin

  muxsel: process(sel, in_data1, in_data2)
    begin
      case sel is
        when '0' => out_data <= in_data1;
        when '1' => out_data <= in_data2;
        when others => null;
      end case;
    end process;

end v;

