-------------------------------------------------------------------------------
-- Title      : Register_ebw
-- Project    : Chip-Module for first submission on 28.04.2000
-------------------------------------------------------------------------------
-- File       : Register_ebw.vhd
-- Author     : Rolf Schneider  <rolf.schneider@kip.uni-heidelberg.de>
-- Company    : University Heidelberg - KIP
-- Last update: 2000/04/04
-- Platform   : Synopsys - 1999.10
-------------------------------------------------------------------------------
-- This is a first Chip-Module design test for the submission on 28.04.2000
-- to get experience with the AMS-0.35u technologie
-------------------------------------------------------------------------------
-- Description: simple register (external_bus_width) with reset
-------------------------------------------------------------------------------
-- Revisions  :
-- Date        Version  Author  Description
-- 2000/02/26  1.0      schneide	Created
-------------------------------------------------------------------------------

library IEEE;
use IEEE.std_logic_1164.all;
use WORK.Global.all;

entity Register_ebw is
  port (
    clk:                in  STD_LOGIC;
    reset:              in  STD_LOGIC;
    in_data:            in  External_Bus;
    out_data:           out External_Bus);
end Register_ebw;

architecture v of Register_ebw is
begin
  
  reg: process(clk, reset, in_data)
    begin
      if clk'event and clk='1' then
        out_data <= in_data;
      end if;
      if reset='0' then
        out_data <= (others => '0');
      end if;
    end process;
    
end v;
