/**************************************************************************
 * Copyright(c) 1998-1999, ALICE Experiment at CERN, All rights reserved. *
 *                                                                        *
 * Author: The ALICE Off-line Project.                                    *
 * Contributors are mentioned in the code where appropriate.              *
 *                                                                        *
 * Permission to use, copy, modify and distribute this software and its   *
 * documentation strictly for non-commercial purposes is hereby granted   *
 * without fee, provided that the above copyright notice appears in all   *
 * copies and that both the copyright notice and this permission notice   * 
 * appear in the supporting documentation. The authors make no claims     *
 * about the suitability of this software for any purpose. It is          *
 * provided "as is" without express or implied warranty.                  *
 **************************************************************************/

/*
$Log$
*/

#include "AliTRDfitPadrow.h"
#include <AliTRDgtuGlobal.h>
#include <iostream>
#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <time.h>
#include <AliTRDfitTracklet.h>
#include <AliTRDfitType.h>



ClassImp(AliTRDfitTracklet)


//_________________________________________________________________________
AliTRDfitTracklet::AliTRDfitTracklet(Int_t iPlane, Int_t iSector, Int_t iChamber, Int_t iPadrow):TObject()
{
  //
  //  AliTRDfitTracklet default constructor
  //

  fMainTrack = -1;
  fRPos = -1;
  fAngle = -1;
  fRPosProj = -1;
  fTrQuality = -1;
  fChi2 = -1;
  fNTracks = -1;	  // involved tracks
  fDefl = -1;
  fMainTrackCount = -1;
  fEject = -1;
//  fMerge = -1;
  
  
  fTracks = new TArrayI(10); 	  //construktor 
  fTracksCount = new TArrayI(10); //construktor
  
  for(Int_t i = 0; i<10; i++) {   
  fTracks->AddAt(-1, i);	// set all entries to -1	
  fTracksCount->AddAt(0, i);    // set all entries to 0
  }
  
  for(Int_t i = 0; i<kTimebins; i++) {   
  fArray_yi[i] = -2000;    // set all entries to -2000
  }
  

  fPlane   = iPlane;
  fSector  = iSector;
  fChamber = iChamber;
  fPadrow  = iPadrow;
  
}
//_________________________________________________________________________
AliTRDfitTracklet::~AliTRDfitTracklet()
{
  //
  //  AliTRDfitTracklet default destructor
  //
  
  
  delete fTracks;
  delete fTracksCount;
  
}

//_________________________________________________________________________
void AliTRDfitTracklet::AddTrack(Int_t TrackID)
{
  //
  // Add a new track id to the list
  //
    
  Int_t i= -1;
  Int_t tmpcount = 0;
  
  if (TrackID == -1) return;
  
  for (Int_t p = 0; p < fTracks->GetSize(); p++) {
   if (TrackID == fTracks->At(p)) {
   //cout << "ID-No. is inside: " << fTracks->At(p) << " at Pos: " << p << endl;
   i=0;
   tmpcount = fTracksCount->At(p);		// readout count
   tmpcount += 1;				// increment
   fTracksCount-> AddAt( tmpcount,p);	// write back
   // cout << "Trackcount wird incrementiert; Current count: " << fTracksCount-> At(p) << endl;
   }
  }
  if (i != 0) {
   for (Int_t j = 0; j < 10; j++) {		// put new Trackid in array
    if (fTracks->At(j) == -1) {			// search for a free place  
     fTracks-> AddAt( TrackID,j);		// Set count to 1 
     fTracksCount-> AddAt( 1,j);		// exit 
     // cout << "Ini ID: " << fTracks->At(j) << " Pos: " << j << " Trackcount: " << fTracksCount-> At(j) << endl; 
     goto weitergehts;						// break;
     cout << "Darf nicht sein\n";
    }
   }
  }
  weitergehts: 
   if (i==3000)
   cout << "Aus der Schleife 1 gesprungen" << endl;	// verlasse die Funktion
}

//_________________________________________________________________________
void AliTRDfitTracklet::AddTrackandCount(Int_t TrackID, Int_t count)
{
  //
  // Add a new track id to the list and update the pointer list
  //
    
  Int_t i= -1;
  Int_t tmpcount = 0;
  
  if (TrackID == -1) return;
  
  for (Int_t p = 0; p < fTracks->GetSize(); p++) {
  	if (TrackID == fTracks->At(p)) {		// track is member of the list
	i=0;
	// cout << "AddTrackandCount, Track is member; ID: " << TrackID << endl;
	// cout << "Trackcount wird uebernommen, oldcount: " << fTracksCount-> At(p) << endl;
	// cout << "Uebergabecount: " << count << endl;
	tmpcount = fTracksCount->At(p);			// get track count from current track
	tmpcount += count;				// add count to track count
	fTracksCount-> AddAt( tmpcount,p);		// save
	// cout << "Trackcount wird uebernommen, newcount: " << fTracksCount-> At(p) << endl;
	
	}
  }
  if (i != 0) {						// track is not a member
   for (Int_t j = 0; j < 10; j++) {
     if (fTracks->At(j) == -1) {
      // cout << "AddTrackandCount, Track is NOT member; ID: " << TrackID << endl;
      fTracks-> AddAt( TrackID,j);
      fTracksCount-> AddAt( count,j);			// update track count
      goto bye;						// break; leaf the loop
      cout << "Darf nicht sein\n";
     }
   }
  
  }
  bye:
   if (i==3000)
   cout << "Aus der Schleife 2 gesprungen" << endl;	// verlasse die Funktion
}


//_________________________________________________________________________
void AliTRDfitTracklet::Dump()
{
  //
  //  print out the main parameters
  //
  
  cout << "\tPlane: " << fPlane << "\t\tSector: " << fSector << endl;
  cout << "\tChamber: " << fChamber << "\t\tPadrow: " << fPadrow << endl;
  cout << "\tMain Track:\t\t" << fMainTrack << " with " << fMainTrackCount << " digits" << endl;
  cout << endl;
  
  for (Int_t i=0; i<10;i++) {
    if (fTracks->At(i) != -1) {
     cout << "\tChannel: " << endl;
     cout << "\tTrack " << i <<":\t\t" << fTracks->At(i) << endl;
    }
  }
  cout << "\tAngle:\t\t\t" << fAngle << endl;
  cout << "\tPos:\t\t\t" << fRPos << endl;
  cout << "\tChi2:\t\t\t" << fChi2 << endl;
  cout << "\tInvolved tracks:\t" << fNTracks << endl;
  cout << "\tEject: " << fEject << endl;
  cout << "\tMerge: " << fMerge << endl; 
  
  // cout << "\tAll involved positions";
  // cout << "\t";
  // for (Int_t i=0; i<kTimebins;i++) 
  // cout << fArray_yi[i] << "  ";
  
  cout << endl;
  
}

//_________________________________________________________________________
Int_t AliTRDfitTracklet::TrackCount()
{
  //
  //  how many tracks are involed 
  //
  Int_t count = 0;
  
  for (Int_t i=0; i<10; i++) {	//loop over all tracks
    if (fTracks->At(i) != -1)
    count += 1;
  }
  return count;
  
}

//_________________________________________________________________________
void AliTRDfitTracklet::MainTrack()
{
  //
  //  Calculate the main track
  //
  Int_t count = -1;
  Int_t pos = -1;
  
  for (Int_t i=0; i<10; i++) {
    if (fTracksCount->At(i) > count) {
    count = fTracksCount->At(i);
    //cout << "count" << count << endl;
    pos = i;
    }
  }
  fMainTrack = fTracks->At(pos);	// set main track
  fMainTrackCount = count;		// set main track count
  count = -1;				// reset count and pos
  pos = -1;
  
}


