#ifndef AliTRDgtu_H
#define AliTRDgtu_H
/* Copyright(c) 1998-1999, ALICE Experiment at CERN, All rights reserved. *
 * See cxx source for full Copyright notice                               */

/* $Id: AliTRDgtu.h,v 1.1.1.1 2001/01/16 18:02:33 schneide Exp $ */

#include <TObject.h>
#include "AliTRDgtuBlock.h"

class AliTRDgtu : public TObject {

  public:

    AliTRDgtu();
    AliTRDgtu(Int_t iSector, Int_t iChamber);
    virtual ~AliTRDgtu();

    void            SetWarningLevel(Int_t mode);
    void            Info();
    AliTRDgtuBlock *GetBlock(Int_t iSector, Int_t iChamber);
    Int_t           Global2Local(Int_t iSector, Int_t iChamber);
    void            Local2Global(Int_t iLocal, Int_t *iSector, Int_t *iChamber);

  private:

    AliTRDgtuBlock *fBlock[kSectors][kChambers];

  protected:

    ClassDef(AliTRDgtu,1)  // TRD Global Tracking Unit (GTU) base class

};

#endif
