#ifndef ALITRDGTUBLOCK_H
#define ALITRDGTUBLOCK_H
/* Copyright(c) 1998-1999, ALICE Experiment at CERN, All rights reserved. *
 * See cxx source for full Copyright notice                               */

/* $Id: AliTRDgtuBlock.h,v 1.1.1.1 2001/01/16 18:02:33 schneide Exp $ */

#include <TObject.h>
#include "AliTRDgtuConst.h"
#include "AliTRDgtuLink.h"
#include "AliTRDgtuTMU.h"
#include "AliTRDgtuVisual.h"

class AliTRDgtuBlock : public TObject {

  public:

    AliTRDgtuBlock();
    AliTRDgtuBlock(Int_t iSector, Int_t iChamber);
    virtual ~AliTRDgtuBlock();

    void    ReadASCII(Int_t iLayer, char *iFilename);
    void    AddCandidate(Int_t iLayer, AliTRDgtuCandidate *iCand);
    void    CalcMidlayer();
    void    InitTMUs();
    void    Clear();
    void    OutputBlockData();
    void    OutputTMUs();
    void    FindTracks(Int_t iPadrow);
    void    OutputTracks(Int_t iPadrow);
    void    VisualTMUcandidates2D(AliTRDgtuVisual *iVisual, Int_t iPadrow);
    void    VisualTMUtracks2D(AliTRDgtuVisual *iVisual, Int_t iPadrow);
    void    VisualBlockCandidates3D(AliTRDgtuVisual *iVisual);

    void    SetSector(Int_t iSector) { fSector = iSector; }
    void    SetChamber(Int_t iChamber) { fChamber = iChamber; }
    Int_t   GetSector() const { return fSector; }
    Int_t   GetChamber() const { return fChamber; }

  private:

    AliTRDgtuLink *fLink[kLayers];           // chamber links
    AliTRDgtuTMU  *fTMU[kPadrowsPerChamber]; // dedicated TMUs

    Int_t          fSector;  // current sector identifier
    Int_t          fChamber; // current chamber identifier

  protected:

    ClassDef(AliTRDgtuBlock,1)               // TRD GTU Block class (6 chambers)

};

#endif
