#ifndef ALITRDGTULINK_H
#define ALITRDGTULINK_H
/* Copyright(c) 1998-1999, ALICE Experiment at CERN, All rights reserved. *
 * See cxx source for full Copyright notice                               */

/* $Id: AliTRDgtuLink.h,v 1.1.1.1 2001/01/16 18:02:33 schneide Exp $ */

#include <TObjArray.h>
#include "AliTRDgtuCandidate.h"

class AliTRDgtuLink : public TObject {

  public:

    AliTRDgtuLink();
    AliTRDgtuLink(Int_t iPlane, Int_t iSector, Int_t iChamber);
    virtual ~AliTRDgtuLink();

    void       AddCandidate(AliTRDgtuCandidate *iCandidate);
    void       CalcMidlayer(Int_t iLayer);
    void       ReadASCII(char *iFilename);
    TObjArray *GetLinkDataObj();
    void       Clear();
    void       Output();

    void       SetPlane(Int_t iPlane) { fPlane = iPlane; }
    void       SetSector(Int_t iSector) { fSector = iSector; }
    void       SetChamber(Int_t iChamber) { fChamber = iChamber; }
    Int_t      GetPlane() const { return fPlane; }
    Int_t      GetSector() const { return fSector; }
    Int_t      GetChamber() const { return fChamber; }

  private:

    TObjArray *fLinkData; // chamber link data

    Int_t      fPlane;   // current plane identifier
    Int_t      fSector;  // current sector identifier
    Int_t      fChamber; // current chamber identifier

  protected:

    ClassDef(AliTRDgtuLink,1) // TRD GTU detector link class

};

#endif
