#ifndef ALITRDGTUTRACK_H
#define ALITRDGTUTRACK_H
/* Copyright(c) 1998-1999, ALICE Experiment at CERN, All rights reserved. *
 * See cxx source for full Copyright notice                               */

/* $Id: AliTRDgtuTrack.h,v 1.1.1.1 2001/01/16 18:02:33 schneide Exp $ */

#include <TObjArray.h>
#include "AliTRDgtuConst.h"
#include "AliTRDgtuCandidate.h"

class AliTRDgtuTrack : public AliTRDgtuCandidate {

  public:

    AliTRDgtuTrack();
    virtual ~AliTRDgtuTrack();

    void       AddCandidate(AliTRDgtuCandidate *iCandidate);
    void       CalcTrack();
    TObjArray *GetCandidates() const {return fCandidate; }
    Int_t      NumberOfCandidates();
    void       Output();

  private:

    TObjArray *fCandidate;                   // array of involved candidates in track

  protected:

    ClassDef(AliTRDgtuTrack,1)               // Data container for one TRD GTU Track

};

#endif
