/////////////////////////////////////////////////////////////////////
//                                                                 //
//  Example Macro for Global Tracking Unit Simluation              //
//                                                                 //
//  author: Rolf Schneider                                         //
//  date  : 2000/07/12                                             //
//                                                                 //
//  notes : global identifiers have always the order               //
//            (Plane, Sector, Chamber, Padrow)                     //
//                                                                 //
/////////////////////////////////////////////////////////////////////

void AliTRDgtu()
{
  ///////////////////////////////////////////////////////////////////
  //  Initialize Global Tracking Unit                              //
  ///////////////////////////////////////////////////////////////////

  gSystem->Load("$(ALICE_ROOT)/lib/tgt_$(ALICE_TARGET)/libTRDgtu");

  Int_t lSector  = 1;
  Int_t lChamber = 2;
  AliTRDgtu *GTU = new AliTRDgtu(1, 2);
  GTU->SetWarningLevel(1);
  GTU->Info();

  ///////////////////////////////////////////////////////////////////
  //  Track Block (-, 1, 2, -)                                     //
  ///////////////////////////////////////////////////////////////////

  AliTRDgtuBlock *Block;
  Block = GTU->GetBlock(1, 2);
  Block->ReadASCII(0, "./DATA/in0.dat");
  Block->ReadASCII(1, "./DATA/in1.dat");
  Block->ReadASCII(2, "./DATA/in2.dat");
  Block->ReadASCII(3, "./DATA/in3.dat");
  Block->ReadASCII(4, "./DATA/in4.dat");
  Block->ReadASCII(5, "./DATA/in5.dat");
  Block->CalcMidlayer();
  //Block->OutputBlockData();
  Block->InitTMUs();
  //Block->OutputTMUs();
  Block->FindTracks(10);
  Block->OutputTracks(10);

  ///////////////////////////////////////////////////////////////////
  //  Visualisation of results                                     //
  ///////////////////////////////////////////////////////////////////

  AliTRDgtuVisual *Visual = new AliTRDgtuVisual();
  Visual->Init2D();
  Visual->DrawBlock2D();
  Block->VisualTMUtracks2D(Visual, 10);
  Block->VisualTMUcandidates2D(Visual, 10);
  Visual->DrawStats2D(-1, 1, 2, 10);
  delete Visual;

  ///////////////////////////////////////////////////////////////////
  //  Leave Global Tracking Unit                                   //
  ///////////////////////////////////////////////////////////////////

  delete GTU;
}
