void AliTRDgtuStatistic() 
{

/////////////////////////////////////////////////////////////////////////
//
// Do some statistics with AliTRDgtuStatistic module
//
/////////////////////////////////////////////////////////////////////////

  Char_t *alifile = "~schneide/data/galice_nh.root";

  // Dynamically link some shared libs
  if (gClassTable->GetID("AliRun") < 0) {
    gROOT->LoadMacro("loadlibs.C");
    loadlibs();
  }
  gSystem->Load("$(ALICE_ROOT)/lib/tgt_$(ALICE_TARGET)/libTRDgtu");

  // Event number
  Int_t   nEvent  = 0;

  // Connect the AliRoot file containing Geometry, Kine, Hits, and Digits
  TFile *gafl = (TFile*) gROOT->GetListOfFiles()->FindObject(alifile);
  if (!gafl) {
    cout << "Open the ALIROOT-file " << alifile << endl;
    gafl = new TFile(alifile);
  }
  else {
    cout << alifile << " is already open" << endl;
  }

  // Get AliRun object from file or create it if not on file
  gAlice = (AliRun*) gafl->Get("gAlice");
  if (gAlice)  
    cout << "AliRun object found on file" << endl;
  else
    gAlice = new AliRun("gAlice","Alice test program");

  // Init AliTRDgtuStatistic
  Int_t iSec = 17;
  Int_t iCha = 2;
  Int_t iPla = 5;
  AliTRDgtuGlobal::TMUwl = 2;
  AliTRDgtuStatistic *stat = new AliTRDgtuStatistic(gAlice);
  stat->SetSectorRange(iSec, iSec);
  stat->SetChamberRange(iCha, iCha);
  stat->SetPlaneRange(iPla, iPla);
  AliTRDgeometry *fGeo = stat->GetTRDgeometry();
  Int_t cDet = fGeo->GetDetector(iPla, iCha, iSec);

  // Do some statistics
  cout << endl;
  printf("Geometry Version is %d\n", fGeo->IsVersion());
  stat->OutputGeometry(iPla, iCha, iSec);

  Int_t CurrParticle = 887;
  Float_t gpos1[3], gpos2[3];
  Float_t lpos1[3], lpos2[3];

  stat->GetParticlePos(CurrParticle, cDet, gpos1, gpos2, lpos1, lpos2);

  printf("Global Position : (%5.2f, %5.2f, %5.2f) -> (%5.2f, %5.2f, %5.2f)\n", gpos1[0], gpos1[1], gpos1[2], gpos2[0], gpos2[1], gpos2[2]);
  printf("Local Position  : (%5.2f, %5.2f, %5.2f) -> (%5.2f, %5.2f, %5.2f)\n", lpos1[0], lpos1[1], lpos1[2], lpos2[0], lpos2[1], lpos2[2]);

  // end
  cout << endl;
  cout << "--------------------------------------------------------" << endl;
  gafl->Close();
  delete gafl;
  delete stat;
  cout << "BYE." << endl << endl;
}
