void Test() {
  gROOT->Reset();
  gSystem->Load("$(ALICE_ROOT)/lib/tgt_$(ALICE_TARGET)/libTRDgtu");

  TFile *fp = new TFile("testfile.root", "RECREATE", "this is just a test");
  if(!fp->IsOpen()) {
    printf("ERROR: cannot open file\n");
    exit(1);
  }

  TTree *trackdata = new TTree("T", "track data");
 
  TClonesArray *testarr = new TClonesArray("AliTRDgtuRealTrack",2);

  TClonesArray &testarr_tmp = *testarr;
  new(testarr_tmp[0]) AliTRDgtuRealTrack(1, 2, 3);
  new(testarr_tmp[1]) AliTRDgtuRealTrack(3, 2, 1);

  printf("entries: %d\n", testarr->GetEntries());
  TObject *testobj = (AliTRDgtuRealTrack *)testarr->At(1);
  testobj->Dump();

  trackdata->Branch("AliTRDgtuRealTrack", &testarr);
  trackdata->Fill();

  fp->Write();
  fp->Close();
  testarr->Delete();
  delete testarr;
  delete fp;
}
