Int_t LCRsum(Int_t ampL, Int_t ampC, Int_t ampR)
{
  return(ampL + ampC + ampR);
}

Int_t RLdiff(Int_t ampR, Int_t ampL)
{
  return(ampR - ampL);
}


Double_t dYdL(Int_t ampL, Int_t ampC, Int_t ampR)
{
  Double_t sum  = LCRsum(ampL, ampC, ampR);
  Double_t diff = RLdiff(ampR, ampL);

  return((-sum+diff)/(sum*sum));
}

Double_t dYdR(Int_t ampL, Int_t ampC, Int_t ampR)
{
  Double_t sum  = LCRsum(ampL, ampC, ampR);
  Double_t diff = RLdiff(ampR, ampL);

  return((sum+diff)/(sum*sum));
}

Double_t dYdC(Int_t ampL, Int_t ampC, Int_t ampR)
{
  Double_t sum  = LCRsum(ampL, ampC, ampR);
  Double_t diff = RLdiff(ampR, ampL);

  return(diff/(sum*sum));
}

//__________________________________________________________________
void yi_error()
{
  const Double_t DELTA_LCR = 1.0;

  const Int_t ampCmin = 1;
  const Int_t ampCmax = 255;
  Int_t ampL = 0;
  Int_t ampR = 0;

  printf("*** delta ampL,ampC,ampR = %f\n", DELTA_LCR);

  c1 = new TCanvas("c1","c1",200,10,600,400);
  c1->SetGrid();
  TH1F *h1 = new TH1F("h1", "mittlerer Positionsfehler vs. ampC (ampL, ampR je 10% ampC)", 255, 1, 255);
  h1->SetXTitle("amplitude"); h1->SetYTitle("[um]");

  for(Int_t ampC=ampCmin; ampC<=ampCmax; ampC++) {
    ampL = ampR = (Int_t)(((10.0 * (Double_t)ampC)/100.0) + 0.5);
    Double_t dYdL  = dYdL(ampL, ampC, ampR);
    Double_t dYdC  = dYdC(ampL, ampC, ampR);
    Double_t dYdR  = dYdR(ampL, ampC, ampR);
    Double_t dYdLd = dYdL*DELTA_LCR;
    Double_t dYdCd = dYdC*DELTA_LCR;
    Double_t dYdRd = dYdR*DELTA_LCR;
    Double_t dY = TMath::Sqrt((dYdLd*dYdLd) + (dYdCd*dYdCd) + (dYdRd*dYdRd));
    h1->Fill(ampC, dY*10.0*1000.0);
  }

  c1->cd();
  gPad->SetLogx();
  gPad->SetLogy();
  h1->SetLineWidth(2);
  h1->Draw();

}
