void AliTRDhit()
{
  gROOT->LoadMacro("getDigitsManagerG.C");
  gROOT->LoadMacro("dialogs.C");

  gSystem->Load("$(ALICE_ROOT)/lib/tgt_$(ALICE_TARGET)/libTRDgtu");
  gSystem->Load("$(ALICE_ROOT)/lib/tgt_$(ALICE_TARGET)/libTRDfit");

  cout << endl;
  cout << "////////////////////////////////////////////////////////" << endl;
  cout << "//                                                    //" << endl;
  cout << "//  ALIROOT AliTRDstatistic GENERATION                //" << endl;
  cout << "//                                                    //" << endl;
  cout << "////////////////////////////////////////////////////////" << endl << endl;

  ////// CONSTANTS //////
  const Char_t *alifile     = "/home/schneide/data/galice.root";
  const Int_t   iSec        = 13;
  const Int_t   iCha        = 2;
  const Int_t   iDefaultRow = 1;
  const Int_t   iOffMax     = 128;
  const Int_t   iAngMax     = 256;

  ////// READ ALIROOT FILE //////
  cout << endl;
  cout << "--------------------------------------------------------" << endl;
  cout << "--  GET DIGITS FROM ALIROOT EVENT FILE                --" << endl;
  cout << "--------------------------------------------------------" << endl << endl;
  AliRun *gAlice = NULL;
  AliTRDdigitsManager *DigitsManager;
  AliTRDv1 *TRD;
  TClonesArray *ParticleArray;
  AliTRDgeometry *TRDgeometry;
  if(!(getDigitsManagerG(alifile, &gAlice, &DigitsManager, &TRD, &ParticleArray))) {
    cout << "ERROR: cannot get DigitsManager" << endl;
    break;
  }
  TRDgeometry = TRD->GetGeometry();

  ////// INITIALIZE ENVIRONMENT //////
  cout << endl;
  cout << "--------------------------------------------------------" << endl;
  cout << "--  INITIALIZE SIMULATION ENVIRONMENT                 --" << endl;
  cout << "--------------------------------------------------------" << endl << endl;

  cout << "*** Geometry" << endl << endl;
  cout << "Current Block    : Sector " << iSec << "; Chamber " << iCha << endl;
  for(Int_t plane = 0; plane < 6; plane++) {
    Int_t colMax  = TRDgeometry->GetColMax(plane);
    Int_t rowMax  = TRDgeometry->GetRowMax(0,iCha,iSec);
    Int_t timeMax = TRDgeometry->GetTimeMax();
    printf("Geometry plane %d : Columns %3d; Rows %2d; Timebins %2d\n", plane, colMax, rowMax, timeMax);
  }
  cout << endl << "*** Hits" << endl << endl;
  cout << gAlice << endl;
  printf("%d\n", gAlice->TreeH()->GetEntries());


  ////// FINISHED //////
  cout << endl;
  cout << "--------------------------------------------------------" << endl;
  cout << "BYE." << endl << endl;
}
