/*
$Log: defl.C,v $
Revision 1.4  2001/04/02 14:51:38  schneide
Use of global header file for fit settings

*/

#include "../global.h"

#define MODULE "defl"

void defl()
{
  Char_t TitleString[120];
  sprintf(TitleString, "AliTRDnh_%s (%s, %s)", MODULE, CONFIGURATION, DATE);

  TStyle *mystyle = new TStyle("Default", "Default Style");
  Int_t ncolors = 1;
  Int_t *colors = NULL;
  mystyle->SetPalette(ncolors, colors);
  mystyle->cd();

  TCanvas *c1 = new TCanvas("c1", "Config_bv.C", 100, 10, 600, 400); c1->Draw();
  TPad *ptitle1 = new TPad("ptitle1", "ptitle1", 0.01, 0.95, 0.99, 0.99); ptitle1->Draw();
  ptitle1->cd(); TPaveLabel *pltitle1 = new TPaveLabel(0.0, 0.0, 1.0, 1.0, TitleString); pltitle1->Draw();
  c1->cd(); TPad *phisto1 = new TPad("phisto1", "phisto1", 0.01, 0.01, 0.99, 0.94);
  phisto1->Draw(); phisto1->Divide(1,1);

  TFile *fp = new TFile("./histo_defl.root");

  phisto1->cd(1); gPad->SetLogy();
  TH1F *h0_1_1 = new TH1F();
  h0_1_1->Read("h0_1_1");
  TH1F *h1_1_1 = new TH1F();
  h1_1_1->Read("h1_1_1");
  TH1F *h1_1_2 = new TH1F();
  h1_1_2->Read("h1_1_2");
  TH1F *h1_1_3 = new TH1F();
  h1_1_3->Read("h1_1_3");
  TH1F *h1_1_4 = new TH1F();
  h1_1_4->Read("h1_1_4");
  TH1F *h1_1_5 = new TH1F();
  h1_1_5->Read("h1_1_5");
  h0_1_1->SetLineWidth(3); h0_1_1->SetLineColor(1); h0_1_1->SetStats(FALSE); h0_1_1->Draw();
  h1_1_1->SetLineWidth(3); h1_1_1->SetLineColor(2); h1_1_1->SetStats(FALSE); h1_1_1->Draw("same");
  h1_1_2->SetLineWidth(3); h1_1_2->SetLineColor(4); h1_1_2->SetStats(FALSE); h1_1_2->Draw("same");
  h1_1_3->SetLineWidth(3); h1_1_3->SetLineColor(6); h1_1_3->SetStats(FALSE); h1_1_3->Draw("same");
  h1_1_4->SetLineWidth(3); h1_1_4->SetLineColor(8); h1_1_4->SetStats(FALSE); h1_1_4->Draw("same");
  h1_1_5->SetLineWidth(3); h1_1_5->SetLineColor(7); h1_1_5->SetStats(FALSE); h1_1_5->Draw("same");
  c1->SaveAs("./sim_results/sim_defl_h1_1_1.ps");
  c1->SaveAs("./sim_results/sim_defl_h1_1_1.gif");
  delete h0_1_1;
  delete h1_1_1;
  delete h1_1_2;
  delete h1_1_3;
  delete h1_1_4;
  delete h1_1_5;

  phisto1->cd(1); gPad->SetLogy(FALSE);
  TH1F *h2_1_1 = new TH1F();
  h2_1_1->Read("h2_1_1");
  TH1F *h2_1_2 = new TH1F();
  h2_1_2->Read("h2_1_2");
  TH1F *h2_1_3 = new TH1F();
  h2_1_3->Read("h2_1_3");
  TH1F *h2_1_4 = new TH1F();
  h2_1_4->Read("h2_1_4");
  TH1F *h2_1_5 = new TH1F();
  h2_1_5->Read("h2_1_5");
  h2_1_1->SetLineWidth(3); h2_1_1->SetLineColor(2); h2_1_1->SetStats(FALSE); h2_1_1->Draw();
  h2_1_2->SetLineWidth(3); h2_1_2->SetLineColor(4); h2_1_2->SetStats(FALSE); h2_1_2->Draw("same");
  h2_1_3->SetLineWidth(3); h2_1_3->SetLineColor(6); h2_1_3->SetStats(FALSE); h2_1_3->Draw("same");
  h2_1_4->SetLineWidth(3); h2_1_4->SetLineColor(8); h2_1_4->SetStats(FALSE); h2_1_4->Draw("same");
  h2_1_5->SetLineWidth(3); h2_1_5->SetLineColor(7); h2_1_5->SetStats(FALSE); h2_1_5->Draw("same");
  c1->SaveAs("./sim_results/sim_defl_h2_1_1.ps");
  c1->SaveAs("./sim_results/sim_defl_h2_1_1.gif");
  delete h2_1_1;
  delete h2_1_2;
  delete h2_1_3;
  delete h2_1_4;
  delete h2_1_5;

  phisto1->cd(1); gPad->SetLogy(FALSE);
  TH1F *h3_1_1 = new TH1F();
  h3_1_1->Read("h3_1_1");
  TH1F *h3_1_2 = new TH1F();
  h3_1_2->Read("h3_1_2");
  TH1F *h3_1_3 = new TH1F();
  h3_1_3->Read("h3_1_3");
  TH1F *h3_1_4 = new TH1F();
  h3_1_4->Read("h3_1_4");
  TH1F *h3_1_5 = new TH1F();
  h3_1_5->Read("h3_1_5");
  TH1F *h3_1_6 = new TH1F();
  h3_1_6->Read("h3_1_6");
  h3_1_1->SetLineWidth(1); h3_1_1->SetLineColor(2); h3_1_1->SetStats(FALSE); h3_1_1->Draw();
  h3_1_2->SetLineWidth(1); h3_1_2->SetLineColor(4); h3_1_2->SetStats(FALSE); h3_1_2->Draw("same");
  h3_1_3->SetLineWidth(1); h3_1_3->SetLineColor(6); h3_1_3->SetStats(FALSE); h3_1_3->Draw("same");
  h3_1_4->SetLineWidth(1); h3_1_4->SetLineColor(8); h3_1_4->SetStats(FALSE); h3_1_4->Draw("same");
  h3_1_5->SetLineWidth(1); h3_1_5->SetLineColor(7); h3_1_5->SetStats(FALSE); h3_1_5->Draw("same");
  h3_1_6->SetLineWidth(1); h3_1_6->SetLineColor(1); h3_1_6->SetStats(FALSE); h3_1_6->Draw("same");
  c1->SaveAs("./sim_results/sim_defl_h3_1_1.ps");
  c1->SaveAs("./sim_results/sim_defl_h3_1_1.gif");
  delete h3_1_1;
  delete h3_1_2;
  delete h3_1_3;
  delete h3_1_4;
  delete h3_1_5;
  delete h3_1_6;

  phisto1->cd(1); gPad->SetLogy(FALSE);
  TH1F *h4_1_1 = new TH1F();
  h4_1_1->Read("h4_1_1");
  TH1F *h4_1_2 = new TH1F();
  h4_1_2->Read("h4_1_2");
  TH1F *h4_1_3 = new TH1F();
  h4_1_3->Read("h4_1_3");
  TH1F *h4_1_4 = new TH1F();
  h4_1_4->Read("h4_1_4");
  TH1F *h4_1_5 = new TH1F();
  h4_1_5->Read("h4_1_5");
  h4_1_5->SetLineWidth(3); h4_1_5->SetLineColor(7); h4_1_5->SetStats(FALSE); h4_1_5->Draw();
  h4_1_4->SetLineWidth(3); h4_1_4->SetLineColor(8); h4_1_4->SetStats(FALSE); h4_1_4->Draw("same");
  h4_1_3->SetLineWidth(3); h4_1_3->SetLineColor(6); h4_1_3->SetStats(FALSE); h4_1_3->Draw("same");
  h4_1_2->SetLineWidth(3); h4_1_2->SetLineColor(4); h4_1_2->SetStats(FALSE); h4_1_2->Draw("same");
  h4_1_1->SetLineWidth(3); h4_1_1->SetLineColor(2); h4_1_1->SetStats(FALSE); h4_1_1->Draw("same");
  c1->SaveAs("./sim_results/sim_defl_h4_1_1.ps");
  c1->SaveAs("./sim_results/sim_defl_h4_1_1.gif");
  delete h4_1_1;
  delete h4_1_2;
  delete h4_1_3;
  delete h4_1_4;
  delete h4_1_5;

  phisto1->cd(1); gPad->SetLogy(FALSE);
  TH1F *h5_1_1 = new TH1F();
  h5_1_1->Read("h5_1_1");
  TH1F *h5_1_2 = new TH1F();
  h5_1_2->Read("h5_1_2");
  TH1F *h5_1_3 = new TH1F();
  h5_1_3->Read("h5_1_3");
  TH1F *h5_1_4 = new TH1F();
  h5_1_4->Read("h5_1_4");
  TH1F *h5_1_5 = new TH1F();
  h5_1_5->Read("h5_1_5");
  h5_1_5->SetLineWidth(1); h5_1_5->SetLineColor(7); h5_1_5->SetStats(FALSE); h5_1_5->Draw();
  h5_1_4->SetLineWidth(1); h5_1_4->SetLineColor(8); h5_1_4->SetStats(FALSE); h5_1_4->Draw("same");
  h5_1_3->SetLineWidth(1); h5_1_3->SetLineColor(6); h5_1_3->SetStats(FALSE); h5_1_3->Draw("same");
  h5_1_2->SetLineWidth(1); h5_1_2->SetLineColor(4); h5_1_2->SetStats(FALSE); h5_1_2->Draw("same");
  h5_1_1->SetLineWidth(1); h5_1_1->SetLineColor(2); h5_1_1->SetStats(FALSE); h5_1_1->Draw("same");
  c1->SaveAs("./sim_results/sim_defl_h5_1_1.ps");
  c1->SaveAs("./sim_results/sim_defl_h5_1_1.gif");
  delete h5_1_1;
  delete h5_1_2;
  delete h5_1_3;
  delete h5_1_4;
  delete h5_1_5;

  delete c1;
}
