/*
$Log: gen.C,v $
Revision 1.3  2001/04/02 14:51:39  schneide
Use of global header file for fit settings

*/

#include "../global.h"

#define MODULE "gen"

void gen()
{
  Char_t TitleString[120];
  sprintf(TitleString, "AliTRDnh_%s (%s, %s)", MODULE, CONFIGURATION, DATE);

  TStyle *mystyle = new TStyle("Default", "Default Style");
  Int_t ncolors = 1;
  Int_t *colors = NULL;
  mystyle->SetPalette(ncolors, colors);
  mystyle->cd();

  TCanvas *c1 = new TCanvas("c1", "Config_bv.C", 100, 10, 600, 400); c1->Draw();
  TPad *ptitle1 = new TPad("ptitle1", "ptitle1", 0.01, 0.95, 0.99, 0.99); ptitle1->Draw();
  ptitle1->cd(); TPaveLabel *pltitle1 = new TPaveLabel(0.0, 0.0, 1.0, 1.0, TitleString); pltitle1->Draw();
  c1->cd(); TPad *phisto1 = new TPad("phisto1", "phisto1", 0.01, 0.01, 0.99, 0.94);
  phisto1->Draw(); phisto1->Divide(1,1);

  TFile *fp = new TFile("./histo_gen.root");

  cout << "generate h1_1 ..." << endl;
  phisto1->cd(1);
  TH1F *h1_1 = new TH1F();
  h1_1->Read("h1_1");
  TH1F *h1_2 = new TH1F();
  h1_2->Read("h1_2");
  TH1F *h1_3 = new TH1F();
  h1_3->Read("h1_3");
  h1_1->SetLineWidth(3); h1_1->SetLineColor(2); h1_1->Draw();
  h1_2->SetLineWidth(3); h1_2->SetLineColor(4); h1_2->Draw("same");
  h1_3->SetLineWidth(3); h1_3->SetLineColor(8); h1_3->Draw("same");
  c1->SaveAs("./sim_results/sim_gen_h1_1.ps");
  c1->SaveAs("./sim_results/sim_gen_h1_1.gif");
  delete h1_1;
  delete h1_2;
  delete h1_3;

  cout << "generate h1_4 ..." << endl;
  phisto1->cd(1);
  TH1F *h1_4 = new TH1F();
  h1_4->Read("h1_4");
  TH1F *h1_5 = new TH1F();
  h1_5->Read("h1_5");
  TH1F *h1_6 = new TH1F();
  h1_6->Read("h1_6");
  h1_4->SetLineWidth(3); h1_4->SetLineColor(2); h1_4->Draw();
  h1_5->SetLineWidth(3); h1_5->SetLineColor(4); h1_5->Draw("same");
  h1_6->SetLineWidth(3); h1_6->SetLineColor(8); h1_6->Draw("same");
  c1->SaveAs("./sim_results/sim_gen_h1_4.ps");
  c1->SaveAs("./sim_results/sim_gen_h1_4.gif");
  delete h1_4;
  delete h1_5;
  delete h1_6;

  cout << "generate h1_7 ..." << endl;
  phisto1->cd(1);
  TH2F *h1_7 = new TH2F();
  h1_7->Read("h1_7");
  h1_7->Draw("colz");
  c1->SaveAs("./sim_results/sim_gen_h1_7.ps");
  c1->SaveAs("./sim_results/sim_gen_h1_7.gif");
  delete h1_7;

  cout << "generate h1_8 ..." << endl;
  phisto1->cd(1);
  TH2F *h1_8 = new TH2F();
  h1_8->Read("h1_8");
  h1_8->Draw("colz");
  c1->SaveAs("./sim_results/sim_gen_h1_8.ps");
  c1->SaveAs("./sim_results/sim_gen_h1_8.gif");
  delete h1_8;

  cout << "generate h1_10 ..." << endl;
  phisto1->cd(1); gPad->SetLogy();
  TH1F *h1_10 = new TH1F();
  h1_10->Read("h1_10");
  TH1F *h1_11 = new TH1F();
  h1_11->Read("h1_11");
  TH1F *h1_12 = new TH1F();
  h1_12->Read("h1_12");
  h1_10->SetLineWidth(3); h1_10->SetLineColor(2); h1_10->Draw();
  h1_11->SetLineWidth(3); h1_11->SetLineColor(4); h1_11->Draw("same");
  h1_12->SetLineWidth(3); h1_12->SetLineColor(8); h1_12->Draw("same");
  c1->SaveAs("./sim_results/sim_gen_h1_10.ps");
  c1->SaveAs("./sim_results/sim_gen_h1_10.gif");
  delete h1_10;
  delete h1_11;
  delete h1_12;

  cout << "generate h1_13 ..." << endl;
  phisto1->cd(1); gPad->SetLogy();
  TH1F *h1_13 = new TH1F();
  h1_13->Read("h1_13");
  TH1F *h1_14 = new TH1F();
  h1_14->Read("h1_14");
  TH1F *h1_15 = new TH1F();
  h1_15->Read("h1_15");
  h1_13->SetLineWidth(3); h1_13->SetLineColor(2); h1_13->Draw();
  h1_14->SetLineWidth(3); h1_14->SetLineColor(4); h1_14->Draw("same");
  h1_15->SetLineWidth(3); h1_15->SetLineColor(8); h1_15->Draw("same");
  c1->SaveAs("./sim_results/sim_gen_h1_13.ps");
  c1->SaveAs("./sim_results/sim_gen_h1_13.gif");
  delete h1_13;
  delete h1_14;
  delete h1_15;

  cout << "generate h2_1 ..." << endl;
  phisto1->cd(1); gPad->SetLogy(FALSE);
  TH2F *h2_1 = new TH2F();
  h2_1->Read("h2_1");
  h2_1->Draw("colz");
  c1->SaveAs("./sim_results/sim_gen_h2_1.ps");
  c1->SaveAs("./sim_results/sim_gen_h2_1.gif");
  delete h2_1;

  cout << "generate h2_2 ..." << endl;
  phisto1->cd(1);
  TH2F *h2_2 = new TH2F();
  h2_2->Read("h2_2");
  h2_2->Draw("colz");
  c1->SaveAs("./sim_results/sim_gen_h2_2.ps");
  c1->SaveAs("./sim_results/sim_gen_h2_2.gif");
  delete h2_2;

  cout << "generate h2_3 ..." << endl;
  phisto1->cd(1);
  TH2F *h2_3 = new TH2F();
  h2_3->Read("h2_3");
  h2_3->Draw("colz");
  c1->SaveAs("./sim_results/sim_gen_h2_3.ps");
  c1->SaveAs("./sim_results/sim_gen_h2_3.gif");
  delete h2_3;

  cout << "generate h2_4 ..." << endl;
  phisto1->cd(1);
  TH2F *h2_4 = new TH2F();
  h2_4->Read("h2_4");
  h2_4->Draw("colz");
  c1->SaveAs("./sim_results/sim_gen_h2_4.ps");
  c1->SaveAs("./sim_results/sim_gen_h2_4.gif");
  delete h2_4;

  cout << "generate h2_5 ..." << endl;
  phisto1->cd(1);
  TH2F *h2_5 = new TH2F();
  h2_5->Read("h2_5");
  h2_5->Draw("colz");
  c1->SaveAs("./sim_results/sim_gen_h2_5.ps");
  c1->SaveAs("./sim_results/sim_gen_h2_5.gif");
  delete h2_5;

  cout << "generate h2_6 ..." << endl;
  phisto1->cd(1);
  TH2F *h2_6 = new TH2F();
  h2_6->Read("h2_6");
  h2_6->Draw("colz");
  c1->SaveAs("./sim_results/sim_gen_h2_6.ps");
  c1->SaveAs("./sim_results/sim_gen_h2_6.gif");
  delete h2_6;

  cout << "generate h2_9 ..." << endl;
  phisto1->cd(1);
  TH1F *h2_9 = new TH1F();
  h2_9->Read("h2_9");
  TH1F *h2_10 = new TH1F();
  h2_10->Read("h2_10");
  h2_9->SetLineWidth(3); h2_9->SetLineColor(2); h2_9->Draw();
  h2_10->SetLineWidth(3); h2_10->SetLineColor(4); h2_10->Draw("same");
  c1->SaveAs("./sim_results/sim_gen_h2_9.ps");
  c1->SaveAs("./sim_results/sim_gen_h2_9.gif");
  delete h2_9;
  delete h2_10;

  cout << "generate h2_11 ..." << endl;
  phisto1->cd(1);
  TH1F *h2_11 = new TH1F();
  h2_11->Read("h2_11");
  TH1F *h2_12 = new TH1F();
  h2_12->Read("h2_12");
  h2_12->SetLineWidth(3); h2_12->SetLineColor(4); h2_12->Draw();
  h2_11->SetLineWidth(3); h2_11->SetLineColor(2);  h2_11->Draw("same");
  c1->SaveAs("./sim_results/sim_gen_h2_11.ps");
  c1->SaveAs("./sim_results/sim_gen_h2_11.gif");
  delete h2_11;
  delete h2_12;

  cout << "generate h2_13 ..." << endl;
  phisto1->cd(1);
  TH1F *h2_13 = new TH1F();
  h2_13->Read("h2_13");
  TH1F *h2_14 = new TH1F();
  h2_14->Read("h2_14");
  h2_14->SetLineWidth(3); h2_14->SetLineColor(4); h2_14->Draw();
  h2_13->SetLineWidth(3); h2_13->SetLineColor(2); h2_13->Draw("same");
  c1->SaveAs("./sim_results/sim_gen_h2_13.ps");
  c1->SaveAs("./sim_results/sim_gen_h2_13.gif");
  delete h2_13;
  delete h2_14;

  delete c1;
}
