/*
$Log: pt.C,v $
Revision 1.3  2001/04/02 14:51:39  schneide
Use of global header file for fit settings

*/

#include "../global.h"

#define MODULE "pt"

void pt()
{
  Char_t TitleString[120];
  sprintf(TitleString, "AliTRDnh_%s (%s, %s)", MODULE, CONFIGURATION, DATE);

  TStyle *mystyle = new TStyle("Default", "Default Style");
  Int_t ncolors = 1;
  Int_t *colors = NULL;
  mystyle->SetPalette(ncolors, colors);
  mystyle->cd();

  TCanvas *c1 = new TCanvas("c1", "Config_bv.C", 100, 10, 600, 400); c1->Draw();
  TPad *ptitle1 = new TPad("ptitle1", "ptitle1", 0.01, 0.95, 0.99, 0.99); ptitle1->Draw();
  ptitle1->cd(); TPaveLabel *pltitle1 = new TPaveLabel(0.0, 0.0, 1.0, 1.0, TitleString); pltitle1->Draw();
  c1->cd(); TPad *phisto1 = new TPad("phisto1", "phisto1", 0.01, 0.01, 0.99, 0.94);
  phisto1->Draw(); phisto1->Divide(1,1);

  TFile *fp = new TFile("./histo_pt.root");

  phisto1->cd(1); gPad->SetLogy();
  TH1F *h1_1 = new TH1F();
  h1_1->Read("h1_1");
  h1_1->SetLineWidth(3); h1_1->SetLineColor(2); h1_1->Draw();
  c1->SaveAs("./sim_results/sim_pt_h1_1.ps");
  c1->SaveAs("./sim_results/sim_pt_h1_1.gif");
  delete h1_1;

  phisto1->cd(1);
  TH1F *h1_2 = new TH1F();
  h1_2->Read("h1_2");
  h1_2->SetLineWidth(3); h1_2->SetLineColor(2); h1_2->Draw();
  c1->SaveAs("./sim_results/sim_pt_h1_2.ps");
  c1->SaveAs("./sim_results/sim_pt_h1_2.gif");
  delete h1_2;

  phisto1->cd(1);
  TH1F *h1_3 = new TH1F();
  h1_3->Read("h1_3");
  h1_3->SetLineWidth(3); h1_3->SetLineColor(2); h1_3->Draw();
  c1->SaveAs("./sim_results/sim_pt_h1_3.ps");
  c1->SaveAs("./sim_results/sim_pt_h1_3.gif");
  delete h1_3;

  phisto1->cd(1); gPad->SetLogy(FALSE);
  TH2F *h1_4 = new TH2F();
  h1_4->Read("h1_4");
  h1_4->Draw("colz");
  c1->SaveAs("./sim_results/sim_pt_h1_4.ps");
  c1->SaveAs("./sim_results/sim_pt_h1_4.gif");
  delete h1_4;

  phisto1->cd(1);
  TH2F *h1_5 = new TH2F();
  h1_5->Read("h1_5");
  h1_5->Draw("colz");
  c1->SaveAs("./sim_results/sim_pt_h1_5.ps");
  c1->SaveAs("./sim_results/sim_pt_h1_5.gif");
  delete h1_5;

  phisto1->cd(1);
  TH2F *h1_6 = new TH2F();
  h1_6->Read("h1_6");
  h1_6->Draw("colz");
  c1->SaveAs("./sim_results/sim_pt_h1_6.ps");
  c1->SaveAs("./sim_results/sim_pt_h1_6.gif");
  delete h1_6;

  delete c1;
}
