/*
$Log: realhist.C,v $
Revision 1.3  2001/04/02 14:51:39  schneide
Use of global header file for fit settings

*/

#include "../global.h"

#define MODULE "realhist"

void realhist()
{
  Char_t TitleString[120];
  sprintf(TitleString, "AliTRDnh_%s (%s, %s)", MODULE, CONFIGURATION, DATE);

  TStyle *mystyle = new TStyle("Default", "Default Style");
  Int_t ncolors = 1;
  Int_t *colors = NULL;
  mystyle->SetPalette(ncolors, colors);
  mystyle->cd();

  TCanvas *c1 = new TCanvas("c1", "Config_bv.C", 100, 10, 600, 400); c1->Draw();
  TPad *ptitle1 = new TPad("ptitle1", "ptitle1", 0.01, 0.95, 0.99, 0.99); ptitle1->Draw();
  ptitle1->cd(); TPaveLabel *pltitle1 = new TPaveLabel(0.0, 0.0, 1.0, 1.0, TitleString); pltitle1->Draw();
  c1->cd(); TPad *phisto1 = new TPad("phisto1", "phisto1", 0.01, 0.01, 0.99, 0.94);
  phisto1->Draw(); phisto1->Divide(1,1);

  TFile *fp = new TFile("./histo_realhist.root");

  phisto1->cd(1);
  TH1F *h1_1 = new TH1F();
  h1_1->Read("h1_1");
  TH1F *h1_2 = new TH1F();
  h1_2->Read("h1_2");
  h1_1->SetLineWidth(3); h1_1->SetLineColor(2); h1_1->SetStats(FALSE); h1_1->Draw();
  h1_2->SetLineWidth(3); h1_2->SetLineColor(4); h1_2->SetStats(FALSE); h1_2->Draw("same");
  c1->SaveAs("./sim_results/sim_realhist_h1_1.ps");
  c1->SaveAs("./sim_results/sim_realhist_h1_1.gif");
  delete h1_2;
  delete h1_1;

  phisto1->cd(1);
  TH1F *h1_5 = new TH1F();
  h1_5->Read("h1_5");
  TH1F *h1_6 = new TH1F();
  h1_6->Read("h1_6");
  h1_5->SetLineWidth(3); h1_5->SetLineColor(2); h1_5->SetStats(FALSE); h1_5->Draw();
  h1_6->SetLineWidth(3); h1_6->SetLineColor(4); h1_6->SetStats(FALSE); h1_6->Draw("same");
  c1->SaveAs("./sim_results/sim_realhist_h1_5.ps");
  c1->SaveAs("./sim_results/sim_realhist_h1_5.gif");
  delete h1_5;
  delete h1_6;

  phisto1->cd(1);
  TH2F *h1_7 = new TH2F();
  h1_7->Read("h1_7");
  h1_7->Draw("colz");
  c1->SaveAs("./sim_results/sim_realhist_h1_7.ps");
  c1->SaveAs("./sim_results/sim_realhist_h1_7.gif");
  delete h1_7;

  phisto1->cd(1);
  TH2F *h1_8 = new TH2F();
  h1_8->Read("h1_8");
  h1_8->Draw("colz");
  c1->SaveAs("./sim_results/sim_realhist_h1_8.ps");
  c1->SaveAs("./sim_results/sim_realhist_h1_8.gif");
  delete h1_8;

  phisto1->cd(1);
  TH1F *h2_1 = new TH1F();
  h2_1->Read("h2_1");
  h2_1->SetLineWidth(3); h2_1->Draw();
  c1->SaveAs("./sim_results/sim_realhist_h2_1.ps");
  c1->SaveAs("./sim_results/sim_realhist_h2_1.gif");
  delete h2_1;

  phisto1->cd(1);
  TH1F *h2_2 = new TH1F();
  h2_2->Read("h2_2");
  TH1F *h2_3 = new TH1F();
  h2_3->Read("h2_3");
  TH1F *h2_4 = new TH1F();
  h2_4->Read("h2_4");
  h2_2->SetLineWidth(3); h2_2->SetLineColor(2); h2_2->SetStats(FALSE); h2_2->Draw();
  h2_3->SetLineWidth(3); h2_3->SetLineColor(4); h2_3->SetStats(FALSE); h2_3->Draw("same");
  h2_4->SetLineWidth(3); h2_4->SetLineColor(6); h2_4->SetStats(FALSE); h2_4->Draw("same");
  c1->SaveAs("./sim_results/sim_realhist_h2_2.ps");
  c1->SaveAs("./sim_results/sim_realhist_h2_2.gif");
  delete h2_2;
  delete h2_3;
  delete h2_4;

  delete c1;
}
