/*
$Log: res.C,v $
Revision 1.3  2001/04/02 14:51:39  schneide
Use of global header file for fit settings

*/

#include "../global.h"

#define MODULE "res"

void res()
{
  Char_t TitleString[120];
  sprintf(TitleString, "AliTRDnh_%s (%s, %s)", MODULE, CONFIGURATION, DATE);

  TStyle *mystyle = new TStyle("Default", "Default Style");
  Int_t ncolors = 1;
  Int_t *colors = NULL;
  mystyle->SetPalette(ncolors, colors);
  mystyle->cd();

  TCanvas *c1 = new TCanvas("c1", "Config_bv.C", 100, 10, 600, 400); c1->Draw();
  TPad *ptitle1 = new TPad("ptitle1", "ptitle1", 0.01, 0.95, 0.99, 0.99); ptitle1->Draw();
  ptitle1->cd(); TPaveLabel *pltitle1 = new TPaveLabel(0.0, 0.0, 1.0, 1.0, TitleString); pltitle1->Draw();
  c1->cd(); TPad *phisto1 = new TPad("phisto1", "phisto1", 0.01, 0.01, 0.99, 0.94);
  phisto1->Draw(); phisto1->Divide(1,1);

  TFile *fp = new TFile("./histo_res.root");

  phisto1->cd(1);
  TH2F *h1_1 = new TH2F();
  h1_1->Read("h1_1");
  h1_1->Draw("colz");
  c1->SaveAs("./sim_results/sim_res_h1_1.ps");
  c1->SaveAs("./sim_results/sim_res_h1_1.gif");
  delete h1_1;

  phisto1->cd(1);
  TH1F *h2_1 = new TH1F();
  h2_1->Read("h2_1");
  TH1F *h2_2 = new TH1F();
  h2_2->Read("h2_2");
  TH1F *h2_3 = new TH1F();
  h2_3->Read("h2_3");
  TH1F *h2_4 = new TH1F();
  h2_4->Read("h2_4");
  TH1F *h2_5 = new TH1F();
  h2_5->Read("h2_5");
  h2_1->SetLineColor(2); h2_1->SetLineWidth(2); h2_1->SetStats(FALSE); h2_1->Draw();
  h2_2->SetLineColor(3); h2_2->SetLineWidth(2); h2_2->SetStats(FALSE); h2_2->Draw("same");
  h2_3->SetLineColor(4); h2_3->SetLineWidth(2); h2_3->SetStats(FALSE); h2_3->Draw("same");
  h2_4->SetLineColor(6); h2_4->SetLineWidth(2); h2_4->SetStats(FALSE); h2_4->Draw("same");
  h2_5->SetLineColor(8); h2_5->SetLineWidth(2); h2_5->SetStats(FALSE); h2_5->Draw("same");
  Float_t max = h2_5->GetMaximum();
  Char_t text[80];
  TPaveText *tt0 = new TPaveText(1000, 0.9*max, 2500, 0.95*max); tt0->SetTextColor(2); sprintf(text, "TH = %d, RMS = %d", 0, (Int_t)h2_1->GetRMS()); tt0->AddText(text); tt0->Draw();
  TPaveText *tt1 = new TPaveText(1000, 0.85*max, 2500, 0.9*max); tt1->SetTextColor(3); sprintf(text, "TH = %d, RMS = %d", 5, (Int_t)h2_2->GetRMS()); tt1->AddText(text); tt1->Draw();
  TPaveText *tt2 = new TPaveText(1000, 0.8*max, 2500, 0.85*max); tt2->SetTextColor(4); sprintf(text, "TH = %d, RMS = %d", 10, (Int_t)h2_3->GetRMS()); tt2->AddText(text); tt2->Draw();
  TPaveText *tt3 = new TPaveText(1000, 0.75*max, 2500, 0.8*max); tt3->SetTextColor(6); sprintf(text, "TH = %d, RMS = %d", 15, (Int_t)h2_4->GetRMS()); tt3->AddText(text); tt3->Draw();
  TPaveText *tt4 = new TPaveText(1000, 0.7*max, 2500, 0.75*max); tt4->SetTextColor(8); sprintf(text, "TH = %d, RMS = %d", 20, (Int_t)h2_5->GetRMS()); tt4->AddText(text); tt4->Draw();
  c1->SaveAs("./sim_results/sim_res_h2_1.ps");
  c1->SaveAs("./sim_results/sim_res_h2_1.gif");
  delete h2_1;
  delete h2_2;
  delete h2_3;
  delete h2_4;
  delete h2_5;

  delete c1;
}
