/*
$Log: res3.C,v $
Revision 1.3  2001/04/02 14:51:39  schneide
Use of global header file for fit settings

*/

#include "../global.h"

#define MODULE "res3"

void res3()
{
  Char_t TitleString[120];
  sprintf(TitleString, "AliTRDnh_%s (%s, %s)", MODULE, CONFIGURATION, DATE);

  TStyle *mystyle = new TStyle("Default", "Default Style");
  Int_t ncolors = 1;
  Int_t *colors = NULL;
  mystyle->SetPalette(ncolors, colors);
  mystyle->cd();

  TCanvas *c1 = new TCanvas("c1", "Config_bv.C", 100, 10, 600, 400); c1->Draw();
  TPad *ptitle1 = new TPad("ptitle1", "ptitle1", 0.01, 0.95, 0.99, 0.99); ptitle1->Draw();
  ptitle1->cd(); TPaveLabel *pltitle1 = new TPaveLabel(0.0, 0.0, 1.0, 1.0, TitleString); pltitle1->Draw();
  c1->cd(); TPad *phisto1 = new TPad("phisto1", "phisto1", 0.01, 0.01, 0.99, 0.94);
  phisto1->Draw(); phisto1->Divide(1,1);

  TFile *fp = new TFile("./histo_res3.root");

  phisto1->cd(1);
  TH1F *h1_1 = new TH1F();
  h1_1->Read("h1_1");
  TH1F *h1_1_2 = new TH1F();
  h1_1_2->Read("h1_1_2");
  TH1F *h1_1_3 = new TH1F();
  h1_1_3->Read("h1_1_3");
  h1_1->SetLineWidth(2); h1_1->SetLineColor(2); h1_1->SetStats(FALSE); h1_1->Draw();
  h1_1_2->SetLineWidth(2); h1_1_2->SetLineColor(3); h1_1_2->SetStats(FALSE); h1_1_2->Draw("same");
  h1_1_3->SetLineWidth(2); h1_1_3->SetLineColor(4); h1_1_3->SetStats(FALSE); h1_1_3->Draw("same");
  char hstr[80];
  Float_t max = h1_1->GetMaximum();
  TPaveText *tt1 = new TPaveText(1.2, 0.8*max, 2.8, 0.9*max); tt1->SetTextColor(2); sprintf(hstr, "RMS = %f\n", h1_1->GetRMS()); tt1->AddText(hstr); tt1->Draw();
  TPaveText *tt2 = new TPaveText(1.2, 0.7*max, 2.8, 0.8*max); tt2->SetTextColor(3); sprintf(hstr, "RMS = %f\n", h1_1_2->GetRMS()); tt2->AddText(hstr); tt2->Draw();
  TPaveText *tt3 = new TPaveText(1.2, 0.6*max, 2.8, 0.7*max); tt3->SetTextColor(4); sprintf(hstr, "RMS = %f\n", h1_1_3->GetRMS()); tt3->AddText(hstr); tt3->Draw();
  c1->SaveAs("./sim_results/sim_res3_h1_1.ps");
  c1->SaveAs("./sim_results/sim_res3_h1_1.gif");
  delete h1_1;
  delete h1_1_2;
  delete h1_1_3;

  phisto1->cd(1);
  TH1F *h1_2 = new TH1F();
  h1_2->Read("h1_2");
  h1_2->SetLineWidth(3); h1_2->Draw();
  c1->SaveAs("./sim_results/sim_res3_h1_2.ps");
  c1->SaveAs("./sim_results/sim_res3_h1_2.gif");
  delete h1_2;

  phisto1->cd(1);
  TH1F *h1_3 = new TH1F();
  h1_3->Read("h1_3");
  h1_3->SetLineWidth(3); h1_3->Draw();
  c1->SaveAs("./sim_results/sim_res3_h1_3.ps");
  c1->SaveAs("./sim_results/sim_res3_h1_3.gif");
  delete h1_3;

  phisto1->cd(1);
  TH1F *h1_4 = new TH1F();
  h1_4->Read("h1_4");
  h1_4->SetLineWidth(3); h1_4->Draw();
  c1->SaveAs("./sim_results/sim_res3_h1_4.ps");
  c1->SaveAs("./sim_results/sim_res3_h1_4.gif");
  delete h1_4;

  phisto1->cd(1);
  TH1F *h1_5 = new TH1F();
  h1_5->Read("h1_5");
  h1_5->SetLineWidth(3); h1_5->Draw();
  c1->SaveAs("./sim_results/sim_res3_h1_5.ps");
  c1->SaveAs("./sim_results/sim_res3_h1_5.gif");
  delete h1_5;

  phisto1->cd(1);
  TH1F *h1_6 = new TH1F();
  h1_6->Read("h1_6");
  h1_6->SetLineWidth(3); h1_6->Draw();
  c1->SaveAs("./sim_results/sim_res3_h1_6.ps");
  c1->SaveAs("./sim_results/sim_res3_h1_6.gif");
  delete h1_6;

  phisto1->cd(1);
  TH1F *h1_7 = new TH1F();
  h1_7->Read("h1_7");
  h1_7->SetLineWidth(3); h1_7->Draw();
  c1->SaveAs("./sim_results/sim_res3_h1_7.ps");
  c1->SaveAs("./sim_results/sim_res3_h1_7.gif");
  delete h1_7;

  phisto1->cd(1);
  TH1F *h1_8 = new TH1F();
  h1_8->Read("h1_8");
  TH1F *h1_8_2 = new TH1F();
  h1_8_2->Read("h1_8_2");
  TH1F *h1_8_3 = new TH1F();
  h1_8_3->Read("h1_8_3");
  TH1F *h1_8_4 = new TH1F();
  h1_8_4->Read("h1_8_4");
  h1_8->SetLineWidth(2); h1_8->SetLineColor(2); h1_8->SetStats(FALSE); h1_8->Draw();
  h1_8_2->SetLineWidth(2); h1_8_2->SetLineColor(3); h1_8_2->SetStats(FALSE); h1_8_2->Draw("same");
  h1_8_3->SetLineWidth(2); h1_8_3->SetLineColor(4); h1_8_3->SetStats(FALSE); h1_8_3->Draw("same");
  h1_8_4->SetLineWidth(2); h1_8_4->SetLineColor(6); h1_8_4->SetStats(FALSE); h1_8_4->Draw("same");
  c1->SaveAs("./sim_results/sim_res3_h1_8.ps");
  c1->SaveAs("./sim_results/sim_res3_h1_8.gif");
  delete h1_8;
  delete h1_8_2;
  delete h1_8_3;
  delete h1_8_4;

  phisto1->cd(1);
  TH1F *h1_9 = new TH1F();
  h1_9->Read("h1_9");
  TH1F *h1_9_2 = new TH1F();
  h1_9_2->Read("h1_9_2");
  TH1F *h1_9_3 = new TH1F();
  h1_9_3->Read("h1_9_3");
  h1_9->SetLineWidth(2); h1_9->SetLineColor(2); h1_9->SetStats(FALSE); h1_9->Draw();
  h1_9_2->SetLineWidth(2); h1_9_2->SetLineColor(3); h1_9_2->SetStats(FALSE); h1_9_2->Draw("same");
  h1_9_3->SetLineWidth(2); h1_9_3->SetLineColor(4); h1_9_3->SetStats(FALSE); h1_9_3->Draw("same");
  c1->SaveAs("./sim_results/sim_res3_h1_9.ps");
  c1->SaveAs("./sim_results/sim_res3_h1_9.gif");
  delete h1_9;
  delete h1_9_2;
  delete h1_9_3;

  phisto1->cd(1);
  TH2F *h1_10 = new TH2F();
  h1_10->Read("h1_10");
  h1_10->Draw("colz");
  c1->SaveAs("./sim_results/sim_res3_h1_10.ps");
  c1->SaveAs("./sim_results/sim_res3_h1_10.gif");
  delete h1_10;

  phisto1->cd(1);
  TH1F *h1_11 = new TH1F();
  h1_11->Read("h1_11");
  h1_11->SetLineWidth(3); h1_11->Draw();
  c1->SaveAs("./sim_results/sim_res3_h1_11.ps");
  c1->SaveAs("./sim_results/sim_res3_h1_11.gif");
  delete h1_11;

  phisto1->cd(1);
  TH1F *h1_12 = new TH1F();
  h1_12->Read("h1_12");
  TH1F *h1_12_2 = new TH1F();
  h1_12_2->Read("h1_12_2");
  TH1F *h1_12_3 = new TH1F();
  h1_12_3->Read("h1_12_3");
  h1_12->SetLineWidth(2); h1_12->SetLineColor(2); h1_12->SetStats(FALSE); h1_12->Draw();
  h1_12_2->SetLineWidth(2); h1_12_2->SetLineColor(3); h1_12_2->SetStats(FALSE); h1_12_2->Draw("same");
  h1_12_3->SetLineWidth(2); h1_12_3->SetLineColor(4); h1_12_3->SetStats(FALSE); h1_12_3->Draw("same");
  c1->SaveAs("./sim_results/sim_res3_h1_12.ps");
  c1->SaveAs("./sim_results/sim_res3_h1_12.gif");
  delete h1_12;

  delete c1;
}
