/*
$Log: res5.C,v $
Revision 1.3  2001/04/02 14:51:40  schneide
Use of global header file for fit settings

*/

#include "../global.h"

#define MODULE "res5"

void res5()
{
  Char_t TitleString[120];
  sprintf(TitleString, "AliTRDnh_%s (%s, %s)", MODULE, CONFIGURATION, DATE);

  TStyle *mystyle = new TStyle("Default", "Default Style");
  Int_t ncolors = 1;
  Int_t *colors = NULL;
  mystyle->SetPalette(ncolors, colors);
  mystyle->cd();

  TCanvas *c1 = new TCanvas("c1", "Config_bv.C", 100, 10, 600, 400); c1->Draw();
  TPad *ptitle1 = new TPad("ptitle1", "ptitle1", 0.01, 0.95, 0.99, 0.99); ptitle1->Draw();
  ptitle1->cd(); TPaveLabel *pltitle1 = new TPaveLabel(0.0, 0.0, 1.0, 1.0, TitleString); pltitle1->Draw();
  c1->cd(); TPad *phisto1 = new TPad("phisto1", "phisto1", 0.01, 0.01, 0.99, 0.94);
  phisto1->Draw(); phisto1->Divide(1,1);

  TFile *fp = new TFile("./histo_res5.root");

  Char_t hstr[80];

  phisto1->cd(1);
  TH1F *h1_1 = new TH1F();
  h1_1->Read("h1_1");
  TH1F *h1_1_2 = new TH1F();
  h1_1_2->Read("h1_1_2");
  TH1F *h1_1_3 = new TH1F();
  h1_1_3->Read("h1_1_3");
  h1_1->SetLineColor(2); h1_1->SetStats(FALSE); h1_1->Draw();
  h1_1_2->SetLineColor(3); h1_1_2->SetStats(FALSE); h1_1_2->Draw("same");
  h1_1_3->SetLineColor(4); h1_1_3->SetStats(FALSE); h1_1_3->Draw("same");
  Float_t max = h1_1->GetMaximum();
  TPaveText *tt1_1 = new TPaveText(1.2, 0.8*max, 2.8, 0.9*max); tt1_1->SetTextColor(2); sprintf(hstr, "RMS = %f\n", h1_1->GetRMS()); tt1_1->AddText(hstr); tt1_1->Draw();
  TPaveText *tt1_2 = new TPaveText(1.2, 0.7*max, 2.8, 0.8*max); tt1_2->SetTextColor(3); sprintf(hstr, "RMS = %f\n", h1_1_2->GetRMS()); tt1_2->AddText(hstr); tt1_2->Draw();
  TPaveText *tt1_3 = new TPaveText(1.2, 0.6*max, 2.8, 0.7*max); tt1_3->SetTextColor(4); sprintf(hstr, "RMS = %f\n", h1_1_3->GetRMS()); tt1_3->AddText(hstr); tt1_3->Draw();
  c1->SaveAs("./sim_results/sim_res5_h1_1.ps");
  c1->SaveAs("./sim_results/sim_res5_h1_1.gif");
  delete h1_1;
  delete h1_1_2;
  delete h1_1_3;

  phisto1->cd(1);
  TH1F *h1_2 = new TH1F();
  h1_2->Read("h1_2");
  TH1F *h1_2_2 = new TH1F();
  h1_2_2->Read("h1_2_2");
  TH1F *h1_2_3 = new TH1F();
  h1_2_3->Read("h1_2_3");
  h1_2->SetLineColor(2); h1_2->SetStats(FALSE); h1_2->Draw();
  h1_2_2->SetLineColor(3); h1_2_2->SetStats(FALSE); h1_2_2->Draw("same");
  h1_2_3->SetLineColor(4); h1_2_3->SetStats(FALSE); h1_2_3->Draw("same");
  TPaveText *tt2_1 = new TPaveText(4, 0.8*max, 9, 0.9*max); tt2_1->SetTextColor(2); sprintf(hstr, "RMS = %f\n", h1_2->GetRMS()); tt2_1->AddText(hstr); tt2_1->Draw();
  TPaveText *tt2_2 = new TPaveText(4, 0.7*max, 9, 0.8*max); tt2_2->SetTextColor(3); sprintf(hstr, "RMS = %f\n", h1_2_2->GetRMS()); tt2_2->AddText(hstr); tt2_2->Draw();
  TPaveText *tt2_3 = new TPaveText(4, 0.6*max, 9, 0.7*max); tt2_3->SetTextColor(4); sprintf(hstr, "RMS = %f\n", h1_2_3->GetRMS()); tt2_3->AddText(hstr); tt2_3->Draw();
  c1->SaveAs("./sim_results/sim_res5_h1_2.ps");
  c1->SaveAs("./sim_results/sim_res5_h1_2.gif");
  delete h1_2;
  delete h1_2_2;
  delete h1_2_3;

  phisto1->cd(1);
  TH1F *h1_3 = new TH1F();
  h1_3->Read("h1_3");
  h1_3->SetLineColor(2); h1_3->SetStats(FALSE); h1_3->Draw();
  c1->SaveAs("./sim_results/sim_res5_h1_3.ps");
  c1->SaveAs("./sim_results/sim_res5_h1_3.gif");
  delete h1_3;

  phisto1->cd(1);
  TH1F *h1_4 = new TH1F();
  h1_4->Read("h1_4");
  TH1F *h1_4_2 = new TH1F();
  h1_4_2->Read("h1_4_2");
  TH1F *h1_4_3 = new TH1F();
  h1_4_3->Read("h1_4_3");
  h1_4->SetLineColor(2); h1_4->SetStats(FALSE); h1_4->Draw();
  h1_4_2->SetLineColor(3); h1_4_2->SetStats(FALSE); h1_4_2->Draw("same");
  h1_4_3->SetLineColor(4); h1_4_3->SetStats(FALSE); h1_4_3->Draw("same");
  c1->SaveAs("./sim_results/sim_res5_h1_4.ps");
  c1->SaveAs("./sim_results/sim_res5_h1_4.gif");
  delete h1_4;
  delete h1_4_2;
  delete h1_4_3;

  delete c1;
}
