/*
$Log: row.C,v $
Revision 1.3  2001/04/02 14:51:40  schneide
Use of global header file for fit settings

*/

#include "../global.h"

#define MODULE "row"

void row()
{
  Char_t TitleString[120];
  sprintf(TitleString, "AliTRDnh_%s (%s, %s)", MODULE, CONFIGURATION, DATE);

  TStyle *mystyle = new TStyle("Default", "Default Style");
  Int_t ncolors = 1;
  Int_t *colors = NULL;
  mystyle->SetPalette(ncolors, colors);
  mystyle->cd();

  TCanvas *c1 = new TCanvas("c1", "Config_bv.C", 100, 10, 600, 400); c1->Draw();
  TPad *ptitle1 = new TPad("ptitle1", "ptitle1", 0.01, 0.95, 0.99, 0.99); ptitle1->Draw();
  ptitle1->cd(); TPaveLabel *pltitle1 = new TPaveLabel(0.0, 0.0, 1.0, 1.0, TitleString); pltitle1->Draw();
  c1->cd(); TPad *phisto1 = new TPad("phisto1", "phisto1", 0.01, 0.01, 0.99, 0.94);
  phisto1->Draw(); phisto1->Divide(1,1);

  TFile *fp = new TFile("./histo_row.root");

  phisto1->cd(1);
  TH1F *h1_1 = new TH1F();
  h1_1->Read("h1_1");
  h1_1->SetLineWidth(3); h1_1->Draw();
  c1->SaveAs("./sim_results/sim_row_h1_1.ps");
  c1->SaveAs("./sim_results/sim_row_h1_1.gif");
  delete h1_1;

  phisto1->cd(1);
  TH1F *h1_2 = new TH1F();
  h1_2->Read("h1_2");
  TH1F *h1_2_2 = new TH1F();
  h1_2_2->Read("h1_2_2");
  TH1F *h1_2_3 = new TH1F();
  h1_2_3->Read("h1_2_3");
  TH1F *h1_2_4 = new TH1F();
  h1_2_4->Read("h1_2_4");
  TH1F *h1_2_5 = new TH1F();
  h1_2_5->Read("h1_2_5");
  h1_2->SetLineWidth(2); h1_2->SetStats(FALSE);   h1_2->SetLineColor(1);   h1_2->Draw();
  h1_2_2->SetLineWidth(2); h1_2_2->SetStats(FALSE); h1_2_2->SetLineColor(2); h1_2_2->Draw("same");
  h1_2_3->SetLineWidth(2); h1_2_3->SetStats(FALSE); h1_2_3->SetLineColor(3); h1_2_3->Draw("same");
  h1_2_4->SetLineWidth(2); h1_2_4->SetStats(FALSE); h1_2_4->SetLineColor(4); h1_2_4->Draw("same");
  h1_2_5->SetLineWidth(2); h1_2_5->SetStats(FALSE); h1_2_5->SetLineColor(6); h1_2_5->Draw("same");
  Float_t max = h1_2->GetMaximum();
  TPaveText *tt0 = new TPaveText(60, 0.9*max, 120, 0.95*max); tt0->SetTextColor(1); tt0->AddText("segment lost in r direction"); tt0->Draw();
  TPaveText *tt1 = new TPaveText(80, 0.85*max, 100, 0.9*max); tt1->SetTextColor(1); tt1->AddText(">0mm"); tt1->Draw();
  TPaveText *tt2 = new TPaveText(80, 0.8*max, 100, 0.85*max); tt2->SetTextColor(2); tt2->AddText(">3mm"); tt2->Draw();
  TPaveText *tt3 = new TPaveText(80, 0.75*max, 100, 0.8*max); tt3->SetTextColor(3); tt3->AddText(">6mm"); tt3->Draw();
  TPaveText *tt4 = new TPaveText(80, 0.7*max, 100, 0.75*max); tt4->SetTextColor(4); tt4->AddText(">9mm"); tt4->Draw();
  TPaveText *tt5 = new TPaveText(80, 0.65*max, 100, 0.7*max); tt5->SetTextColor(6); tt5->AddText(">12mm"); tt5->Draw();
  c1->SaveAs("./sim_results/sim_row_h1_2.ps");
  c1->SaveAs("./sim_results/sim_row_h1_2.gif");
  delete h1_2;
  delete h1_2_2;
  delete h1_2_3;
  delete h1_2_4;
  delete h1_2_5;

  phisto1->cd(1);
  TH1F *h1_3 = new TH1F();
  h1_3->Read("h1_3");
  TH1F *h1_3_2 = new TH1F();
  h1_3_2->Read("h1_3_2");
  TH1F *h1_3_3 = new TH1F();
  h1_3_3->Read("h1_3_3");
  TH1F *h1_3_4 = new TH1F();
  h1_3_4->Read("h1_3_4");
  TH1F *h1_3_5 = new TH1F();
  h1_3_5->Read("h1_3_5");
  h1_3->SetLineWidth(2); h1_3->SetStats(FALSE);   h1_3->SetLineColor(1);   h1_3->Draw();
  h1_3_2->SetLineWidth(2); h1_3_2->SetStats(FALSE); h1_3_2->SetLineColor(2); h1_3_2->Draw("same");
  h1_3_3->SetLineWidth(2); h1_3_3->SetStats(FALSE); h1_3_3->SetLineColor(3); h1_3_3->Draw("same");
  h1_3_4->SetLineWidth(2); h1_3_4->SetStats(FALSE); h1_3_4->SetLineColor(4); h1_3_4->Draw("same");
  h1_3_5->SetLineWidth(2); h1_3_5->SetStats(FALSE); h1_3_5->SetLineColor(6); h1_3_5->Draw("same");
  Float_t max = h1_3->GetMaximum();
  TPaveText *tt0 = new TPaveText(60, 0.9*max, 120, 0.95*max); tt0->SetTextColor(1); tt0->AddText("segment lost in r direction"); tt0->Draw();
  TPaveText *tt1 = new TPaveText(80, 0.85*max, 100, 0.9*max); tt1->SetTextColor(1); tt1->AddText(">0mm"); tt1->Draw();
  TPaveText *tt2 = new TPaveText(80, 0.8*max, 100, 0.85*max); tt2->SetTextColor(2); tt2->AddText(">3mm"); tt2->Draw();
  TPaveText *tt3 = new TPaveText(80, 0.75*max, 100, 0.8*max); tt3->SetTextColor(3); tt3->AddText(">6mm"); tt3->Draw();
  TPaveText *tt4 = new TPaveText(80, 0.7*max, 100, 0.75*max); tt4->SetTextColor(4); tt4->AddText(">9mm"); tt4->Draw();
  TPaveText *tt5 = new TPaveText(80, 0.65*max, 100, 0.7*max); tt5->SetTextColor(6); tt5->AddText(">12mm"); tt5->Draw();
  c1->SaveAs("./sim_results/sim_row_h1_3.ps");
  c1->SaveAs("./sim_results/sim_row_h1_3.gif");
  delete h1_3;
  delete h1_3_2;
  delete h1_3_3;
  delete h1_3_4;
  delete h1_3_5;

  phisto1->cd(1);
  TH1F *h1_4 = new TH1F();
  h1_4->Read("h1_4");
  h1_4->SetLineWidth(3); h1_4->Draw();
  c1->SaveAs("./sim_results/sim_row_h1_4.ps");
  c1->SaveAs("./sim_results/sim_row_h1_4.gif");
  delete h1_4;

  phisto1->cd(1);
  TH1F *h1_5 = new TH1F();
  h1_5->Read("h1_5");
  h1_5->SetLineWidth(3); h1_5->Draw();
  c1->SaveAs("./sim_results/sim_row_h1_5.ps");
  c1->SaveAs("./sim_results/sim_row_h1_5.gif");
  delete h1_5;

  phisto1->cd(1);
  TH1F *h1_6 = new TH1F();
  h1_6->Read("h1_6");
  h1_6->SetLineWidth(3); h1_6->Draw();
  c1->SaveAs("./sim_results/sim_row_h1_6.ps");
  c1->SaveAs("./sim_results/sim_row_h1_6.gif");
  delete h1_6;

  phisto1->cd(1);
  TH1F *h1_7 = new TH1F();
  h1_7->Read("h1_7");
  h1_7->SetLineWidth(3); h1_7->Draw();
  c1->SaveAs("./sim_results/sim_row_h1_7.ps");
  c1->SaveAs("./sim_results/sim_row_h1_7.gif");
  delete h1_7;

  delete c1;
}
