#ifndef ALITRDTRAP_H
#define ALITRDTRAP_H
/* Copyright(c) 1998-1999, ALICE Experiment at CERN, All rights reserved. *
 * See cxx source for full Copyright notice                               */

/* $Id$ */

#include <TObject.h>
#include <TObjArray.h>
#include "AliTRDtrapFilter.h"

class AliTRDtrap : public TObject {

  public:

    AliTRDtrap();
    AliTRDtrap(Int_t iPlane, Int_t iSector, Int_t iChamber, Int_t iPadrow, Int_t iMCM);
    virtual ~AliTRDtrap();
    Int_t      GetChamber() const { return fChamber; }
    Int_t      GetChannels() const { return fChannels; }
    TObject   *GetFilter(Int_t iFilter) const { return fFilter->At(iFilter); }
    Int_t      GetMCM() const { return fMCM; }
    Int_t      GetPadrow() const { return fPadrow; }
    Int_t      GetPlane() const { return fPlane; }
    Int_t      GetSector() const { return fSector; }
    void       Init();
    void       SetChamber(Int_t iChamber) { fChamber = iChamber; }
    void       SetChannels(Int_t iChannels) { fChannels = iChannels; }
    void       SetMCM(Int_t iMCM) { fMCM = iMCM; }
    void       SetPadrow(Int_t iPadrow) { fPadrow = iPadrow; }
    void       SetPlane(Int_t iPlane) { fPlane = iPlane; }
    void       SetSector(Int_t iSector) { fSector = iSector; }

    static Int_t fDebug;

  private:

    Int_t      fPlane;
    Int_t      fSector;
    Int_t      fChamber;
    Int_t      fPadrow;
    Int_t      fMCM;

    Int_t      fChannels; // Number of channels per TRAP
    TObjArray *fFilter; // Array of filter channels (0 .. fChannels+3-1)

  protected:

    ClassDef(AliTRDtrap,1) // Data container for one filter channel

};

#endif
