#ifndef ALITRDTRAPCONST_H
#define ALITRDTRAPCONST_H
/* Copyright(c) 1998-1999, ALICE Experiment at CERN, All rights reserved. *
 * See cxx source for full Copyright notice                               */

/* $Id$ */

#include "Rtypes.h"

///////////////////////////////////////////////////////////////////////////
//  DEFINES                                                              //
///////////////////////////////////////////////////////////////////////////
#define VERSION            "V021015"             // current version
#define MODULE             "AliTRDtrap"
#define LIBRARY            "TRDtrap"
#define TRUE               1
#define FALSE              0
#define XXX                -1                    // not defined
#define WL_NONE            0                     // warning level: none
#define WL_ERROR           1                     //                error
#define WL_WARNING         2                     //                warnings
#define WL_INFO            3                     //                info

///////////////////////////////////////////////////////////////////////////
//  CONSTANTS                                                            //
///////////////////////////////////////////////////////////////////////////
// GEOMETRY
const Int_t   kLayers                 = 6;
const Int_t   kSectors                = 18;
const Int_t   kChambers               = 5;

///////////////////////////////////////////////////////////////////////////
//  MACROS                                                               //
///////////////////////////////////////////////////////////////////////////
#define DBG_I(CMD)   { if(AliTRDtrap::fDebug >= WL_INFO) { printf("%s: INFO -- ", MODULE); CMD }}
#define DBG_W(CMD)   { if(AliTRDtrap::fDebug >= WL_WARNING) { printf("%s: WARNING -- ", MODULE); CMD }}
#define DBG_E(CMD)   { if(AliTRDtrap::fDebug >= WL_ERROR) { printf("%s: ERROR -- ", MODULE); CMD }}
#define HEAD(CMD)    { DBG_N ( printf("\n"); ) DBG_N ( printf("************************************************************\n"); ) DBG_N ( printf("**** "); ) CMD DBG_N ( printf("************************************************************\n"); ) DBG_N ( printf("\n"); ) }
#endif
