void filterTest()
{
  Int_t ADC  = 0; // enum ARRAY_TYPE defined in AliTRDtrapFilter.h
  Int_t TAIL = 1;
  Int_t CT   = 2;
  Int_t NL   = 3;
  Int_t PD   = 4;
  Int_t GAIN = 5;

  gROOT->Reset();
  gSystem->Load("libTRDtrap");

  AliTRDtrapFilter *filter = new AliTRDtrapFilter(1, 2, 3, 4, 5, 6);
  
  //TH1D *hADC = new TH1D("hADC", "ADC values", 30, -0.5, 29.5);
  TH1D *hNL = new TH1D("hNL", "ADC values", 30, -0.5, 29.5);
  hNL->SetLineWidth(3); hNL->SetLineColor(2);

  TH1D *hTAIL = new TH1D("hTAIL", "tail cancellation", 30, -0.5, 29.5);
  hTAIL->SetLineWidth(3); hTAIL->SetLineColor(4);

  //TH1D *hCT = new TH1D("hCT", "crosstalk cancellation", 30, -0.5, 29.5);

  filter->ReadFilter("testfile.txt");
  filter->Info();
  cout << "-- ADC values:" << endl;
  filter->OutputValues(ADC);
  filter->NonLinearityCorrection();
  cout << "-- NL values:" << endl;
  filter->OutputValues(NL);

  filter->SetAlpha_l(246);
  filter->SetLambda_l(285);
  filter->SetLambda_s(211);

  filter->TailCancellation();
  cout << "-- TAIL values:" << endl;
  filter->OutputValues(TAIL);

  /*
  filter->SetC0(0.02910888);
  filter->SetC1(-0.04309046);
  filter->SetC2(-0.02579803);
  filter->SetC3(0.07202855);
  filter->SetC4(-0.01659233);
  filter->CrosstalkCancellation();
  filter->OutputCTvalues();
  */

  //for(Int_t i=0; i<30; i++) hADC->Fill(i, filter->GetValue(ADC, i));
  for(Int_t i=0; i<30; i++) hNL->Fill(i, filter->GetValue(NL, i));
  for(Int_t i=0; i<30; i++) hTAIL->Fill(i, filter->GetValue(TAIL, i));
  //for(Int_t i=0; i<30; i++) hCT->Fill(i, filter->GetValue(CT, i));

  //hADC->Draw("same");
  hNL->Draw("L");
  hTAIL->Draw("LSAME");
  //hCT->Draw("same");
}
