library IEEE, TRAP;
use IEEE.std_logic_1164.all;
use WORK.ni_global.all;

----------------------------------------------------------------------------------------------------
-- PACKAGE
----------------------------------------------------------------------------------------------------
package ni_rb_global is

  -- CONSTANTS -------------------------------------------------------------------------------------
  constant chips : integer := 17;
  constant width : integer := 32;

  -- SIGNAL TYPES ----------------------------------------------------------------------------------
  subtype addr_type  is STD_LOGIC_VECTOR(io_address_bus_width-1 downto 0);
  type    addr_array is array(chips-1 downto 0) of addr_type;
  subtype intr_type  is STD_LOGIC_VECTOR(2 downto 0);
  type    intr_array is array(chips-1 downto 0) of intr_type;
  subtype data_type  is STD_LOGIC_VECTOR(width-1 downto 0);
  type    data_array is array(chips-1 downto 0) of data_type;
  subtype port_type  is STD_LOGIC_VECTOR((width/4)+1 downto 0);
  type    port_array is array(chips-1 downto 0) of port_type;
  subtype sig_array  is STD_LOGIC_VECTOR(chips-1 downto 0);

end ;
