#
# FirstEncounter(TM) Clock Synthesis Technology File Format
#
# (A) for user-specified clock tree topology
#    ClockNetName <net_name>
#    LevelNumber  <number>
#    LevelSpec   <level number> <no. of buffer> <buf type>
#    End
#
#
# (B) for automatic gated clock tree synthesis
#    AutoCTSRootPin    <clock root pin name>
#    MaxDelay     <number>
#    MinDelay     <number>
#    SinkMaxTran          <number>
#    BufMaxTran   <number>
#    MaxSkew           <number>
#    NoGating          <rising|falling|NO>
#    MaxDepth     <number>
#    Buffer           <cell_1> <cell_2> <cell_3> ....
#    LeafPin
#    +  <pin name> <rising|falling>
#    +  ....
#    LeafPort
#    +  <port name> <rising|falling>
#    +  ....
#    ExcludedPin
#    +  <pin name>
#    +  ....
#    ExcludedPort
#    +  <port name>
#    +  ....
#    ThroughPin
#    +  <pin name>
#    +  ....
#    End
#
#
#  NOTE:
#   1) "AutoClockNetName" is obsolete and can be replaced by
#       "AutoCTSRootPin" with NoGating <rising|falling>.
#   2) MaxDelay is used to set max. phase delay constraint,
#      the default value is 10ns.
#   3) MinDelay is used to set min. phase delay constraint,
#      the default value is 0.0.
#   4) SinkMaxTran is to set SINK max. transition time constraint,
#      the default value is 400ps.
#   5) BufMaxTran is to set BUFFER max. transition time constraint,
#      the default value is 400ps.
#   6) MaxSkew is used to set maximum skew constraint, the default
#      value is 300ps.
#   7) MaxDepth is used to limit the depth of clock tree tracing,
#      the default value is 10.
#   8) NoGating is used to limit CTS not to trace through any
#      gate and treat those gate as leaves.
#
#
#  (C) Setting MacroModel:
#
#      MacroModel port <cellName/portName> <maxRiseDelay> <minRiseDelay> <maxFallDelay> <minFallDelay> <inputCap>
#
#      MacroModel pin <pinName> <maxRiseDelay> <minRiseDelay> <maxFallDelay> <minFallDelay> <inputCap>
#
#      Example :
#          MacroModel pin A/B/C 1ns 900ps 1.1ns 950ps 0.2pf
#
#
#
#
#
#  (D) Clock Grouping:
#
#      Note that, just like the stmt for MacroModel, the stmt
#      for Clock Grouping must be placed at the beginning of
#      the spec. after MacroModel stmt.
#
#
#
#      ClkGroup
#      + <clock root pin name>
#      + <clock root pin name>
#      + <clock root pin name>
#      ClkGroup
#      + <clock root pin name>
#      + <clock root pin name>
#      + <clock root pin name>
#
#
#
#      Example :
#      ClkGroup
#      + reset_n
#      + clk
#      ClkGroup
#      + scan_shift_mode
#      + cclk
#      + dclk
