
################################################################################
# define all synchronous clocks into appropriate groups
################################################################################

# NIP0
ClkGroup
+ NIP0_D0/DI
+ NIP0_D1/DI
+ NIP0_D2/DI
+ NIP0_D3/DI
+ NIP0_D4/DI
+ NIP0_D5/DI
+ NIP0_D6/DI
+ NIP0_D7/DI
+ NIP0_D8/DI
+ NIP0_D9/DI
+ NIP0_STB/DI
+ Itrap2top/rs/U121/Z

# NIP1
ClkGroup
+ NIP1_D0/DI
+ NIP1_D1/DI
+ NIP1_D2/DI
+ NIP1_D3/DI
+ NIP1_D4/DI
+ NIP1_D5/DI
+ NIP1_D6/DI
+ NIP1_D7/DI
+ NIP1_D8/DI
+ NIP1_D9/DI
+ NIP1_STB/DI
+ Itrap2top/rs/U122/Z

# NIP2
ClkGroup
+ NIP2_D0/DI
+ NIP2_D1/DI
+ NIP2_D2/DI
+ NIP2_D3/DI
+ NIP2_D4/DI
+ NIP2_D5/DI
+ NIP2_D6/DI
+ NIP2_D7/DI
+ NIP2_D8/DI
+ NIP2_D9/DI
+ NIP2_STB/DI
+ Itrap2top/rs/U123/Z
 
# NIP3
ClkGroup
+ NIP3_D0/DI
+ NIP3_D1/DI
+ NIP3_D2/DI
+ NIP3_D3/DI
+ NIP3_D4/DI
+ NIP3_D5/DI
+ NIP3_D6/DI
+ NIP3_D7/DI
+ NIP3_D8/DI
+ NIP3_D9/DI
+ NIP3_STB/DI
+ Itrap2top/rs/U124/Z

# NIP4
ClkGroup
+ Itrap2top/rs/U_port_out/U_delay/U_delaybit_0/U_buffer/Z
+ Itrap2top/rs/U_port_out/U_delay/U_delaybit_1/U_buffer/Z
+ Itrap2top/rs/U_port_out/U_delay/U_delaybit_2/U_buffer/Z
+ Itrap2top/rs/U_port_out/U_delay/U_delaybit_3/U_buffer/Z
+ Itrap2top/rs/U_port_out/U_delay/U_delaybit_4/U_buffer/Z
+ Itrap2top/rs/U_port_out/U_delay/U_delaybit_5/U_buffer/Z
+ Itrap2top/rs/U_port_out/U_delay/U_delaybit_6/U_buffer/Z
+ Itrap2top/rs/U_port_out/U_delay/U_delaybit_7/U_buffer/Z
+ Itrap2top/rs/U_port_out/U_delay/U_delaybit_8/U_buffer/Z
+ Itrap2top/rs/U_port_out/U_delay/U_delaybit_9/U_buffer/Z
+ Itrap2top/rs/U_port_out/U_delay/U_delaybit_10/U_buffer/Z
+ Itrap2top/rs/U_port_out/U_delay/U_delaybit_11/U_buffer/Z
+ NIP4_CTL/DI



################################################################################
# Port 0
################################################################################

AutoCTSRootPin   	NIP0_D0/DI
RouteType		CLKSpline
NoGating          	rising
MaxDelay          	5000ps
MinDelay          	0ps
MaxSkew           	10ps
MaxDepth          	100
SinkMaxTran       	500ps
BufMaxTran        	500ps
Buffer			BUFBD2 BUFBD4 BUFBD8 BUFBD12 BUFBD16 INVBD2 INVBD4 INVBD8 INVBD12 INVBD16
RouteClkNet             NO
PostOpt                 YES         # this is the default
DetailReport            YES
End

AutoCTSRootPin   	NIP0_D1/DI
RouteType		CLKSpline
NoGating          	rising
MaxDelay          	5000ps
MinDelay          	0ps
MaxSkew           	10ps
MaxDepth          	100
SinkMaxTran       	500ps
BufMaxTran        	500ps
Buffer			BUFBD2 BUFBD4 BUFBD8 BUFBD12 BUFBD16 INVBD2 INVBD4 INVBD8 INVBD12 INVBD16
RouteClkNet             NO
PostOpt                 YES         # this is the default
DetailReport            YES
End

AutoCTSRootPin   	NIP0_D2/DI
RouteType		CLKSpline
NoGating          	rising
MaxDelay          	5000ps
MinDelay          	0ps
MaxSkew           	10ps
MaxDepth          	100
SinkMaxTran       	500ps
BufMaxTran        	500ps
Buffer			BUFBD2 BUFBD4 BUFBD8 BUFBD12 BUFBD16 INVBD2 INVBD4 INVBD8 INVBD12 INVBD16
RouteClkNet             NO
PostOpt                 YES         # this is the default
DetailReport            YES
End

AutoCTSRootPin   	NIP0_D3/DI
RouteType		CLKSpline
NoGating          	rising
MaxDelay          	5000ps
MinDelay          	0ps
MaxSkew           	10ps
MaxDepth          	100
SinkMaxTran       	500ps
BufMaxTran        	500ps
Buffer			BUFBD2 BUFBD4 BUFBD8 BUFBD12 BUFBD16 INVBD2 INVBD4 INVBD8 INVBD12 INVBD16
RouteClkNet             NO
PostOpt                 YES         # this is the default
DetailReport            YES
End

AutoCTSRootPin   	NIP0_D4/DI
RouteType		CLKSpline
NoGating          	rising
MaxDelay          	5000ps
MinDelay          	0ps
MaxSkew           	10ps
MaxDepth          	100
SinkMaxTran       	500ps
BufMaxTran        	500ps
Buffer			BUFBD2 BUFBD4 BUFBD8 BUFBD12 BUFBD16 INVBD2 INVBD4 INVBD8 INVBD12 INVBD16
RouteClkNet             NO
PostOpt                 YES         # this is the default
DetailReport            YES
End

AutoCTSRootPin   	NIP0_D5/DI
RouteType		CLKSpline
NoGating          	rising
MaxDelay          	5000ps
MinDelay          	0ps
MaxSkew           	10ps
MaxDepth          	100
SinkMaxTran       	500ps
BufMaxTran        	500ps
Buffer			BUFBD2 BUFBD4 BUFBD8 BUFBD12 BUFBD16 INVBD2 INVBD4 INVBD8 INVBD12 INVBD16
RouteClkNet             NO
PostOpt                 YES         # this is the default
DetailReport            YES
End

AutoCTSRootPin   	NIP0_D6/DI
RouteType		CLKSpline
NoGating          	rising
MaxDelay          	5000ps
MinDelay          	0ps
MaxSkew           	10ps
MaxDepth          	100
SinkMaxTran       	500ps
BufMaxTran        	500ps
Buffer			BUFBD2 BUFBD4 BUFBD8 BUFBD12 BUFBD16 INVBD2 INVBD4 INVBD8 INVBD12 INVBD16
RouteClkNet             NO
PostOpt                 YES         # this is the default
DetailReport            YES
End

AutoCTSRootPin   	NIP0_D7/DI
RouteType		CLKSpline
NoGating          	rising
MaxDelay          	5000ps
MinDelay          	0ps
MaxSkew           	10ps
MaxDepth          	100
SinkMaxTran       	500ps
BufMaxTran        	500ps
Buffer			BUFBD2 BUFBD4 BUFBD8 BUFBD12 BUFBD16 INVBD2 INVBD4 INVBD8 INVBD12 INVBD16
RouteClkNet             NO
PostOpt                 YES         # this is the default
DetailReport            YES
End

AutoCTSRootPin   	NIP0_D8/DI
RouteType		CLKSpline
NoGating          	rising
MaxDelay          	5000ps
MinDelay          	0ps
MaxSkew           	10ps
MaxDepth          	100
SinkMaxTran       	500ps
BufMaxTran        	500ps
Buffer			BUFBD2 BUFBD4 BUFBD8 BUFBD12 BUFBD16 INVBD2 INVBD4 INVBD8 INVBD12 INVBD16
RouteClkNet             NO
PostOpt                 YES         # this is the default
DetailReport            YES
End

AutoCTSRootPin   	NIP0_D9/DI
RouteType		CLKSpline
NoGating          	rising
MaxDelay          	5000ps
MinDelay          	0ps
MaxSkew           	10ps
MaxDepth          	100
SinkMaxTran       	500ps
BufMaxTran        	500ps
Buffer			BUFBD2 BUFBD4 BUFBD8 BUFBD12 BUFBD16 INVBD2 INVBD4 INVBD8 INVBD12 INVBD16
RouteClkNet             NO
PostOpt                 YES         # this is the default
DetailReport            YES
End

AutoCTSRootPin   	NIP0_STB/DI
RouteType		CLKSpline
NoGating          	rising
MaxDelay          	5000ps
MinDelay          	0ps
MaxSkew           	10ps
MaxDepth          	100
SinkMaxTran       	500ps
BufMaxTran        	500ps
Buffer			BUFBD2 BUFBD4 BUFBD8 BUFBD12 BUFBD16 INVBD2 INVBD4 INVBD8 INVBD12 INVBD16
RouteClkNet             NO
PostOpt                 YES         # this is the default
DetailReport            YES
End

AutoCTSRootPin   	Itrap2top/rs/U121/Z
RouteType		CLKSpline
NoGating          	rising
MaxDelay          	5000ps
MinDelay          	0ps
MaxSkew           	10ps
MaxDepth          	100
SinkMaxTran       	500ps
BufMaxTran        	500ps
Buffer			BUFBD2 BUFBD4 BUFBD8 BUFBD12 BUFBD16 INVBD2 INVBD4 INVBD8 INVBD12 INVBD16
RouteClkNet             NO
PostOpt                 YES         # this is the default
DetailReport            YES
End


################################################################################
# Port 1
################################################################################

AutoCTSRootPin   	NIP1_D0/DI
RouteType		CLKSpline
NoGating          	rising
MaxDelay          	5000ps
MinDelay          	0ps
MaxSkew           	10ps
MaxDepth          	100
SinkMaxTran       	500ps
BufMaxTran        	500ps
Buffer			BUFBD2 BUFBD4 BUFBD8 BUFBD12 BUFBD16 INVBD2 INVBD4 INVBD8 INVBD12 INVBD16
RouteClkNet             NO
PostOpt                 YES         # this is the default
DetailReport            YES
End

AutoCTSRootPin   	NIP1_D1/DI
RouteType		CLKSpline
NoGating          	rising
MaxDelay          	5000ps
MinDelay          	0ps
MaxSkew           	10ps
MaxDepth          	100
SinkMaxTran       	500ps
BufMaxTran        	500ps
Buffer			BUFBD2 BUFBD4 BUFBD8 BUFBD12 BUFBD16 INVBD2 INVBD4 INVBD8 INVBD12 INVBD16
RouteClkNet             NO
PostOpt                 YES         # this is the default
DetailReport            YES
End

AutoCTSRootPin   	NIP1_D2/DI
RouteType		CLKSpline
NoGating          	rising
MaxDelay          	5000ps
MinDelay          	0ps
MaxSkew           	10ps
MaxDepth          	100
SinkMaxTran       	500ps
BufMaxTran        	500ps
Buffer			BUFBD2 BUFBD4 BUFBD8 BUFBD12 BUFBD16 INVBD2 INVBD4 INVBD8 INVBD12 INVBD16
RouteClkNet             NO
PostOpt                 YES         # this is the default
DetailReport            YES
End

AutoCTSRootPin   	NIP1_D3/DI
RouteType		CLKSpline
NoGating          	rising
MaxDelay          	5000ps
MinDelay          	0ps
MaxSkew           	10ps
MaxDepth          	100
SinkMaxTran       	500ps
BufMaxTran        	500ps
Buffer			BUFBD2 BUFBD4 BUFBD8 BUFBD12 BUFBD16 INVBD2 INVBD4 INVBD8 INVBD12 INVBD16
RouteClkNet             NO
PostOpt                 YES         # this is the default
DetailReport            YES
End

AutoCTSRootPin   	NIP1_D4/DI
RouteType		CLKSpline
NoGating          	rising
MaxDelay          	5000ps
MinDelay          	0ps
MaxSkew           	10ps
MaxDepth          	100
SinkMaxTran       	500ps
BufMaxTran        	500ps
Buffer			BUFBD2 BUFBD4 BUFBD8 BUFBD12 BUFBD16 INVBD2 INVBD4 INVBD8 INVBD12 INVBD16
RouteClkNet             NO
PostOpt                 YES         # this is the default
DetailReport            YES
End

AutoCTSRootPin   	NIP1_D5/DI
RouteType		CLKSpline
NoGating          	rising
MaxDelay          	5000ps
MinDelay          	0ps
MaxSkew           	10ps
MaxDepth          	100
SinkMaxTran       	500ps
BufMaxTran        	500ps
Buffer			BUFBD2 BUFBD4 BUFBD8 BUFBD12 BUFBD16 INVBD2 INVBD4 INVBD8 INVBD12 INVBD16
RouteClkNet             NO
PostOpt                 YES         # this is the default
DetailReport            YES
End

AutoCTSRootPin   	NIP1_D6/DI
RouteType		CLKSpline
NoGating          	rising
MaxDelay          	5000ps
MinDelay          	0ps
MaxSkew           	10ps
MaxDepth          	100
SinkMaxTran       	500ps
BufMaxTran        	500ps
Buffer			BUFBD2 BUFBD4 BUFBD8 BUFBD12 BUFBD16 INVBD2 INVBD4 INVBD8 INVBD12 INVBD16
RouteClkNet             NO
PostOpt                 YES         # this is the default
DetailReport            YES
End

AutoCTSRootPin   	NIP1_D7/DI
RouteType		CLKSpline
NoGating          	rising
MaxDelay          	5000ps
MinDelay          	0ps
MaxSkew           	10ps
MaxDepth          	100
SinkMaxTran       	500ps
BufMaxTran        	500ps
Buffer			BUFBD2 BUFBD4 BUFBD8 BUFBD12 BUFBD16 INVBD2 INVBD4 INVBD8 INVBD12 INVBD16
RouteClkNet             NO
PostOpt                 YES         # this is the default
DetailReport            YES
End

AutoCTSRootPin   	NIP1_D8/DI
RouteType		CLKSpline
NoGating          	rising
MaxDelay          	5000ps
MinDelay          	0ps
MaxSkew           	10ps
MaxDepth          	100
SinkMaxTran       	500ps
BufMaxTran        	500ps
Buffer			BUFBD2 BUFBD4 BUFBD8 BUFBD12 BUFBD16 INVBD2 INVBD4 INVBD8 INVBD12 INVBD16
RouteClkNet             NO
PostOpt                 YES         # this is the default
DetailReport            YES
End

AutoCTSRootPin   	NIP1_D9/DI
RouteType		CLKSpline
NoGating          	rising
MaxDelay          	5000ps
MinDelay          	0ps
MaxSkew           	10ps
MaxDepth          	100
SinkMaxTran       	500ps
BufMaxTran        	500ps
Buffer			BUFBD2 BUFBD4 BUFBD8 BUFBD12 BUFBD16 INVBD2 INVBD4 INVBD8 INVBD12 INVBD16
RouteClkNet             NO
PostOpt                 YES         # this is the default
DetailReport            YES
End

AutoCTSRootPin   	NIP1_STB/DI
RouteType		CLKSpline
NoGating          	rising
MaxDelay          	5000ps
MinDelay          	0ps
MaxSkew           	10ps
MaxDepth          	100
SinkMaxTran       	500ps
BufMaxTran        	500ps
Buffer			BUFBD2 BUFBD4 BUFBD8 BUFBD12 BUFBD16 INVBD2 INVBD4 INVBD8 INVBD12 INVBD16
RouteClkNet             NO
PostOpt                 YES         # this is the default
DetailReport            YES
End

AutoCTSRootPin   	Itrap2top/rs/U122/Z
RouteType		CLKSpline
NoGating          	rising
MaxDelay          	5000ps
MinDelay          	0ps
MaxSkew           	10ps
MaxDepth          	100
SinkMaxTran       	500ps
BufMaxTran        	500ps
Buffer			BUFBD2 BUFBD4 BUFBD8 BUFBD12 BUFBD16 INVBD2 INVBD4 INVBD8 INVBD12 INVBD16
RouteClkNet             NO
PostOpt                 YES         # this is the default
DetailReport            YES
End


################################################################################
# Port 2
################################################################################

AutoCTSRootPin   	NIP2_D0/DI
RouteType		CLKSpline
NoGating          	rising
MaxDelay          	5000ps
MinDelay          	0ps
MaxSkew           	10ps
MaxDepth          	100
SinkMaxTran       	500ps
BufMaxTran        	500ps
Buffer			BUFBD2 BUFBD4 BUFBD8 BUFBD12 BUFBD16 INVBD2 INVBD4 INVBD8 INVBD12 INVBD16
RouteClkNet             NO
PostOpt                 YES         # this is the default
DetailReport            YES
End

AutoCTSRootPin   	NIP2_D1/DI
RouteType		CLKSpline
NoGating          	rising
MaxDelay          	5000ps
MinDelay          	0ps
MaxSkew           	10ps
MaxDepth          	100
SinkMaxTran       	500ps
BufMaxTran        	500ps
Buffer			BUFBD2 BUFBD4 BUFBD8 BUFBD12 BUFBD16 INVBD2 INVBD4 INVBD8 INVBD12 INVBD16
RouteClkNet             NO
PostOpt                 YES         # this is the default
DetailReport            YES
End

AutoCTSRootPin   	NIP2_D2/DI
RouteType		CLKSpline
NoGating          	rising
MaxDelay          	5000ps
MinDelay          	0ps
MaxSkew           	10ps
MaxDepth          	100
SinkMaxTran       	500ps
BufMaxTran        	500ps
Buffer			BUFBD2 BUFBD4 BUFBD8 BUFBD12 BUFBD16 INVBD2 INVBD4 INVBD8 INVBD12 INVBD16
RouteClkNet             NO
PostOpt                 YES         # this is the default
DetailReport            YES
End

AutoCTSRootPin   	NIP2_D3/DI
RouteType		CLKSpline
NoGating          	rising
MaxDelay          	5000ps
MinDelay          	0ps
MaxSkew           	10ps
MaxDepth          	100
SinkMaxTran       	500ps
BufMaxTran        	500ps
Buffer			BUFBD2 BUFBD4 BUFBD8 BUFBD12 BUFBD16 INVBD2 INVBD4 INVBD8 INVBD12 INVBD16
RouteClkNet             NO
PostOpt                 YES         # this is the default
DetailReport            YES
End

AutoCTSRootPin   	NIP2_D4/DI
RouteType		CLKSpline
NoGating          	rising
MaxDelay          	5000ps
MinDelay          	0ps
MaxSkew           	10ps
MaxDepth          	100
SinkMaxTran       	500ps
BufMaxTran        	500ps
Buffer			BUFBD2 BUFBD4 BUFBD8 BUFBD12 BUFBD16 INVBD2 INVBD4 INVBD8 INVBD12 INVBD16
RouteClkNet             NO
PostOpt                 YES         # this is the default
DetailReport            YES
End

AutoCTSRootPin   	NIP2_D5/DI
RouteType		CLKSpline
NoGating          	rising
MaxDelay          	5000ps
MinDelay          	0ps
MaxSkew           	10ps
MaxDepth          	100
SinkMaxTran       	500ps
BufMaxTran        	500ps
Buffer			BUFBD2 BUFBD4 BUFBD8 BUFBD12 BUFBD16 INVBD2 INVBD4 INVBD8 INVBD12 INVBD16
RouteClkNet             NO
PostOpt                 YES         # this is the default
DetailReport            YES
End

AutoCTSRootPin   	NIP2_D6/DI
RouteType		CLKSpline
NoGating          	rising
MaxDelay          	5000ps
MinDelay          	0ps
MaxSkew           	10ps
MaxDepth          	100
SinkMaxTran       	500ps
BufMaxTran        	500ps
Buffer			BUFBD2 BUFBD4 BUFBD8 BUFBD12 BUFBD16 INVBD2 INVBD4 INVBD8 INVBD12 INVBD16
RouteClkNet             NO
PostOpt                 YES         # this is the default
DetailReport            YES
End

AutoCTSRootPin   	NIP2_D7/DI
RouteType		CLKSpline
NoGating          	rising
MaxDelay          	5000ps
MinDelay          	0ps
MaxSkew           	10ps
MaxDepth          	100
SinkMaxTran       	500ps
BufMaxTran        	500ps
Buffer			BUFBD2 BUFBD4 BUFBD8 BUFBD12 BUFBD16 INVBD2 INVBD4 INVBD8 INVBD12 INVBD16
RouteClkNet             NO
PostOpt                 YES         # this is the default
DetailReport            YES
End

AutoCTSRootPin   	NIP2_D8/DI
RouteType		CLKSpline
NoGating          	rising
MaxDelay          	5000ps
MinDelay          	0ps
MaxSkew           	10ps
MaxDepth          	100
SinkMaxTran       	500ps
BufMaxTran        	500ps
Buffer			BUFBD2 BUFBD4 BUFBD8 BUFBD12 BUFBD16 INVBD2 INVBD4 INVBD8 INVBD12 INVBD16
RouteClkNet             NO
PostOpt                 YES         # this is the default
DetailReport            YES
End

AutoCTSRootPin   	NIP2_D9/DI
RouteType		CLKSpline
NoGating          	rising
MaxDelay          	5000ps
MinDelay          	0ps
MaxSkew           	10ps
MaxDepth          	100
SinkMaxTran       	500ps
BufMaxTran        	500ps
Buffer			BUFBD2 BUFBD4 BUFBD8 BUFBD12 BUFBD16 INVBD2 INVBD4 INVBD8 INVBD12 INVBD16
RouteClkNet             NO
PostOpt                 YES         # this is the default
DetailReport            YES
End

AutoCTSRootPin   	NIP2_STB/DI
RouteType		CLKSpline
NoGating          	rising
MaxDelay          	5000ps
MinDelay          	0ps
MaxSkew           	10ps
MaxDepth          	100
SinkMaxTran       	500ps
BufMaxTran        	500ps
Buffer			BUFBD2 BUFBD4 BUFBD8 BUFBD12 BUFBD16 INVBD2 INVBD4 INVBD8 INVBD12 INVBD16
RouteClkNet             NO
PostOpt                 YES         # this is the default
DetailReport            YES
End

AutoCTSRootPin   	Itrap2top/rs/U123/Z
RouteType		CLKSpline
NoGating          	rising
MaxDelay          	5000ps
MinDelay          	0ps
MaxSkew           	10ps
MaxDepth          	100
SinkMaxTran       	500ps
BufMaxTran        	500ps
Buffer			BUFBD2 BUFBD4 BUFBD8 BUFBD12 BUFBD16 INVBD2 INVBD4 INVBD8 INVBD12 INVBD16
RouteClkNet             NO
PostOpt                 YES         # this is the default
DetailReport            YES
End


################################################################################
# Port 3
################################################################################

AutoCTSRootPin   	NIP3_D0/DI
RouteType		CLKSpline
NoGating          	rising
MaxDelay          	5000ps
MinDelay          	0ps
MaxSkew           	10ps
MaxDepth          	100
SinkMaxTran       	500ps
BufMaxTran        	500ps
Buffer			BUFBD2 BUFBD4 BUFBD8 BUFBD12 BUFBD16 INVBD2 INVBD4 INVBD8 INVBD12 INVBD16
RouteClkNet             NO
PostOpt                 YES         # this is the default
DetailReport            YES
End

AutoCTSRootPin   	NIP3_D1/DI
RouteType		CLKSpline
NoGating          	rising
MaxDelay          	5000ps
MinDelay          	0ps
MaxSkew           	10ps
MaxDepth          	100
SinkMaxTran       	500ps
BufMaxTran        	500ps
Buffer			BUFBD2 BUFBD4 BUFBD8 BUFBD12 BUFBD16 INVBD2 INVBD4 INVBD8 INVBD12 INVBD16
RouteClkNet             NO
PostOpt                 YES         # this is the default
DetailReport            YES
End

AutoCTSRootPin   	NIP3_D2/DI
RouteType		CLKSpline
NoGating          	rising
MaxDelay          	5000ps
MinDelay          	0ps
MaxSkew           	10ps
MaxDepth          	100
SinkMaxTran       	500ps
BufMaxTran        	500ps
Buffer			BUFBD2 BUFBD4 BUFBD8 BUFBD12 BUFBD16 INVBD2 INVBD4 INVBD8 INVBD12 INVBD16
RouteClkNet             NO
PostOpt                 YES         # this is the default
DetailReport            YES
End

AutoCTSRootPin   	NIP3_D3/DI
RouteType		CLKSpline
NoGating          	rising
MaxDelay          	5000ps
MinDelay          	0ps
MaxSkew           	10ps
MaxDepth          	100
SinkMaxTran       	500ps
BufMaxTran        	500ps
Buffer			BUFBD2 BUFBD4 BUFBD8 BUFBD12 BUFBD16 INVBD2 INVBD4 INVBD8 INVBD12 INVBD16
RouteClkNet             NO
PostOpt                 YES         # this is the default
DetailReport            YES
End

AutoCTSRootPin   	NIP3_D4/DI
RouteType		CLKSpline
NoGating          	rising
MaxDelay          	5000ps
MinDelay          	0ps
MaxSkew           	10ps
MaxDepth          	100
SinkMaxTran       	500ps
BufMaxTran        	500ps
Buffer			BUFBD2 BUFBD4 BUFBD8 BUFBD12 BUFBD16 INVBD2 INVBD4 INVBD8 INVBD12 INVBD16
RouteClkNet             NO
PostOpt                 YES         # this is the default
DetailReport            YES
End

AutoCTSRootPin   	NIP3_D5/DI
RouteType		CLKSpline
NoGating          	rising
MaxDelay          	5000ps
MinDelay          	0ps
MaxSkew           	10ps
MaxDepth          	100
SinkMaxTran       	500ps
BufMaxTran        	500ps
Buffer			BUFBD2 BUFBD4 BUFBD8 BUFBD12 BUFBD16 INVBD2 INVBD4 INVBD8 INVBD12 INVBD16
RouteClkNet             NO
PostOpt                 YES         # this is the default
DetailReport            YES
End

AutoCTSRootPin   	NIP3_D6/DI
RouteType		CLKSpline
NoGating          	rising
MaxDelay          	5000ps
MinDelay          	0ps
MaxSkew           	10ps
MaxDepth          	100
SinkMaxTran       	500ps
BufMaxTran        	500ps
Buffer			BUFBD2 BUFBD4 BUFBD8 BUFBD12 BUFBD16 INVBD2 INVBD4 INVBD8 INVBD12 INVBD16
RouteClkNet             NO
PostOpt                 YES         # this is the default
DetailReport            YES
End

AutoCTSRootPin   	NIP3_D7/DI
RouteType		CLKSpline
NoGating          	rising
MaxDelay          	5000ps
MinDelay          	0ps
MaxSkew           	10ps
MaxDepth          	100
SinkMaxTran       	500ps
BufMaxTran        	500ps
Buffer			BUFBD2 BUFBD4 BUFBD8 BUFBD12 BUFBD16 INVBD2 INVBD4 INVBD8 INVBD12 INVBD16
RouteClkNet             NO
PostOpt                 YES         # this is the default
DetailReport            YES
End

AutoCTSRootPin   	NIP3_D8/DI
RouteType		CLKSpline
NoGating          	rising
MaxDelay          	5000ps
MinDelay          	0ps
MaxSkew           	10ps
MaxDepth          	100
SinkMaxTran       	500ps
BufMaxTran        	500ps
Buffer			BUFBD2 BUFBD4 BUFBD8 BUFBD12 BUFBD16 INVBD2 INVBD4 INVBD8 INVBD12 INVBD16
RouteClkNet             NO
PostOpt                 YES         # this is the default
DetailReport            YES
End

AutoCTSRootPin   	NIP3_D9/DI
RouteType		CLKSpline
NoGating          	rising
MaxDelay          	5000ps
MinDelay          	0ps
MaxSkew           	10ps
MaxDepth          	100
SinkMaxTran       	500ps
BufMaxTran        	500ps
Buffer			BUFBD2 BUFBD4 BUFBD8 BUFBD12 BUFBD16 INVBD2 INVBD4 INVBD8 INVBD12 INVBD16
RouteClkNet             NO
PostOpt                 YES         # this is the default
DetailReport            YES
End

AutoCTSRootPin   	NIP3_STB/DI
RouteType		CLKSpline
NoGating          	rising
MaxDelay          	5000ps
MinDelay          	0ps
MaxSkew           	10ps
MaxDepth          	100
SinkMaxTran       	500ps
BufMaxTran        	500ps
Buffer			BUFBD2 BUFBD4 BUFBD8 BUFBD12 BUFBD16 INVBD2 INVBD4 INVBD8 INVBD12 INVBD16
RouteClkNet             NO
PostOpt                 YES         # this is the default
DetailReport            YES
End

AutoCTSRootPin   	Itrap2top/rs/U124/Z
RouteType		CLKSpline
NoGating          	rising
MaxDelay          	5000ps
MinDelay          	0ps
MaxSkew           	10ps
MaxDepth          	100
SinkMaxTran       	500ps
BufMaxTran        	500ps
Buffer			BUFBD2 BUFBD4 BUFBD8 BUFBD12 BUFBD16 INVBD2 INVBD4 INVBD8 INVBD12 INVBD16
RouteClkNet             NO
PostOpt                 YES         # this is the default
DetailReport            YES
End


################################################################################
# Port 4
################################################################################

AutoCTSRootPin   	Itrap2top/rs/U_port_out/U_delay/U_delaybit_0/U_buffer/Z
RouteType		CLKSpline
NoGating          	rising
MaxDelay          	5000ps
MinDelay          	0ps
MaxSkew           	10ps
MaxDepth          	100
SinkMaxTran       	500ps
BufMaxTran        	500ps
Buffer			BUFBD2 BUFBD4 BUFBD8 BUFBD12 BUFBD16 INVBD2 INVBD4 INVBD8 INVBD12 INVBD16
RouteClkNet             NO
PostOpt                 YES         # this is the default
DetailReport            YES
End

AutoCTSRootPin   	Itrap2top/rs/U_port_out/U_delay/U_delaybit_1/U_buffer/Z
RouteType		CLKSpline
NoGating          	rising
MaxDelay          	5000ps
MinDelay          	0ps
MaxSkew           	10ps
MaxDepth          	100
SinkMaxTran       	500ps
BufMaxTran        	500ps
Buffer			BUFBD2 BUFBD4 BUFBD8 BUFBD12 BUFBD16 INVBD2 INVBD4 INVBD8 INVBD12 INVBD16
RouteClkNet             NO
PostOpt                 YES         # this is the default
DetailReport            YES
End

AutoCTSRootPin   	Itrap2top/rs/U_port_out/U_delay/U_delaybit_2/U_buffer/Z
RouteType		CLKSpline
NoGating          	rising
MaxDelay          	5000ps
MinDelay          	0ps
MaxSkew           	10ps
MaxDepth          	100
SinkMaxTran       	500ps
BufMaxTran        	500ps
Buffer			BUFBD2 BUFBD4 BUFBD8 BUFBD12 BUFBD16 INVBD2 INVBD4 INVBD8 INVBD12 INVBD16
RouteClkNet             NO
PostOpt                 YES         # this is the default
DetailReport            YES
End

AutoCTSRootPin   	Itrap2top/rs/U_port_out/U_delay/U_delaybit_3/U_buffer/Z
RouteType		CLKSpline
NoGating          	rising
MaxDelay          	5000ps
MinDelay          	0ps
MaxSkew           	10ps
MaxDepth          	100
SinkMaxTran       	500ps
BufMaxTran        	500ps
Buffer			BUFBD2 BUFBD4 BUFBD8 BUFBD12 BUFBD16 INVBD2 INVBD4 INVBD8 INVBD12 INVBD16
RouteClkNet             NO
PostOpt                 YES         # this is the default
DetailReport            YES
End

AutoCTSRootPin   	Itrap2top/rs/U_port_out/U_delay/U_delaybit_4/U_buffer/Z
RouteType		CLKSpline
NoGating          	rising
MaxDelay          	5000ps
MinDelay          	0ps
MaxSkew           	10ps
MaxDepth          	100
SinkMaxTran       	500ps
BufMaxTran        	500ps
Buffer			BUFBD2 BUFBD4 BUFBD8 BUFBD12 BUFBD16 INVBD2 INVBD4 INVBD8 INVBD12 INVBD16
RouteClkNet             NO
PostOpt                 YES         # this is the default
DetailReport            YES
End

AutoCTSRootPin   	Itrap2top/rs/U_port_out/U_delay/U_delaybit_5/U_buffer/Z
RouteType		CLKSpline
NoGating          	rising
MaxDelay          	5000ps
MinDelay          	0ps
MaxSkew           	10ps
MaxDepth          	100
SinkMaxTran       	500ps
BufMaxTran        	500ps
Buffer			BUFBD2 BUFBD4 BUFBD8 BUFBD12 BUFBD16 INVBD2 INVBD4 INVBD8 INVBD12 INVBD16
RouteClkNet             NO
PostOpt                 YES         # this is the default
DetailReport            YES
End

AutoCTSRootPin   	Itrap2top/rs/U_port_out/U_delay/U_delaybit_6/U_buffer/Z
RouteType		CLKSpline
NoGating          	rising
MaxDelay          	5000ps
MinDelay          	0ps
MaxSkew           	10ps
MaxDepth          	100
SinkMaxTran       	500ps
BufMaxTran        	500ps
Buffer			BUFBD2 BUFBD4 BUFBD8 BUFBD12 BUFBD16 INVBD2 INVBD4 INVBD8 INVBD12 INVBD16
RouteClkNet             NO
PostOpt                 YES         # this is the default
DetailReport            YES
End

AutoCTSRootPin   	Itrap2top/rs/U_port_out/U_delay/U_delaybit_7/U_buffer/Z
RouteType		CLKSpline
NoGating          	rising
MaxDelay          	5000ps
MinDelay          	0ps
MaxSkew           	10ps
MaxDepth          	100
SinkMaxTran       	500ps
BufMaxTran        	500ps
Buffer			BUFBD2 BUFBD4 BUFBD8 BUFBD12 BUFBD16 INVBD2 INVBD4 INVBD8 INVBD12 INVBD16
RouteClkNet             NO
PostOpt                 YES         # this is the default
DetailReport            YES
End

AutoCTSRootPin   	Itrap2top/rs/U_port_out/U_delay/U_delaybit_8/U_buffer/Z
RouteType		CLKSpline
NoGating          	rising
MaxDelay          	5000ps
MinDelay          	0ps
MaxSkew           	10ps
MaxDepth          	100
SinkMaxTran       	500ps
BufMaxTran        	500ps
Buffer			BUFBD2 BUFBD4 BUFBD8 BUFBD12 BUFBD16 INVBD2 INVBD4 INVBD8 INVBD12 INVBD16
RouteClkNet             NO
PostOpt                 YES         # this is the default
DetailReport            YES
End

AutoCTSRootPin   	Itrap2top/rs/U_port_out/U_delay/U_delaybit_9/U_buffer/Z
RouteType		CLKSpline
NoGating          	rising
MaxDelay          	5000ps
MinDelay          	0ps
MaxSkew           	10ps
MaxDepth          	100
SinkMaxTran       	500ps
BufMaxTran        	500ps
Buffer			BUFBD2 BUFBD4 BUFBD8 BUFBD12 BUFBD16 INVBD2 INVBD4 INVBD8 INVBD12 INVBD16
RouteClkNet             NO
PostOpt                 YES         # this is the default
DetailReport            YES
End

AutoCTSRootPin   	Itrap2top/rs/U_port_out/U_delay/U_delaybit_10/U_buffer/Z
RouteType		CLKSpline
NoGating          	rising
MaxDelay          	5000ps
MinDelay          	0ps
MaxSkew           	10ps
MaxDepth          	100
SinkMaxTran       	500ps
BufMaxTran        	500ps
Buffer			BUFBD2 BUFBD4 BUFBD8 BUFBD12 BUFBD16 INVBD2 INVBD4 INVBD8 INVBD12 INVBD16
RouteClkNet             NO
PostOpt                 YES         # this is the default
DetailReport            YES
End

AutoCTSRootPin   	Itrap2top/rs/U_port_out/U_delay/U_delaybit_11/U_buffer/Z
RouteType		CLKSpline
NoGating          	rising
MaxDelay          	5000ps
MinDelay          	0ps
MaxSkew           	10ps
MaxDepth          	100
SinkMaxTran       	500ps
BufMaxTran        	500ps
Buffer			BUFBD2 BUFBD4 BUFBD8 BUFBD12 BUFBD16 INVBD2 INVBD4 INVBD8 INVBD12 INVBD16
RouteClkNet             NO
PostOpt                 YES         # this is the default
DetailReport            YES
End

AutoCTSRootPin   	NIP4_CTL/DI
RouteType		CLKSpline
NoGating          	rising
MaxDelay          	5000ps
MinDelay          	0ps
MaxSkew           	10ps
MaxDepth          	100
SinkMaxTran       	500ps
BufMaxTran        	500ps
Buffer			BUFBD2 BUFBD4 BUFBD8 BUFBD12 BUFBD16 INVBD2 INVBD4 INVBD8 INVBD12 INVBD16
RouteClkNet             NO
PostOpt                 YES         # this is the default
DetailReport            YES
End
