#
# read in design, and generate gds output file
#
encMessage warning 0
encMessage debug 0
encMessage info 0
restoreDesign ./OUTPUT/ENC/RouteF2GDSout.enc.dat top_pad 1 1 0
setDrawMode fplan
encMessage warning 1
encMessage debug 0
encMessage info 1

#saveNetlist ./gdsout/top_pad_final.v
fillNotch -reportfile notchFill.log

#
# stream everything out without filler cells
#
streamOut OUTPUT/GDS/top_pad_nofill.gds -mapFile CFG/streamOut.map -libName DesignLib \
-structureName top_pad -merge { \
  ./GDS/CHIPIOSTCELLS.gds ./GDS/CORECELLS.gds \
  ./GDS/ADC.gds ./GDS/R256X39M8.gds \
  ./GDS/R128X16M1.gds ./GDS/R4096X30M16.gds ./GDS/event_buffer_memory.gds \
  ./GDS/vvdd_dm.gds ./GDS/chip_id.gds ./GDS/i1200o4800d5.gds \
  ./GDS/DMEM_BLOCK.gds \
  ./GDS/BPADSall.gds ./GDS/LVDSCells.gds } \
-stripes 1 -units 1000 -mode ALL


#
# Note: the fillers are added at this point only since for initial LVS it is quite useful
#       not to have them. (see above)
#
deleteAllRouteBlks

addFiller -cell SpareStripeBLK -prefix spare -area  875.55 1081		899.75 1821
addFiller -cell SpareStripeBLK -prefix spare -area  875.55 4426		899.75 5930

addFiller -cell SpareStripeBLK -prefix spare -area  1172.55 1081	1195.75 1821
addFiller -cell SpareStripeBLK -prefix spare -area  1172.55 4426	1195.75 5930

addFiller -cell SpareStripeBLK -prefix spare -area  1511.13 1444	1534.33 5930

addFiller -cell SpareStripeBLK -prefix spare -area  1776.79 1444	1798.99 5930

addFiller -cell SpareStripeBLK -prefix spare -area  2096.89 1444	2118.09 5930

addFiller -cell SpareStripeBLK -prefix spare -area  2376.73 1444	2397.93 5930


addFiller -cell SpareStripeBLK -prefix spare -area  2621.25 1444	2644.45 5930

addFiller -cell SpareStripeBLK -prefix spare -area  2980.29 1444	3003.49 5646

addFiller -cell SpareStripeBLK -prefix spare -area  3241.10 1475	3264.19 5646

addFiller -cell SpareStripeBLK -prefix spare -area  3623.13 3151	3646.99 5646

addFiller -cell SpareStripeBLK -prefix spare -area  3868.33 3151	3889.53 5646

addFiller -cell SpareStripeBLK -prefix spare -area  4121.77 3151	4142.97 5646

#
# now add the basic filler cells
#


addFiller -cell FILL16 -prefix corefill -fillBoundary
addFiller -cell FILL8  -prefix corefill -fillBoundary
addFiller -cell FILL4  -prefix corefill -fillBoundary
addFiller -cell FILL2  -prefix corefill -fillBoundary
addFiller -cell FILL1  -prefix corefill -fillBoundary

streamOut OUTPUT/GDS/top_pad.gds -mapFile CFG/streamOut.map -libName DesignLib \
-structureName top_pad -merge { \
  ./GDS/CHIPIOSTCELLS.gds ./GDS/CORECELLS.gds \
  ./GDS/ADC.gds ./GDS/R256X39M8.gds \
  ./GDS/R128X16M1.gds ./GDS/R4096X30M16.gds ./GDS/event_buffer_memory.gds \
  ./GDS/vvdd_dm.gds ./GDS/chip_id.gds ./GDS/i1200o4800d5.gds \
  ./GDS/DMEM_BLOCK.gds ./GDS/SpareStripeBLK.gds\
  ./GDS/BPADSall.gds ./GDS/LVDSCells.gds } \
-stripes 1 -units 1000 -mode ALL

# VoLi 20040401: according to Christian Reichling is the metall fill not a good
#                working too well here. We skip that here.

saveDesign ./OUTPUT/ENC/GDSout.enc
exit

#
# Fill metal in order to achieve the minimum metal design rule. Connect all
# metal to VSS. Make it nice squares
#

setMetalFill -layer 1 -minLength 10 -maxLength 20 -minWidth 10 -maxWidth 20     \
             -activeSpacing 3 -gapSpacing 1 -minDensity 90                      \
             -windowSize 100 100 -windowStep 50 50
setMetalFill -layer 2 -minLength 10 -maxLength 20 -minWidth 10 -maxWidth 20     \
             -activeSpacing 3 -gapSpacing 1 -minDensity 90                      \
             -windowSize 100 100 -windowStep 50 50
setMetalFill -layer 3 -minLength 10 -maxLength 20 -minWidth 10 -maxWidth 20     \
             -activeSpacing 3 -gapSpacing 1 -minDensity 90                      \
             -windowSize 100 100 -windowStep 50 50
setMetalFill -layer 4 -minLength 10 -maxLength 20 -minWidth 10 -maxWidth 20     \
             -activeSpacing 3 -gapSpacing 1 -minDensity 90                      \
             -windowSize 100 100 -windowStep 50 50
setMetalFill -layer 5 -minLength 10 -maxLength 20 -minWidth 10 -maxWidth 20     \
             -activeSpacing 3 -gapSpacing 1 -minDensity 90                      \
             -windowSize 100 100 -windowStep 50 50
setMetalFill -layer 6 -minLength 10 -maxLength 20 -minWidth 10 -maxWidth 20     \
             -activeSpacing 3 -gapSpacing 1 -minDensity 90                      \
             -windowSize 100 100 -windowStep 50 50

addMetalFill -nets {VSS GND} -removeFloatingFill


#
# stream everything out
#
streamOut OUTPUT/GDS/top_pad_metalFill.gds -mapFile CFG/streamOut.map -libName DesignLib \
-structureName top_pad -merge { \
  ./GDS/CHIPIOSTCELLS.gds ./GDS/CORECELLS.gds \
  ./GDS/ADC.gds ./GDS/R256X39M8.gds \
  ./GDS/R128X16M1.gds ./GDS/R4096X30M16.gds ./GDS/event_buffer_memory.gds \
  ./GDS/vvdd_dm.gds ./GDS/chip_id.gds ./GDS/i1200o4800d5.gds \
  ./GDS/DMEM_BLOCK.gds ./GDS/SpareStripeBLK.gds \
  ./GDS/BPADSall.gds ./GDS/LVDSCells.gds } \
-stripes 1 -units 1000 -mode ALL

saveDesign ./OUTPUT/ENC/GDSout.enc
exit
