exec date -R

encMessage warning 0
encMessage debug 0
encMessage info 0
restoreDesign ./OUTPUT/ENC/CTSFinal.enc.dat top_pad 1 1 0
setDrawMode fplan
encMessage warning 1
encMessage debug 0
encMessage info 1

#
# Prepare and perform In-Place Optimization
#

source SCRIPTS/setOpCond.tcl
specifyClockTree -clkfile ./CFG/CTS/routeTypes.cts
specifyClockTree -clkfile ./CFG/CTS/top_pad_masterCLK.cts
# these misc. clocks are already generated and are specified here
# so that they are not touched by the optimizer
specifyClockTree -clkfile ./CFG/CTS/top_pad_miscCLK.cts
specifyClockTree -clkfile ./CFG/CTS/top_pad_niPorts.cts
setTrialRouteMode -highEffort -maxRouteLayer 6 -guide OUTPUT/CTS/top_pad_cts.guide

setAnalysisMode -setup -noAsync -skew -autoDetectClockTree 

trialRoute
extractRC
freeTimingGraph
buildTimingGraph
reportClock

reportSlacks        -outfile ./REPORTS/IPOpostCTS/top_pad.slk
reportViolation     -outfile ./REPORTS/IPOpostCTS/top_pad.tarpt  -num 1000 -longForm
reportViolation     -outfile ./REPORTS/IPOpostCTS/top_pad.tasrpt -num 1000 -shortForm
reportTranViolation -outfile ./REPORTS/IPOpostCTS/top_pad.tran   -noGlobalNets -excNetFile ./CFG/TranExcl.ntf


#
# IPO fixing setup violation:
# in order to avoid ambiguities all relevant defaults are set here explicitly
#
setIPOMode -highEffort -Restruct -SwapPin -addPortAsNeeded -targetSlack 0.5     \
        -maxDensity 0.95 -fixDRC -fixFanoutLoad -addInst       \
        -deleteInst -downsizeInst -optimizeFF -reclaimArea -restruct            \
        -swapPin -incrTrialRoute -usefulSkew -moveInst

initECO
skewClock
optCritPath
saveDesign  ./OUTPUT/ENC/IPOpostCTSopt1.enc

optCritPath
saveDesign  ./OUTPUT/ENC/IPOpostCTSopt2.enc

optCritPath
saveDesign  ./OUTPUT/ENC/IPOpostCTSopt3.enc

# this is not needed any more if hold time fixing is not done
extractRC
freeTimingGraph
buildTimingGraph

reportSlacks        -outfile ./REPORTS/IPOpostCTS/top_pad_ipoSFix.slk
reportViolation     -outfile ./REPORTS/IPOpostCTS/top_pad_ipoSFix.tarpt  -num 1000 -longForm
reportViolation     -outfile ./REPORTS/IPOpostCTS/top_pad_ipoSFix.tasrpt -num 1000 -shortForm
reportTranViolation -outfile ./REPORTS/IPOpostCTS/top_pad_ipoSFix.tran   -noGlobalNets -excNetFile ./CFG/TranExcl.ntf


#
# IPO fixing hold violation:
# in order to avoid ambiguities all relevant defaults are set here explicitly
#
# WARNING: the hold time fixer used here with the same arguments as successfully
#          run for ATOLL in Mannheim completely screws the design, causing 100%
#          routing congestion. Since there are basically no hold time problems
#	   in this design we skip this step, in order to avoid debuggint FE3.2
#

#setAnalysisMode -hold -noAsync -skew -autoDetectClockTree 
#setBufFootPrint BUFBD
#setDelayFootPrint DLY1D
#buildTimingGraph
#
# if enabled this command completely destroys the design
#setIPOMode -highEffort -SwapPin -addPortAsNeeded -targetSlack 0.5     \
#        -maxDensity 0.95 -noFixDRC -noFixFanoutLoad -addInst          \
#        -deleteInst -downsizeInst -optimizeFF -restruct            \
#        -swapPin -incrTrialRoute
#
#fixHoldViolation
#saveDesign  ./OUTPUT/ENC/IPOpostCTSHopt.enc
#
#reportSlacks        -outfile ./REPORTS/IPOpostCTS/top_pad_ipoHFix.slk
#reportViolation     -outfile ./REPORTS/IPOpostCTS/top_pad_ipoHFix.tarpt  -num 1000 -longForm
#reportViolation     -outfile ./REPORTS/IPOpostCTS/top_pad_ipoHFix.tasrpt -num 1000 -shortForm
#reportTranViolation -outfile ./REPORTS/IPOpostCTS/top_pad_ipoHFix.tran	-noGlobalNets -excNetFile ./CFG/TranExcl.ntf

# those statements are executed in niPortCTS now, overwriting the results here
# I save the cpu time skipping it
#setAnalysisMode -setup -noAsync -skew -autoDetectClockTree 

#trialRoute
#extractRC
#freeTimingGraph
#buildTimingGraph
#reportClock

#reportSlacks        -outfile ./REPORTS/IPOpostCTS/top_pad_ipoFinal.slk
#reportViolation     -outfile ./REPORTS/IPOpostCTS/top_pad_ipoFinal.tarpt  -num 1000 -longForm
#reportViolation     -outfile ./REPORTS/IPOpostCTS/top_pad_ipoFinal.tasrpt -num 1000 -shortForm
#reportTranViolation -outfile ./REPORTS/IPOpostCTS/top_pad_ipoFinal.tran   -noGlobalNets -excNetFile ./CFG/TranExcl.ntf

#saveNetlist ./OUTPUT/NETLIST/top_pad_IPOpostCTS.v
#saveDesign  ./OUTPUT/ENC/IPOpostCTSFinal.enc
#saveDesign  ./OUTPUT/ENC/RouteIN.enc


exec date -R
exit
