exec date -R

#
# Note: FixDRCviolation core dumps if the IO signals are constrained with max
#       delays. The rest works fine. Therefore we use here the full timing
#       constraint file.
#

encMessage warning 0
encMessage debug 0
encMessage info 0
restoreDesign ./OUTPUT/ENC/IPOtranFinal.enc.dat top_pad 1 1 0
setDrawMode fplan
encMessage warning 1
encMessage debug 0
encMessage info 1



# create some extra spacing for the clock buffers to be inserted without large
# placement changes after CTS
# Note: this setting is not carried by saveDesign
source ./SCRIPTS/setCellPadding.tcl

#
# Prepare and perform In-Place Optimization
#

source SCRIPTS/setOpCond.tcl
specifyClockTree -clkfile ./CFG/CTS/routeTypes.cts
specifyClockTree -clkfile ./CFG/CTS/top_pad_masterCLK.cts
# these misc. clocks are already generated and are specified here
# so that they are not touched by the optimizer
specifyClockTree -clkfile ./CFG/CTS/top_pad_miscCLK.cts
specifyClockTree -clkfile ./CFG/CTS/top_pad_niPorts.cts
setAnalysisMode -setup -noAsync -noSkew -noClockTree
setTrialRouteMode -highEffort -maxRouteLayer 6 

trialRoute
extractRC
freeTimingGraph
buildTimingGraph
reportClock

reportSlacks	    -outfile ./REPORTS/IPOpreCTS/top_pad.slk
reportViolation     -outfile ./REPORTS/IPOpreCTS/top_pad.tarpt  -num 1000 -longForm
reportViolation     -outfile ./REPORTS/IPOpreCTS/top_pad.tasrpt -num 1000 -shortForm
reportTranViolation -outfile ./REPORTS/IPOpreCTS/top_pad.tran	-noGlobalNets  -excNetFile ./CFG/TranExcl.ntf


#
# IPO fixing setup violation:
# in order to avoid ambiguities all relevant defaults are set here explicitly
#
# Note: many of the options below are the default and specified here explicitly
#       for clarity and to ensure that the behavior is persistent accross version
#       changes
#
# ## check whether disabling optimizeConstantNet helps
#
setIPOMode -highEffort -Restruct -SwapPin -addPortAsNeeded -targetSlack 0.5	\
	-maxDensity 0.80 -fixDRC -fixFanoutLoad -addInst -addPortAsNeeded	\
	-deleteInst -downsizeInst -optimizeFF -reclaimArea -restruct		\
	-swapPin -incrTrialRoute -moveInst -optimizeAssignNet	\
	-noOptimizeConstantNet

initECO

# now give some extra space for the actual timing fixing
setIPOMode -maxDensity 0.90
fixSetupViolation
saveDesign ./OUTPUT/ENC/IPOpreCTSSetupFix.enc

# if some critical nets remain the following command focuses on those and improves
# tem further
optCritPath
saveDesign ./OUTPUT/ENC/IPOpreCTSopt1.enc

optCritPath
saveDesign ./OUTPUT/ENC/IPOpreCTSopt2.enc

optCritPath
saveDesign ./OUTPUT/ENC/IPOpreCTSopt3.enc


# this is done incrementally during IPO
#trialRoute -maxRouteLayer 6 -highEffort
extractRC
freeTimingGraph
buildTimingGraph

reportSlacks        -outfile ./REPORTS/IPOpreCTS/top_pad_ipo.slk
reportViolation     -outfile ./REPORTS/IPOpreCTS/top_pad_ipo.tarpt  -num 1000 -longForm
reportViolation     -outfile ./REPORTS/IPOpreCTS/top_pad_ipo.tasrpt -num 1000 -shortForm
reportTranViolation -outfile ./REPORTS/IPOpreCTS/top_pad_ipo.tran   -noGlobalNets  -excNetFile ./CFG/TranExcl.ntf

saveDesign ./OUTPUT/ENC/IPOpreCTSFinal.enc
exec date -R
exit
