exec date -R

encMessage warning 0
encMessage debug 0
encMessage info 0
restoreDesign ./OUTPUT/ENC/PlaceFinal.enc.dat top_pad 1 1 0
setDrawMode fplan
encMessage warning 1
encMessage debug 0
encMessage info 1


# create some extra spacing for the clock buffers to be inserted without large
# placement changes after CTS
# Note: this setting is not carried by saveDesign
source ./SCRIPTS/setCellPadding.tcl

#
# Prepare and perform In-Place Optimization
#

source SCRIPTS/setOpCond.tcl
# the script above by default selects detailed timing extraction, which is not
# making sense just for maxCap, maxTran DRC repairing
# we reset here to basic timing analysis. 
setExtractRCMode -default

specifyClockTree -clkfile ./CFG/CTS/routeTypes.cts
specifyClockTree -clkfile ./CFG/CTS/top_pad_miscCLK.cts
specifyClockTree -clkfile ./CFG/CTS/top_pad_niPorts.cts
setAnalysisMode -setup -noAsync -noSkew -noClockTree
setTrialRouteMode -highEffort -maxRouteLayer 6 


#
# generate the RESET trees using the clock generation tool
# this is essential for the transition violation fix as all asynchronous RESETs
# will generate nets, which are driven slow and therefore result irreparably 
# slow. 
#

checkUnique
reportClock
ckSynthesis -report ./REPORTS/IPOtran/top_pad_res.ctsrpt -dontFixAddedBuffers
saveDesign ./OUTPUT/ENC/IPOtranCLK.enc

reportTranViolation -outfile ./REPORTS/IPOtran/top_pad.tran	-noGlobalNets  -excNetFile ./CFG/TranExcl.ntf

# the max transition and max Capacity fixing severely affects the design - do this
# first before optimizing the timing.
# 

#setIPOMode -highEffort -Restruct -SwapPin -addPortAsNeeded -targetSlack 0.5	\
setIPOMode -highEffort -Restruct -swapPin -targetSlack 0.5	\
	-maxDensity 0.80 -fixDRC -fixFanoutLoad -addInst	\
	-deleteInst -downsizeInst -optimizeFF -reclaimArea	\
	-noPreserveRoute -moveInst -optimizeAssignNet	\
	-noOptimizeConstantNet
initECO ECO.log

# in the following maxFanout maxCap and maxTran are done one 
fixDRCViolation -excNetFile ./CFG/TranExcl.ntf -maxFanout -maxCap -maxTran -maxIter 5

endECO

trialRoute
extractRC
freeTimingGraph
buildTimingGraph
reportClock

reportSlacks        -outfile ./REPORTS/IPOtran/top_pad_tran.slk
reportViolation     -outfile ./REPORTS/IPOtran/top_pad_tran.tarpt  -num 1000 -longForm
reportViolation     -outfile ./REPORTS/IPOtran/top_pad_tran.tasrpt -num 1000 -shortForm
reportTranViolation -outfile ./REPORTS/IPOtran/top_pad_tran.tran   -noGlobalNets  -excNetFile ./CFG/TranExcl.ntf

saveDesign ./OUTPUT/ENC/IPOtranFinal.enc

exec date -R
exit
