#
# Add some TIEHI/TIELO components to ease the routing of those static nets
#
addTieHiLo -cell TIEHI -tieHiPin Z -prefix FPTIEHI -row 20 -col 5
addTieHiLo -cell TIELO -tieLoPin Z -prefix FPTIELO -row 20 -col 5


#
# POWER Plan
#


connectToGlobalNet -tie_highs_lows 0 -to_global_net VSS -verbose 1 	\
	-override_prior_global_connection 0 -in_instances * -nets {} 	\
	-pins VSS -connect Pins -under_module {}
connectToGlobalNet -tie_highs_lows 0 -to_global_net VDD -verbose 1 	\
	-override_prior_global_connection 0 -in_instances * -nets {} 	\
	-pins VDD -connect Pins -under_module {}
connectToGlobalNet -tie_highs_lows 0 -to_global_net VDD_DM -verbose 1 	\
	-override_prior_global_connection 0 -in_instances * -nets {} 	\
	-pins VDD_DM -connect Pins -under_module {}
connectToGlobalNet -tie_highs_lows 0 -to_global_net V0IO -verbose 1 	\
	-override_prior_global_connection 0 -in_instances * -nets {} 	\
	-pins V0IO -connect Pins -under_module {}
connectToGlobalNet -tie_highs_lows 0 -to_global_net V3IO -verbose 1 	\
	-override_prior_global_connection 0 -in_instances * -nets {} 	\
	-pins V3IO -connect Pins -under_module {}


#
# Cut standard cell rows around macros:
#
cutCoreRow
clearCutRow


#
# Add Core rings:
#

addRing -width_left   20  -width_right   20  -width_top   20  -width_bottom   20 	\
        -spacing_left  3  -spacing_right  3  -spacing_top  3  -spacing_bottom  3 	\
        -offset_left   3  -offset_right   3  -offset_top   3  -offset_bottom   3 	\
	-layer_left MET2 -layer_right MET2 -layer_top MET1 -layer_bottom MET1    	\
	-around core -jog_distance 0.66 -threshold 0.66 -nets {VDD VSS}			\
	-snap_wire_center_to_grid {Grid} -center 1 

#
# Horizontal stripes:
# this needs to be done here in order for th M5 stripes to all the way from 
# ring to ring
#
addStripe -direction horizontal -start_y 3104.00 -stop_y 3175 -width 20   		\
	-nets {VDD VSS} -number_of_sets 1 -layer MET5 -spacing 3 			\
	-merge_stripes_value 0.66  -snap_wire_center_to_grid {Grid}
addStripe -direction horizontal -start_y 1829.00 -stop_y 1875 -width 20   		\
	-nets {VSS VDD} -number_of_sets 1 -layer MET5 -spacing 3  			\
	-merge_stripes_value 0.66 -snap_wire_center_to_grid {Grid}

#
# Add block rings:
#

selectInst Itrap2top/fl/im0/d0
selectInst Itrap2top/fl/im1/d0
addRing -type block_rings -around shared_cluster -nets {VDD VSS}			\
	-tl 1 -bl 1 -left 0 								\
	-width_top  20  -width_bottom  20  -width_left  20  -width_right  20	   	\
	-spacing_top 3  -spacing_bottom 3  -spacing_left 3  -spacing_right 3		\
	-offset_top  3  -offset_bottom  3  -offset_left  3  -offset_right  3		\
	-layer_top MET3 -layer_bottom MET3 -layer_left MET2 -layer_right MET2		\
	-jog_distance 0.66 -bl 1 -threshold 0.66  					\
	-snap_wire_center_to_grid {Grid}
addRing -type block_rings -around shared_cluster -nets {VDD VSS}			\
	-tl 1 -bl 1 -left 0 								\
	-width_top  20  -width_bottom  20  -width_left  20  -width_right  20	   	\
	-spacing_top 3  -spacing_bottom 3  -spacing_left 3  -spacing_right 3		\
	-offset_top  3  -offset_bottom  3  -offset_left  3  -offset_right  3		\
	-layer_top MET5 -layer_bottom MET5 -layer_left MET4 -layer_right MET4		\
	-jog_distance 0.66 -bl 1 -threshold 0.66  					\
	-snap_wire_center_to_grid {Grid}
deselectAll

selectInst Itrap2top/fl/im3/d0
addRing -type block_rings -around selected -nets {VDD VSS}				\
	-tr 1 -lb 1 -br 1 -right 0							\
	-width_top  20  -width_bottom  20  -width_left  20  -width_right  20	   	\
	-spacing_top 3  -spacing_bottom 3  -spacing_left 3  -spacing_right 3		\
	-offset_top  3  -offset_bottom  3  -offset_left  3  -offset_right  3		\
	-layer_top MET3 -layer_bottom MET3 -layer_left MET2 -layer_right MET2		\
	-jog_distance 0.66 -bl 1 -threshold 0.66  					\
	-snap_wire_center_to_grid {Grid}
addRing -type block_rings -around selected -nets {VDD VSS}				\
	-tr 1 -lb 1 -br 1 -right 0							\
	-width_top  20  -width_bottom  20  -width_left  20  -width_right  20	   	\
	-spacing_top 3  -spacing_bottom 3  -spacing_left 3  -spacing_right 3		\
	-offset_top  3  -offset_bottom  3  -offset_left  3  -offset_right  3		\
	-layer_top MET5 -layer_bottom MET5 -layer_left MET4 -layer_right MET4		\
	-jog_distance 0.66 -bl 1 -threshold 0.66  					\
	-snap_wire_center_to_grid {Grid}
deselectAll
clearDrc

# IM2 is done implicitly here by extending right and bottom

#
# now back the horizontal M3 rings around IMEM with M1
#
setEdit -nets VDD -width_horizontal 20 -width_vertical 20 -shape BLOCKRING		\
	-layer_vertical M2 -layer_horizontal M1 

# IM1 bottom
setEdit -nets VDD 
editAddRoute     576.85 1862.88
editCommitRoute 1363.77 1862.88
setEdit -nets VSS
editAddRoute     553.75 1839.36
editCommitRoute 1328.83 1839.36
setEdit -nets VSS -shape BLOCKWIRE 
editAddRoute    1305    1849.36
editCommitRoute 1305    1829.36

# IM0/IM1 gap
setEdit -nets VDD -shape BLOCKRING
editAddRoute     576.85 3114.48
editCommitRoute 1363.77 3114.48
setEdit -nets VSS
editAddRoute     553.75 3138.00
editCommitRoute 1328.83 3138.00
setEdit -nets VSS -shape BLOCKWIRE 
editAddRoute    1305    3148.00
editCommitRoute 1305    3128.00

# IM0 top
setEdit -nets VSS -shape BLOCKRING
editAddRoute     553.75 4412.56
editCommitRoute 1328.83 4412.56
setEdit -nets VDD
editAddRoute     576.85 4389.04
editCommitRoute 1363.77 4389.04
setEdit -nets VSS -shape BLOCKWIRE 
editAddRoute    1305    4422.56
editCommitRoute 1305    4402.56

# IM3 top
setEdit -nets VSS -shape BLOCKRING
editAddRoute    3671.71 3137.44
editCommitRoute 4446.63 3137.44
setEdit -nets VDD
editAddRoute    3636.61 3113.92
editCommitRoute 4423.53 3113.92
setEdit -nets VSS -shape BLOCKWIRE 
editAddRoute    3695    3147.44
editCommitRoute 3695    3127.44

# IM2/IM3 gap
setEdit -nets VSS -shape BLOCKRING
editAddRoute    3671.71 1839.36
editCommitRoute 4446.63 1839.36
setEdit -nets VDD
editAddRoute    3636.61 1862.88
editCommitRoute 4423.53 1862.88
setEdit -nets VSS -shape BLOCKWIRE 
editAddRoute    3695    1849.36
editCommitRoute 3695    1829.36

uiSetTool select
deselectAll


# the TM FiFo memories
windowSelect 593.555 1067.377 1220.288 578.846
addRing -type block_rings -around cluster -nets {VDD VSS}				\
	-rb 1 -tl 1 -left 0 -bottom 0 -rectangle 1					\
	-width_top  10  -width_bottom  10  -width_left  10  -width_right  10	   	\
	-spacing_top 3  -spacing_bottom 3  -spacing_left 3  -spacing_right 3		\
	-offset_top  3  -offset_bottom  3  -offset_left  3  -offset_right  3		\
	-layer_top MET3 -layer_bottom MET3 -layer_left MET2 -layer_right MET2		\
	-jog_distance 0.66 -bl 1 -threshold 0.66  					\
	-snap_wire_center_to_grid {Grid}
deselectAll

# the top right EventBuf block
windowSelect 4118.482 5463.767 4424.550 4402.870
addRing -type block_rings -around cluster -nets {VDD VSS}				\
	-tr 1 -br 1 -right 0                           					\
	-width_top  10  -width_bottom  10  -width_left  10  -width_right  10	   	\
	-spacing_top 3  -spacing_bottom 3  -spacing_left 3  -spacing_right 3		\
	-offset_top  3  -offset_bottom  3  -offset_left  3  -offset_right  3		\
	-layer_top MET3 -layer_bottom MET3 -layer_left MET2 -layer_right MET2		\
	-jog_distance 0.66 -bl 1 -threshold 0.66  					\
	-snap_wire_center_to_grid {Grid}
deselectAll

# the top EventBuf block
windowSelect 2714.378 5956.266 4438.613 5645.126
addRing -type block_rings -around cluster -nets {VDD VSS}				\
	-lt 1 -br 1 -top 0 -right 0                   					\
	-width_top  10  -width_bottom  10  -width_left  10  -width_right  10	   	\
	-spacing_top 3  -spacing_bottom 3  -spacing_left 3  -spacing_right 3		\
	-offset_top  3  -offset_bottom  3  -offset_left  3  -offset_right  3		\
	-layer_top MET3 -layer_bottom MET3 -layer_left MET2 -layer_right MET2		\
	-jog_distance 0.66 -bl 1 -threshold 0.66  					\
	-snap_wire_center_to_grid {Grid}
deselectAll


selectInst Itrap2top/fl/dm/d0
addRing -type block_rings -around selected -nets {VDD VSS}				\
	-lb 1 -rb 1 -bottom 0 								\
	-width_top  10  -width_bottom  10  -width_left  10  -width_right  10	   	\
	-spacing_top 3  -spacing_bottom 3  -spacing_left 3  -spacing_right 3		\
	-offset_top  3  -offset_bottom  3  -offset_left  3  -offset_right  3		\
	-layer_top MET3 -layer_bottom MET3 -layer_left MET2 -layer_right MET2		\
	-jog_distance 0.66 -bl 1 -threshold 0.66  					\
	-snap_wire_center_to_grid {Grid}
deselectAll

#
# the particular stripe below is required in order to have the single port memory below connect to it properly
#
addStripe -direction vertical -start_x 3240.99 -stop_x 3280 -width 10			\
	-nets {VDD VSS} -number_of_sets 1 -layer MET2 -spacing 3 			\
	-break_stripes_at_block_rings 1 -merge_stripes_value 0.66    			\
	-snap_wire_center_to_grid {Grid} 
deselectAll

# the global mailbox memory
selectInst Itrap2top/fl/cc/db/d0
# this command does not connect to the stripe - we fix that manually below
addRing -type block_rings -around selected -nets {VDD VSS}				\
	-rb 1 -tl 1 -left 0 -bottom 0							\
	-width_top  10  -width_bottom  10  -width_left  10  -width_right  10	   	\
	-spacing_top 3  -spacing_bottom 3  -spacing_left 3  -spacing_right 3		\
	-offset_top  3  -offset_bottom  3  -offset_left  3  -offset_right  3		\
	-layer_top MET3 -layer_bottom MET3 -layer_left MET2 -layer_right MET2		\
	-jog_distance 0.66 -bl 1 -threshold 0.66  					\
	-snap_wire_center_to_grid {Grid}
deselectAll
clearDrc


#
# some manual patching remaines to extend the power rings for proper core connection
#
setEdit -nets VDD -width_horizontal 20 -width_vertical 20 -shape BLOCKRING		\
	-layer_vertical M2 -layer_horizontal M1 

# extend inner VDD ring wire to allow easy core row connection at IM0
editAddRoute    1353.77 4367.00
editCommitRoute 1353.77 4422.56
# same at bottom of IM1
editAddRoute    1353.77 1877.00
editCommitRoute 1353.77 1829.36
setEdit -nets VSS
editAddRoute    1376.87 1832.00
editCommitRoute 1376.87 1826.02
# same at top of IM3   
setEdit -nets VDD
editAddRoute    3646.61 3085.00
editCommitRoute 3646.61 3147.44
# memory db
setEdit -nets VDD -width_horizontal 10 -width_vertical 10 
editAddRoute    3461.15 1446.00
editCommitRoute 3461.15 1476.38
setEdit -nets VSS
editAddRoute    3474.35 1459.00
editCommitRoute 3474.35 1476.38



# event buffer channel 00 (lower left corner)
setEdit -nets VDD -width_horizontal 10 -width_vertical 10 -shape BLOCKRING		\
	-layer_vertical M2 -layer_horizontal M3 
editAddRoute    2739.11 5680.00
editCommitRoute 2739.11 5649.00
# event buffer channel 13 (top left corner)
setEdit -nets VSS
editAddRoute    4125.77 4444.00
editCommitRoute 4125.77 5475.00
# event buffer channel 20 (lower left corner)
setEdit -nets VDD
editAddRoute    4138.97 4430.00
editCommitRoute 4138.97 4403.00
setEdit -nets VSS
editAddRoute    4125.77 4430.00
editCommitRoute 4125.77 4400.00
# TM FiFo 3 (upper right corner)
setEdit -nets VDD
editAddRoute    1177.55 1045.00
editCommitRoute 1177.55 1073.00
setEdit -nets VSS
editAddRoute    1190.75 1045.00
editCommitRoute 1190.75 1077.00
# DMEM (upper left corner)
setEdit -nets VDD
editAddRoute    1529.33 1401.00
editCommitRoute 1529.33 1441.00
setEdit -nets VSS
editAddRoute    1516.13 1401.00
editCommitRoute 1516.13 1436.00

# connect the top horizontal row of mailbox memory to vertical stripe (somehow does not done automatically)
setEdit -nets VSS
editAddRoute    3280.00 1456.32
editCommitRoute 3254.19 1456.32
setEdit -nets VDD
editAddRoute    3280.00 1442.88
editCommitRoute 3240.99 1442.88

uiSetTool select
deselectAll


#
# Vertical stripes:
#

addStripe -direction vertical -start_x 875 -stop_x 925 -width 10			\
	-nets {VDD VSS} -number_of_sets 1 -layer MET2 -spacing 3 			\
	-break_stripes_at_block_rings 1 -merge_stripes_value 0.66    			\
	-snap_wire_center_to_grid {Grid} 
addStripe -direction vertical -start_x 1172.55 -stop_x 1195.75 -width 10		\
	-nets {VDD VSS} -number_of_sets 1 -layer MET2 -spacing 3 			\
	-break_stripes_at_block_rings 1 -merge_stripes_value 0.66    			\
	-snap_wire_center_to_grid {Grid} -break_at_selected_blocks 1

addStripe -direction vertical -start_x 1511.13 -stop_x 1534.33 -width 10		\
	-nets {VSS VDD} -number_of_sets 1 -layer MET2 -spacing 3 			\
	-break_stripes_at_block_rings 1 -merge_stripes_value 0.66    			\
	-snap_wire_center_to_grid {Grid} -break_at_selected_blocks 1
addStripe -direction vertical -start_x 1775.45 -stop_x 1975 -width 10			\
	-nets {VSS VDD} -number_of_sets 1 -layer MET2 -spacing 3 			\
	-break_stripes_at_block_rings 1 -merge_stripes_value 0.66    			\
	-snap_wire_center_to_grid {Grid} -break_at_selected_blocks 1
addStripe -direction vertical -start_x 2095.55 -stop_x 2275 -width 10			\
	-nets {VSS VDD} -number_of_sets 1 -layer MET2 -spacing 3 			\
	-break_stripes_at_block_rings 1 -merge_stripes_value 0.66    			\
	-snap_wire_center_to_grid {Grid} -break_at_selected_blocks 1
addStripe -direction vertical -start_x 2375.39 -stop_x 2575 -width 10			\
	-nets {VSS VDD} -number_of_sets 1 -layer MET2 -spacing 3 			\
	-break_stripes_at_block_rings 1 -merge_stripes_value 0.66    			\
	-snap_wire_center_to_grid {Grid} -break_at_selected_blocks 1
addStripe -direction vertical -start_x 2620.91 -stop_x 2744.11 -width 10		\
	-nets {VSS VDD} -number_of_sets 1 -layer MET2 -spacing 3 			\
	-break_stripes_at_block_rings 1 -merge_stripes_value 0.66    			\
	-snap_wire_center_to_grid {Grid} -break_at_selected_blocks 1
addStripe -direction vertical -start_x 2980 -stop_x 3129 -width 10			\
	-nets {VSS VDD} -number_of_sets 1 -layer MET2 -spacing 3 			\
	-break_stripes_at_block_rings 1 -merge_stripes_value 0.66    			\
	-snap_wire_center_to_grid {Grid} -break_at_selected_blocks 1

# need the extra 500 nm spacing here for good matching of wide IM rings
addStripe -direction vertical -start_x 3623.00 -stop_x 3680 -width 10			\
	-nets {VSS VDD} -number_of_sets 1 -layer MET2 -spacing 3.5 			\
	-break_stripes_at_block_rings 1 -merge_stripes_value 0.66    			\
	-snap_wire_center_to_grid {Grid} -break_at_selected_blocks 1

addStripe -direction vertical -start_x 3867.00 -stop_x 3900 -width 10			\
	-nets {VSS VDD} -number_of_sets 1 -layer MET2 -spacing 3 			\
	-break_stripes_at_block_rings 1 -merge_stripes_value 0.66    			\
	-snap_wire_center_to_grid {Grid} -break_at_selected_blocks 1
addStripe -direction vertical -start_x 4120.77 -stop_x 4145.95 -width 10		\
	-nets {VSS VDD} -number_of_sets 1 -layer MET2 -spacing 3 			\
	-break_stripes_at_block_rings 1 -merge_stripes_value 0.66    			\
	-snap_wire_center_to_grid {Grid} -break_at_selected_blocks 1



#
# a few routing blockages are added here in order to avoid heroic connections
# of SUPER_LVDS feed through power connections in the area of stripes or pins
#

createRouteBlk 3253  551 3275  552 all -name stripeblkS1_ALL
createRouteBlk 2370  551 2395  552 all -name stripeblkS2_ALL
createRouteBlk 3691  551 3717  552 all -name stripeblkS3_ALL
createRouteBlk  832  551  856  552 all -name stripeblkS5_ALL

createRouteBlk 4448 4456 4449 4475 6   -name stripeblkE1_M6
createRouteBlk 4448 4456 4449 4475 5   -name stripeblkE1_M5
createRouteBlk 4448 4456 4449 4475 4   -name stripeblkE1_M4
createRouteBlk 4448 4456 4449 4475 3   -name stripeblkE1_M3
createRouteBlk 4448 4456 4449 4475 2   -name stripeblkE1_M2
createRouteBlk 4448 1872 4449 1896 all -name stripeblkE2_ALL


# generate an updated floor plan file
saveFPlan ./OUTPUT/FLOORPLAN/PowerStripes.fp

# Add IO filler cells:
addIoFiller -cell FILLER40 -prefix iofill -side w -from 550.0 -to 5985.0
addIoFiller -cell FILLER20 -prefix iofill -side w -from 550.0 -to 5985.0
addIoFiller -cell FILLER5  -prefix iofill -side w -from 550.0 -to 5985.0
addIoFiller -cell FILLER1  -prefix iofill -side w -from 550.0 -to 5985.0
addIoFiller -cell FILLER0  -prefix iofill -side w -from 550.0 -to 5985.0

addIoFiller -cell FILLER40 -prefix iofill -side e -from 550.0 -to 5985.0
addIoFiller -cell FILLER20 -prefix iofill -side e -from 550.0 -to 5985.0
addIoFiller -cell FILLER5  -prefix iofill -side e -from 550.0 -to 5985.0
addIoFiller -cell FILLER1  -prefix iofill -side e -from 550.0 -to 5985.0
addIoFiller -cell FILLER0  -prefix iofill -side e -from 550.0 -to 5985.0

addIoFiller -cell FILLER40 -prefix iofill -side s -from 550.0 -to 4449.5
addIoFiller -cell FILLER20 -prefix iofill -side s -from 550.0 -to 4449.5
addIoFiller -cell FILLER5  -prefix iofill -side s -from 550.0 -to 4449.5
addIoFiller -cell FILLER1  -prefix iofill -side s -from 550.0 -to 4449.5
addIoFiller -cell FILLER0  -prefix iofill -side s -from 550.0 -to 4449.5

saveDesign ./OUTPUT/ENC/FloorplanStripes.enc

# power route pad and block power pins:
#
# For optical power connection inspection below a list of power pins of various core blocks at
#     appropriate layers identical pins at different layers are counted only once
#
# IMEM   (R4096X30M16): VSS ((6+2)*M3 6*M2) 	VDD (6*M3 8*M2)
# DMEM 			VSS (11*M6) 		VDD (10*M6) 
#						VDD_DM (4*M6) 5 stripes top/bottom - stripe VSS connected to DMEM core
# MailBx (R256X39M8):   VSS (6*M3 8*M2) 	VDD (6*M3 8*M2) (two VSS pins blocked here)
# FiFo   (R128X16M1):   VSS (2*M4) 		VDD (2*M4)
# EventBuf:		VSS (2*M4) 		VDD (2*M4)
#
# Note: the IMEM LEF file was patched, adding another M3 pin in order to create
#       two additional M3 VSS pins above M2 (which is blocked here by core ring)
#

# RSfix -begin
# IMEM0 VSS power on left/right sides
setEdit -nets VSS -width_horizontal 7.14 -width_vertical 7.14 -shape BLOCKRING              \
        -layer_vertical M2 -layer_horizontal M3 
setEdit -nets VSS
editAddRoute      553.75 3781.70
editCommitRoute   601.04 3781.70
setEdit -nets VSS
editAddRoute     1340.48 3781.70
editCommitRoute  1386.87 3781.70
setEdit -nets VSS -width_horizontal 6.04 -width_vertical 6.04 -shape BLOCKRING              \
        -layer_vertical M2 -layer_horizontal M3 
setEdit -nets VSS
editAddRoute      553.75 3744.80
editCommitRoute   601.04 3744.80
setEdit -nets VSS
editAddRoute     1340.48 3744.80
editCommitRoute  1386.87 3744.80

# IMEM1 VSS power on left/right sides
setEdit -nets VSS -width_horizontal 7.14 -width_vertical 7.14 -shape BLOCKRING              \
        -layer_vertical M2 -layer_horizontal M3 
setEdit -nets VSS
editAddRoute      553.75 2506.58
editCommitRoute   601.04 2506.58
setEdit -nets VSS
editAddRoute     1340.48 2506.58
editCommitRoute  1386.87 2506.58
setEdit -nets VSS -width_horizontal 6.04 -width_vertical 6.04 -shape BLOCKRING              \
        -layer_vertical M2 -layer_horizontal M3 
setEdit -nets VSS
editAddRoute      553.75 2469.68
editCommitRoute   601.04 2469.68
setEdit -nets VSS
editAddRoute     1340.48 2469.68
editCommitRoute  1386.87 2469.68

# IMEM2 VSS power on left/right sides
setEdit -nets VSS -width_horizontal 7.14 -width_vertical 7.14 -shape BLOCKRING              \
        -layer_vertical M2 -layer_horizontal M3 
setEdit -nets VSS
editAddRoute     3613.51 1231.46
editCommitRoute  3660.06 1231.46
setEdit -nets VSS
editAddRoute     4399.50 1231.46
editCommitRoute  4446.63 1231.46
setEdit -nets VSS -width_horizontal 6.04 -width_vertical 6.04 -shape BLOCKRING              \
        -layer_vertical M2 -layer_horizontal M3 
setEdit -nets VSS
editAddRoute     3613.51 1194.56
editCommitRoute  3660.06 1194.56
setEdit -nets VSS
editAddRoute     4399.50 1194.56
editCommitRoute  4446.63 1194.56

# IMEM3 VSS power on left/right sides
setEdit -nets VSS -width_horizontal 7.14 -width_vertical 7.14 -shape BLOCKRING              \
        -layer_vertical M2 -layer_horizontal M3 
setEdit -nets VSS
editAddRoute     3613.51 2506.42
editCommitRoute  3660.06 2506.42
setEdit -nets VSS
editAddRoute     4399.50 2506.42
editCommitRoute  4446.63 2506.42
setEdit -nets VSS -width_horizontal 6.04 -width_vertical 6.04 -shape BLOCKRING              \
        -layer_vertical M2 -layer_horizontal M3 
setEdit -nets VSS
editAddRoute     3613.51 2469.52
editCommitRoute  3660.06 2469.52
setEdit -nets VSS
editAddRoute     4399.50 2469.52
editCommitRoute  4446.63 2469.52
# RSfix -end

#
# all rings and stripes placed and routed here - the main power grid is created
# now connect everything ...
#

# power route core cells:
sroute  -verbose -noPadPins -noStripes -noBlockPins -noPadRings -nets {VSS VDD}		\
	-viaThruToOverlapRing -straightConnections straightWithDRCClean

# sroute somehow does not connect VDD_DM - we do that manually below
sroute  -verbose            -noStripes -noCorePins  -noPadRings -nets {VDD_DM}		\
	-viaThruToOverlapRing
sroute  -verbose            -noStripes -noCorePins              -nets {V0IO V3IO} 	\
	-viaThruToOverlapRing

# only allow direct connections
#sroute  -verbose                                               -nets {VSS VDD}		\
#	-viaThruToOverlapRing -padPinPreferredLayerOnly

# route everything, which is left now, such as the memory blocks
sroute  -verbose                                                -nets {VSS VDD}		\
	-viaThruToOverlapRing -blockPin allPins                                  
#	-viaThruToOverlapRing -blockPin allPins -noBlockPinOneAmongOverlappedPins

# RSfix -begin
# IMEM3 VDD power on top-right corner
setEdit -nets VDD -width_horizontal 3 -width_vertical 3 -shape BLOCKRING              \
        -layer_vertical M2 -layer_horizontal M3 
setEdit -nets VDD
editAddRoute     4399.50 3095.31
editCommitRoute  4423.53 3095.31
# RSfix -end

saveDesign ./OUTPUT/ENC/FloorplanSRouted.enc

# somehow we get core dumps here when running continuously - this is a work
# around hack hoping that save/restore cleans up the internal DB
encMessage warning 0
encMessage debug 0
encMessage info 0
restoreDesign ./OUTPUT/ENC/FloorplanSRouted.enc.dat top_pad 1 1 0
setDrawMode fplan
encMessage warning 1
encMessage debug 0
encMessage info 1

clearDrc
fit

# for some strange reason some core rows are not extended to the block rings
# we fix that here by adding appropriate wire segments. Note that stretching wires caused some
# strange side effects. ...
# only horizontal M1 routing performed here.


# bottom of IMEM1
setEdit -nets VSS -width_horizontal 1.48 -width_vertical 1.48 -shape COREWIRE		\
	-layer_vertical M2 -layer_horizontal M1 
# event buffer 00 lower left corner
editAddRoute    2719    5658.28
editCommitRoute 2730.91 5658.28
# event buffer 20 lower left corner
editAddRoute    4119    4413.96
editCommitRoute 4130.77 4413.96
# DMEM top left corner
editAddRoute    1509    1420.26
editCommitRoute 1521.13 1420.26
# DMEM top right corner
editAddRoute    3247    1457.16
editCommitRoute 3264.19 1457.16
# mailbox memory top right corner
editAddRoute    3480    1457.16
editCommitRoute 3469.35 1457.16
setEdit -nets VDD
editAddRoute    3480    1438.68
editCommitRoute 3456.15 1438.68
# side of IMEM1
editAddRoute    1395    2510.52
editCommitRoute 1343.77 2510.52

# RSfix -begin
setEdit -nets VSS
# IMEM1
editAddRoute    1366.87 2504.36
editCommitRoute 1390    2504.36
# IMEM3
editAddRoute    1312    2504.36
editCommitRoute 3633.51 2504.36
editAddRoute    1312    2467.40
editCommitRoute 3633.51 2467.40
# RSfix -begin

#
# some manual patching remaines
#

# connect the DMEM - no time for power domains
setEdit -nets VDD_DM -width_horizontal 17 -width_vertical 17 -shape IOWIRE		\
	-layer_vertical M6 -layer_horizontal M6 
editAddRoute    1895.50  550.24
editCommitRoute 1895.50  601.00
editAddRoute    1914.50  550.24
editCommitRoute 1914.50  601.00

editAddRoute    2885.50  550.24
editCommitRoute 2885.50  601.00
editAddRoute    2904.50  550.24
editCommitRoute 2904.50  601.00


# connect cells, which are not connected automatically
setEdit -nets VSS -width_horizontal 17 -width_vertical 17 -shape IOWIRE			\
	-layer_vertical M3 -layer_horizontal M3 
#
# Cell GNDW0:
editAddRoute     550.24  576.0
editCommitRoute  573.75  576.0
editAddRoute     550.24  595.0
editCommitRoute  573.75  595.0
# Cell PWRW0
setEdit -nets VDD
editAddRoute     550.24  626.0
editCommitRoute  596.85  626.0
editAddRoute     550.24  645.0
editCommitRoute  596.85  645.0

# Cell GNDE0:
setEdit -nets VSS
editAddRoute     4426.63 576.0
editCommitRoute  4449.76 576.0
editAddRoute     4426.63 595.0
editCommitRoute  4449.76 595.0
# Cell PWRE0
setEdit -nets VDD -layer_horizontal M3
editAddRoute     4403.53 626.0
editCommitRoute  4449.76 626.0
editAddRoute     4403.53 645.0
editCommitRoute  4449.76 645.0

uiSetTool select
deselectAll

#
# The router likes to use the area between the core rings for nets. 
# Add appropriate blockages here to avoid that. This has to be done post
# power routing so that the normal connections are drawn
#

createRouteBlk  552   5934   4448  5984   1 -name CoreRingN_M1
createRouteBlk  552    552   4448   600   1 -name CoreRingS_M
createRouteBlk  552    552    600  5984   2 -name CoreRingw_M1
createRouteBlk 4400    552   4448  5984   2 -name CoreRingE_M1

# 
uiSetTool select


# just do a first check whether we have created a short between pwr and GND
verifyGeometry -reportfile ./REPORTS/FLOORPLAN/violation_report_power.rpt  	\
	-allowRoutingBlkgPinOverlap -error 10000 -warning 100000

# clear all bogus DRC errors, possibly generated above, to prevent router from
# trying to fix them, wasting time
clearDrc
