#date

# VoLi 20040104:
#
# The design instantiates all IO cells explicitly. The top level instance 
# exports all PADs as pins. One consequence of this is the resulting existence
# of nets with only one pin (the IO cells PAD). The placement of the bonding
# PADs is done automatically during stream-out. As a result the router produces
# the following warning for all toplevel IO pins/pads:
#          ***WARNING***RST_n does not have layer defined ! 
# here for the RESET input RST_n. These warnings may be ignored. Maybe on the 
# long run we find a more elegant way of doing this.

encMessage warning 0
encMessage debug 0
encMessage info 0
restoreDesign ./OUTPUT/ENC/RouteIN.enc.dat top_pad 1 1 0
setDrawMode fplan
encMessage warning 1
encMessage debug 0
encMessage info 1

#
# prepare the routing - do timing analysis first, allowing a comparison between
# the trial route estimates and the final result
#


source SCRIPTS/setOpCond.tcl
specifyClockTree -clkfile ./CFG/CTS/routeTypes.cts
specifyClockTree -clkfile ./CFG/CTS/top_pad_masterCLK.cts
specifyClockTree -clkfile ./CFG/CTS/top_pad_miscCLK.cts
setAnalysisMode -setup -noAsync -skew -clockTree
setTrialRouteMode -highEffort -maxRouteLayer 6 -guide ./OUTPUT/CTS/top_pad_cts.guide
reportClock

trialRoute

# read default router options for NanoRoute
source ./SCRIPTS/setRoutingOpt.tcl


#
# do the clocks first
#
# VoLi: not entirely sure why these options as taken from the cts configuration
#	are not directly passed to the router. They are in the 


setAttribute -net @CLOCK -preferred_extra_space 2 -avoid_detour true -weight 5 	\
	-bottom_preferred_routing_layer 2 -top_preferred_routing_layer 3	

selectNet -allDefClock
setNanoRouteMode routeSelectedNetOnly true
globalDetailRoute
deselectAll
saveDesign ./OUTPUT/ENC/RouteCLK.enc

exit
