#
# This script contains some post routing optimizations, performed manually 
# after initial route and prior tofinal routing.
#

encMessage warning 0
encMessage debug 0
encMessage info 0
restoreDesign ./OUTPUT/ENC/Route1Final.enc.dat top_pad
setDrawMode fplan
encMessage warning 1
encMessage debug 0
encMessage info 1

source SCRIPTS/setOpCond.tcl
specifyClockTree -clkfile ./CFG/CTS/routeTypes.cts
specifyClockTree -clkfile ./CFG/CTS/top_pad_masterCLK.cts
setAnalysisMode -setup -noAsync -skew -clockTree
setTrialRouteMode -highEffort -maxRouteLayer 6 -guide ./OUTPUT/CTS/top_pad_cts.guideresize -postIPO -noFootPrintChange

#
# perform post routing cell optimization - just change size
#

resize -postIPO -noFootPrintChange
saveDesign ./OUTPUT/ENC/Route1ManOpt.enc

#
# read default router options
#

source ./SCRIPTS/setRoutingOpt.tcl

deselectAll
setNanoRouteMode routeSelectedNetOnly false
setNanoRouteMode -quiet routeInsertAntennaDiode false
setNanoRouteMode -quiet optimizeFixHoldTime true
setNanoRouteMode -quiet optimizeTargetHoldSlack 0.500000

globalDetailRoute

#
# optimization pass finished - now lets see what the results are
#

extractRC
freeTimingGraph
buildTimingGraph

reportSlacks        -outfile ./REPORTS/ROUTING/1st/top_pad_routeManOpt.slk
reportViolation     -outfile ./REPORTS/ROUTING/1st/top_pad_routeManOpt.tarpt  -num 1000 -longForm
reportViolation     -outfile ./REPORTS/ROUTING/1st/top_pad_routeManOpt.tasrpt -num 1000 -shortForm
reportTranViolation -outfile ./REPORTS/ROUTING/1st/top_pad_routeManOpt.tran   -noGlobalNets -excNetFile ./CFG/TranExcl.ntf

saveDesign ./OUTPUT/ENC/Route1Final.enc






