encMessage warning 0
encMessage debug 0
encMessage info 0
restoreDesign ./OUTPUT/ENC/RouteF2GDSout.enc.dat top_pad 1 1 0
setDrawMode fplan
encMessage warning 1
encMessage debug 0
encMessage info 1
fit

source SCRIPTS/setOpCond.tcl

################################################################################
# Worst Case Extraction:
################################################################################

setAnalysisMode -setup -noAsync -skew -autoDetectClockTree

setExtractRCMode -detail -assumeMetFill 0.5
extractRC -outfile OUTPUT/EXTRACTION/3D/top_pad_final_wc.cap
rcOut -setload OUTPUT/EXTRACTION/3D/top_pad_final_wc.setload
rcOut -setres OUTPUT/EXTRACTION/3D/top_pad_final_wc.setres
rcOut -spef OUTPUT/EXTRACTION/3D/top_pad_final_wc.spef

# this file grows beyond 2GB and cannot be produced on linux - use solaris
#rcOut -spf OUTPUT/EXTRACTION/3D/top_pad_final_wc.spf


# Delay calculation:
delayCal -sdf OUTPUT/TIMING/3D/top_pad_final_wc.sdf

################################################################################
# Setup Timing analysis:
################################################################################

setOpCond {}
setAnalysisMode -setup -async -skew -autoDetectClockTree
buildTimingGraph

# Generate report file (short version)
reportSlacks -outfile ./REPORTS/TIMING/3D/top_pad_final_wc.slk

# Generate report file (long version)
reportViolation -outfile ./REPORTS/TIMING/3D/top_pad_final_wc.tarpt -num 10000 -longForm
reportViolation -outfile ./REPORTS/TIMING/3D/top_pad_final_wc.tasrpt -num 10000 -shortForm

# Generate report file for transition violations
reportTranViolation -outfile ./REPORTS/TIMING/3D/top_pad_final_wc.tran -noGlobalNets

# Generate report file (clock info)
reportClock -outfile ./REPORTS/TIMING/3D/top_pad_final_wc.clkinfo

# Generate report file (timing library)
reportTimingLib -outfile ./REPORTS/TIMING/3D/top_pad_final_wc.talib

# Generate report file (cell footprint)
reportFootPrint -outfile ./REPORTS/TIMING/3D/top_pad_final_wc.cfp


################################################################################
# Hold Timing analysis:
################################################################################

# Timing analysis:
setAnalysisMode -hold -async -skew -autoDetectClockTree
buildTimingGraph

# Generate slack report file
reportSlacks -outfile ./REPORTS/TIMING/3D/top_pad_final_hold_bc.slk

# Generate report file (long and short version)
reportViolation -outfile ./REPORTS/TIMING/3D/top_pad_final_hold_bc.tarpt -num 10000 -longForm
reportViolation -outfile ./REPORTS/TIMING/3D/top_pad_final_hold_bc.tasrpt -num 10000 -shortForm

#
################################################################################
################################################################################
# Best Case Setup Timing analysis:
# just to get an idea what the to be expected range will be
################################################################################
################################################################################
#

setOpCond -min WORST -minLibrary umcl18u250t2_wc -max BEST -maxLibrary umcl18u250t2_bc
setAnalysisMode -setup -noAsync -skew -autoDetectClockTree

################################################################################
# Best Case Extraction:
################################################################################

extractRC -outfile OUTPUT/EXTRACTION/3D/top_pad_final_bc.cap
rcOut -setload OUTPUT/EXTRACTION/3D/top_pad_final_bc.setload
rcOut -setres OUTPUT/EXTRACTION/3D/top_pad_final_bc.setres
rcOut -spef OUTPUT/EXTRACTION/3D/top_pad_final_bc.spef

# this file grows beyond 2GB and cannot be produced on linux - use solaris
#rcOut -spf OUTPUT/EXTRACTION/3D/top_pad_final_bc.spf

# Delay calculation:
delayCal -sdf OUTPUT/TIMING/3D/top_pad_final_bc.sdf

################################################################################
# Best Case Setup Timing analysis:
################################################################################

setOpCond {}
setAnalysisMode -setup -async -skew -autoDetectClockTree
buildTimingGraph

# Generate slack report file
reportSlacks -outfile ./REPORTS/TIMING/3D/top_pad_final_bc.slk

# Generate report file (long and short version)
reportViolation -outfile ./REPORTS/TIMING/3D/top_pad_final_bc.tarpt -num 10000 -longForm
reportViolation -outfile ./REPORTS/TIMING/3D/top_pad_final_bc.tasrpt -num 10000 -shortForm

# Generate report file for transition violations
reportTranViolation -outfile ./REPORTS/TIMING/3D/top_pad_final_bc.tran -noGlobalNets

# Generate report file (clock info)
reportClock -outfile ./REPORTS/TIMING/3D/top_pad_final_bc.clkinfo

# Generate report file (timing library)
reportTimingLib -outfile ./REPORTS/TIMING/3D/top_pad_final_bc.talib

# Generate report file (cell footprint)
reportFootPrint -outfile ./REPORTS/TIMING/3D/top_pad_final_bc.cfp

exit
