encMessage warning 0
encMessage debug 0
encMessage info 0
restoreDesign ./OUTPUT/ENC/IPOpostCTSopt3.enc.dat top_pad 1 1 0
setDrawMode fplan
encMessage warning 1
encMessage debug 0
encMessage info 1

#
# Prepare and perform In-Place Optimization
#

source SCRIPTS/setOpCond.tcl
specifyClockTree -clkfile ./CFG/CTS/routeTypes.cts
# these misc. clocks are already generated and are specified here
# so that they are not touched by the optimizer
specifyClockTree -clkfile ./CFG/CTS/top_pad_niPorts.cts
setTrialRouteMode -highEffort -maxRouteLayer 6 -guide OUTPUT/CTS/top_pad_cts.guide

setAnalysisMode -setup -noAsync -skew -autoDetectClockTree 

#
# the Ni input and output CLK trees are being optimized away. We regenerate the
# Clock tree here again.
#

# delete the clock trees first

# NIP0
deleteClockTree -clk NIP0_D0/DI
deleteClockTree -clk NIP0_D1/DI
deleteClockTree -clk NIP0_D2/DI
deleteClockTree -clk NIP0_D3/DI
deleteClockTree -clk NIP0_D4/DI
deleteClockTree -clk NIP0_D5/DI
deleteClockTree -clk NIP0_D6/DI
deleteClockTree -clk NIP0_D7/DI
deleteClockTree -clk NIP0_D8/DI
deleteClockTree -clk NIP0_D9/DI
deleteClockTree -clk NIP0_STB/DI
deleteClockTree -clk Itrap2top/rs/U121/Z

# NIP1
deleteClockTree -clk NIP1_D0/DI
deleteClockTree -clk NIP1_D1/DI
deleteClockTree -clk NIP1_D2/DI
deleteClockTree -clk NIP1_D3/DI
deleteClockTree -clk NIP1_D4/DI
deleteClockTree -clk NIP1_D5/DI
deleteClockTree -clk NIP1_D6/DI
deleteClockTree -clk NIP1_D7/DI
deleteClockTree -clk NIP1_D8/DI
deleteClockTree -clk NIP1_D9/DI
deleteClockTree -clk NIP1_STB/DI
deleteClockTree -clk Itrap2top/rs/U122/Z

# NIP2
deleteClockTree -clk NIP2_D0/DI
deleteClockTree -clk NIP2_D1/DI
deleteClockTree -clk NIP2_D2/DI
deleteClockTree -clk NIP2_D3/DI
deleteClockTree -clk NIP2_D4/DI
deleteClockTree -clk NIP2_D5/DI
deleteClockTree -clk NIP2_D6/DI
deleteClockTree -clk NIP2_D7/DI
deleteClockTree -clk NIP2_D8/DI
deleteClockTree -clk NIP2_D9/DI
deleteClockTree -clk NIP2_STB/DI
deleteClockTree -clk Itrap2top/rs/U123/Z
 
# NIP3
deleteClockTree -clk NIP3_D0/DI
deleteClockTree -clk NIP3_D1/DI
deleteClockTree -clk NIP3_D2/DI
deleteClockTree -clk NIP3_D3/DI
deleteClockTree -clk NIP3_D4/DI
deleteClockTree -clk NIP3_D5/DI
deleteClockTree -clk NIP3_D6/DI
deleteClockTree -clk NIP3_D7/DI
deleteClockTree -clk NIP3_D8/DI
deleteClockTree -clk NIP3_D9/DI
deleteClockTree -clk NIP3_STB/DI
deleteClockTree -clk Itrap2top/rs/U124/Z

# NIP4 - output port
deleteClockTree -clk Itrap2top/rs/U_port_out/U_delay/U_delaybit_0/U_buffer/Z
deleteClockTree -clk Itrap2top/rs/U_port_out/U_delay/U_delaybit_1/U_buffer/Z
deleteClockTree -clk Itrap2top/rs/U_port_out/U_delay/U_delaybit_2/U_buffer/Z
deleteClockTree -clk Itrap2top/rs/U_port_out/U_delay/U_delaybit_3/U_buffer/Z
deleteClockTree -clk Itrap2top/rs/U_port_out/U_delay/U_delaybit_4/U_buffer/Z
deleteClockTree -clk Itrap2top/rs/U_port_out/U_delay/U_delaybit_5/U_buffer/Z
deleteClockTree -clk Itrap2top/rs/U_port_out/U_delay/U_delaybit_6/U_buffer/Z
deleteClockTree -clk Itrap2top/rs/U_port_out/U_delay/U_delaybit_7/U_buffer/Z
deleteClockTree -clk Itrap2top/rs/U_port_out/U_delay/U_delaybit_8/U_buffer/Z
deleteClockTree -clk Itrap2top/rs/U_port_out/U_delay/U_delaybit_9/U_buffer/Z
deleteClockTree -clk Itrap2top/rs/U_port_out/U_delay/U_delaybit_10/U_buffer/Z
deleteClockTree -clk Itrap2top/rs/U_port_out/U_delay/U_delaybit_11/U_buffer/Z
deleteClockTree -clk NIP4_CTL/DI

#
# generate the RESET trees using the clock generation tool
# this is essential for the transition violation fix as all asynchronous RESETs
# will generate nets, which are driven slow and therefore result irreparably 
# slow. 
#

checkUnique
ckSynthesis -report ./REPORTS/IPOpostCTS/top_pad_NI.ctsrpt -dontFixAddedBuffers
saveDesign ./OUTPUT/ENC/IPOpostCTSManNiCLK.enc
 
#
# scratch area starts here - DO NOT EXECUTE AS SCRIPT
#

trialRoute
extractRC
freeTimingGraph
buildTimingGraph
reportClock

reportSlacks        -outfile ./REPORTS/IPOpostCTS/top_pad_ipoFinal.slk
reportViolation     -outfile ./REPORTS/IPOpostCTS/top_pad_ipoFinal.tarpt  -num 1000 -longForm
reportViolation     -outfile ./REPORTS/IPOpostCTS/top_pad_ipoFinal.tasrpt -num 1000 -shortForm
reportTranViolation -outfile ./REPORTS/IPOpostCTS/top_pad_ipoFinal.tran -noGlobalNets -excNetFile ./CFG/TranExcl.ntf

saveNetlist ./OUTPUT/NETLIST/top_pad_IPOpostCTS.v
saveDesign  ./OUTPUT/ENC/IPOpostCTSFinal.enc
saveDesign  ./OUTPUT/ENC/RouteIN.enc

exec date -R
exit
