encMessage warning 0
encMessage debug 0
encMessage info 0
restoreDesign ./OUTPUT/ENC/FloorplanFinal.enc.dat top_pad 1 1 0
setDrawMode fplan
encMessage warning 1
encMessage debug 0
encMessage info 1


source SCRIPTS/setOpCond.tcl
# the script above by default selects detailed timing extraction, which is not
# making sense until the design is placed and at least trial routed
# we reset here to basic timing analysis. 
setExtractRCMode -default

setAnalysisMode -setup -noAsync -noSkew -noClockTree
setTrialRouteMode -highEffort -maxRouteLayer 6 


# 
# Placement 
#

# create some extra spacing for the clock buffers to be inserted without large
# placement changes after CTS
source ./SCRIPTS/setCellPadding.tcl

amoebaPlace -slow -timingdriven -ipo -doCongOpt -maxDensity 0.7

# this goes quick and allows to determine early whether or not we have good placement
trialRoute -maxRouteLayer 6 -highEffort -ignoreScan -ignoreSpare

checkPlace
saveDesign ./OUTPUT/ENC/PlaceFinal.enc
savePlace ./OUTPUT/PLACE/TIMING_DRIVEN/top_pad.place

#
# the following timing analysis is going to be pretty bad pior to DRC fixing
# and IPO fixing. But it is a check that the timing constraint file did not
# miss a long path, for instance through the filters
#

trialRoute
extractRC
freeTimingGraph
buildTimingGraph
reportClock

reportSlacks        -outfile ./REPORTS/PLACE/top_pad.slk
reportViolation     -outfile ./REPORTS/PLACE/top_pad.tarpt  -num 1000 -longForm
reportViolation     -outfile ./REPORTS/PLACE/top_pad.tasrpt -num 1000 -shortForm
reportTranViolation -outfile ./REPORTS/PLACE/top_pad.tran	-noGlobalNets  -excNetFile ./CFG/TranExcl.ntf

exit
