-- 
-- Copyright (C) 2001 Virtual Silicon Technology Inc.. All Rights Reserved.
-- eSi, eSi-Route, eSi-Pad, eSi-RAM, eSi-ROM, eSi-PLL,
-- The Heart of Great Silicon(R), Silicon Ready(R), IP Ambassador,
-- Design Service Ambassador, and Virtual Silicon are trademarks
-- of Virtual Silicon Technology Inc.
-- 
-- Virtual Silicon Technology Inc.
-- 1200 Crossman Ave Suite 200
-- Sunnyvale, CA 94089-1116
-- Phone : 408-548-2700
-- Fax : 408-548-2750
-- Web Site : www.virtual-silicon.com
-- 
-- VST Library Release: UMCL18U420T2_1.3
-- 
-- Two-Port RAM 128 words by 16 bits
-- column mux = 1
-- bytewrite  = n
-- tristate   = n
-- test       = n
-- powerbus   = o
-- frequency  = 120
-- 
--  VITAL Model 
-- 

USE STD.TEXTIO.all;
LIBRARY IEEE;
USE IEEE.STD_LOGIC_1164.all;
USE IEEE.VITAL_timing.all;

ENTITY R128X16M1 IS
--
-- COMPILER VERSION  : 1.1
-- GENERATED DATE    : Wed Apr  9 15:49:34 MEST 2003
--  NUMBER_OF_WORDS  : 128 words
--  (ADDRESS_WIDTH   : 7 bits)
--  DATA_WIDTH       : 16 bits
--  TRISTATE OPTION  : No
--  BYTEWRITE OPTION : No
--  TEST OPTION      : None
--  MODEL OPTION     : Timing
--
  GENERIC (
    DF    : Real := 1.0;
    SUHDF : Real := 1.0;
    tipd_RCK    : VitalDelayType01 := (0 ns, 0 ns);
    tipd_REN    : VitalDelayType01 := (0 ns, 0 ns);
    tipd_RADR   : VitalDelayArrayType01(6 downto 0) := (others=>(0 ns,0 ns));
    tipd_WCK    : VitalDelayType01 := (0 ns, 0 ns);
    tipd_WEN    : VitalDelayType01 := (0 ns, 0 ns);
    tipd_WADR   : VitalDelayArrayType01(6 downto 0) := (others=>(0 ns,0 ns));
    tipd_DI     : VitalDelayArrayType01(15 downto 0) := (others=>(0 ns,0 ns));
    tpd_rck_dout_posedge    : VitalDelayArrayType01z(15 downto 0) := (others=>(0 ns,0 ns,0 ns,0 ns,0 ns,0 ns));
    tpd_wck_dout_posedge    : VitalDelayArrayType01z(15 downto 0) := (others=>(0 ns,0 ns,0 ns,0 ns,0 ns,0 ns));
    tsetup_REN_RCK_noedge_posedge     : VitalDelayType := -999 ns;
     thold_REN_RCK_noedge_posedge     : VitalDelayType := -999 ns;
    tsetup_REN_RCK_posedge_posedge    : VitalDelayType := 0 ns;
    tsetup_REN_RCK_negedge_posedge    : VitalDelayType := 0 ns;
     thold_REN_RCK_posedge_posedge    : VitalDelayType := 0 ns;
     thold_REN_RCK_negedge_posedge    : VitalDelayType := 0 ns;
   tsetup_RADR_RCK_noedge_posedge     : VitalDelayArrayType(6 downto 0) := (others=>-999 ns);
    thold_RADR_RCK_noedge_posedge     : VitalDelayArrayType(6 downto 0) := (others=>-999 ns);
   tsetup_RADR_RCK_posedge_posedge    : VitalDelayArrayType(6 downto 0) := (others=>0 ns);
   tsetup_RADR_RCK_negedge_posedge    : VitalDelayArrayType(6 downto 0) := (others=>0 ns);
    thold_RADR_RCK_posedge_posedge    : VitalDelayArrayType(6 downto 0) := (others=>0 ns);
    thold_RADR_RCK_negedge_posedge    : VitalDelayArrayType(6 downto 0) := (others=>0 ns);
    tsetup_WEN_WCK_noedge_posedge     : VitalDelayType := -999 ns;
     thold_WEN_WCK_noedge_posedge     : VitalDelayType := -999 ns;
    tsetup_WEN_WCK_posedge_posedge    : VitalDelayType := 0 ns;
    tsetup_WEN_WCK_negedge_posedge    : VitalDelayType := 0 ns;
     thold_WEN_WCK_posedge_posedge    : VitalDelayType := 0 ns;
     thold_WEN_WCK_negedge_posedge    : VitalDelayType := 0 ns;
   tsetup_WADR_WCK_noedge_posedge     : VitalDelayArrayType(6 downto 0) := (others=>-999 ns);
    thold_WADR_WCK_noedge_posedge     : VitalDelayArrayType(6 downto 0) := (others=>-999 ns);
   tsetup_WADR_WCK_posedge_posedge    : VitalDelayArrayType(6 downto 0) := (others=>0 ns);
   tsetup_WADR_WCK_negedge_posedge    : VitalDelayArrayType(6 downto 0) := (others=>0 ns);
    thold_WADR_WCK_posedge_posedge    : VitalDelayArrayType(6 downto 0) := (others=>0 ns);
    thold_WADR_WCK_negedge_posedge    : VitalDelayArrayType(6 downto 0) := (others=>0 ns);
     tsetup_DI_WCK_noedge_posedge     : VitalDelayArrayType(15 downto 0) := (others=>-999 ns);
      thold_DI_WCK_noedge_posedge     : VitalDelayArrayType(15 downto 0) := (others=>-999 ns);
     tsetup_DI_WCK_posedge_posedge    : VitalDelayArrayType(15 downto 0) := (others=>0 ns);
     tsetup_DI_WCK_negedge_posedge    : VitalDelayArrayType(15 downto 0) := (others=>0 ns);
      thold_DI_WCK_posedge_posedge    : VitalDelayArrayType(15 downto 0) := (others=>0 ns);
      thold_DI_WCK_negedge_posedge    : VitalDelayArrayType(15 downto 0) := (others=>0 ns);
    tsetup_RCK_WCK_noedge_posedge   : VitalDelayType := -999 ns;
    tsetup_WCK_RCK_noedge_posedge   : VitalDelayType := -999 ns;
    tsetup_RCK_WCK_posedge_rflag_posedge : VitalDelayType := 0 ns;
    tsetup_WCK_RCK_posedge_wflag_posedge : VitalDelayType := 0 ns;
    tperiod_RCK_posedge      : VitalDelayType := 0 ns;
    tperiod_WCK_posedge      : VitalDelayType := 0 ns;
    tpw_RCK_noedge   : VitalDelayType := -999 ns;
    tpw_RCK_posedge  : VitalDelayType := 0 ns;
    tpw_RCK_negedge  : VitalDelayType := 0 ns;
    tpw_WCK_noedge   : VitalDelayType := -999 ns;
    tpw_WCK_posedge  : VitalDelayType := 0 ns;
    tpw_WCK_negedge  : VitalDelayType := 0 ns;
    TimingChecksOn : BOOLEAN := TRUE;
    Xon            : BOOLEAN := TRUE;
    MsgOn          : BOOLEAN := TRUE;
    InstancePath   : STRING  := "*" );
  PORT ( RCK    : in  std_logic;
         REN    : in  std_logic;
         RADR   : in  std_logic_vector(6 downto 0);
         WCK    : in  std_logic;
         WEN    : in  std_logic;
         WADR   : in  std_logic_vector(6 downto 0);
         DI     : in  std_logic_vector(15 downto 0);
         DOUT   : out std_logic_vector(15 downto 0) );

  ATTRIBUTE VITAL_LEVEL0 OF R128X16M1 : ENTITY IS True;
END R128X16M1;

ARCHITECTURE R128X16M1_behavior OF R128X16M1 IS
  SUBTYPE X01_vector IS std_ulogic_vector;
  TYPE MEM IS ARRAY (127 downto 0) of std_ulogic_vector(15 downto 0);
  TYPE GlitchArrayDataType IS ARRAY (NATURAL RANGE <>) OF VitalGlitchDataType;
  -- define input delay signals
  SIGNAL RCK_ipd    : std_ulogic := 'X';
  SIGNAL WCK_ipd    : std_ulogic := 'X';
  SIGNAL REN_ipd    : std_ulogic := 'X';
  SIGNAL WEN_ipd    : std_ulogic := 'X';
  SIGNAL RADR_ipd   : std_ulogic_vector(6 downto 0) := (others=>'X');
  SIGNAL WADR_ipd   : std_ulogic_vector(6 downto 0) := (others=>'X');
  SIGNAL DI_ipd     : std_ulogic_vector(15 downto 0) := (others=>'X');
  -- define simplified signals
  SIGNAL RCK_X01    : std_ulogic;
  SIGNAL WCK_X01    : std_ulogic;
  SIGNAL REN_X01    : std_ulogic;
  SIGNAL WEN_X01    : std_ulogic;
  SIGNAL BWEN_X01   : std_ulogic_vector(1 downto 0) := (others=>'0');
  SIGNAL RADR_X01   : std_ulogic_vector(6 downto 0);
  SIGNAL WADR_X01   : std_ulogic_vector(6 downto 0);
  SIGNAL DI_X01     : std_ulogic_vector(15 downto 0);
  SIGNAL OEN_X01    : std_ulogic := '0';
  SIGNAL BYP_X01    : std_ulogic := '0';
  SIGNAL TCE_X01    : std_ulogic := '0';
  SIGNAL TSE_X01    : std_ulogic := '0';
  SIGNAL TRCN_X01   : std_ulogic := '0';
  SIGNAL TWCK_X01   : std_ulogic := '0';
  SIGNAL TIREN_X01  : std_ulogic := '0';
  SIGNAL TIWEN_X01  : std_ulogic := '0';
  SIGNAL TIBWEN_X01 : std_ulogic_vector(1 downto 0) := (others=>'0');
  SIGNAL TIRADR_X01 : std_ulogic := '0';
  SIGNAL TIWADR_X01 : std_ulogic := '0';
  SIGNAL TID_X01    : std_ulogic := '0';
  -- define internal signals
  SIGNAL int_rd_clock   : std_ulogic;
  SIGNAL int_wr_clock   : std_ulogic;
  SIGNAL int_rd_adrs    : std_ulogic_vector(6 downto 0);
  SIGNAL int_wr_adrs    : std_ulogic_vector(6 downto 0);
  SIGNAL int_wr_data    : std_ulogic_vector(15 downto 0);
  SIGNAL int_enable     : std_ulogic := '1';
  SIGNAL int_datain     : std_ulogic_vector(15 downto 0);
  SIGNAL int_dataout    : std_ulogic_vector(15 downto 0);
  SIGNAL pre_datain     : std_ulogic_vector(15 downto 0);
  SIGNAL pre_dataout    : std_ulogic_vector(15 downto 0);
  SIGNAL int_toradr     : std_ulogic;
  SIGNAL int_towadr     : std_ulogic;
  SIGNAL int_toren      : std_ulogic;
  SIGNAL int_towen      : std_ulogic;
  SIGNAL int_tobwen     : std_ulogic_vector(1 downto 0);
  SIGNAL int_tod        : std_ulogic;
  -- define a flag for error and ref-edge keeper
  CONSTANT tw_RCK_WCK_posedge_posedge  : VitalDelayType := 2.59 ns;   --max
--CONSTANT tw_RCK_WCK_posedge_posedge  : VitalDelayType := 2.59 ns;   --typ
--CONSTANT tw_RCK_WCK_posedge_posedge  : VitalDelayType := 2.59 ns;   --min
  SIGNAL RCK_RisedAt   : TIME := 0 ns;
  SIGNAL RCK_FalledAt  : TIME := 0 ns;
  SIGNAL WCK_RisedAt   : TIME := 0 ns;
  SIGNAL WCK_FalledAt  : TIME := 0 ns;
  SIGNAL int_tmg_error_sh_ren     : std_ulogic := '0';
  SIGNAL int_tmg_error_sh_radr    : std_ulogic_vector(6 downto 0) := (others=>'0');
  SIGNAL int_tmg_error_sh_wenw    : std_ulogic := '0';
  SIGNAL int_tmg_error_sh_wadrw   : std_ulogic_vector(6 downto 0) := (others=>'0');
  SIGNAL int_tmg_error_sh_diw     : std_ulogic_vector(15 downto 0) := (others=>'0');
  SIGNAL int_tmg_error_pw_rck     : std_ulogic := '0';
  SIGNAL int_tmg_error_pw_wck     : std_ulogic := '0';
  SIGNAL int_tmg_error_rwclk      : std_ulogic := '0';
  SIGNAL int_tmg_error_wrclk      : std_ulogic := '0';
  SIGNAL int_rd_tmg_error         : std_ulogic := '0';
  SIGNAL int_wr_tmg_error         : std_ulogic := '0';
  SIGNAL int_tmg_error            : std_ulogic := '0';
  SIGNAL int_delayed_tmg_error    : std_ulogic := '0';

  PROCEDURE Msg(
      CONSTANT MsgOn       : BOOLEAN;
      CONSTANT msg         : STRING;
      CONSTANT MsgSeverity : SEVERITY_LEVEL ) IS
    VARIABLE l   : LINE;
    VARIABLE str : STRING(1 to 512);
  BEGIN
    IF MsgOn THEN
      WRITE( l, InstancePath&"/R128X16M1 ");
      WRITE( l, msg);
      WRITE( l, STRING'("; At "));
      WRITE( l, NOW);
      FOR i IN l'range LOOP
        str(i)   := l(i);
        str(i+1) := NUL;
      END LOOP;
      ASSERT FALSE REPORT str SEVERITY MsgSeverity;
    END IF;
  END Msg;
  PROCEDURE TmgErrMsg(
      CONSTANT MsgOn    : BOOLEAN;
      CONSTANT msg      : STRING;
      CONSTANT ref_time : TIME;
      CONSTANT exp_time : TIME;
      CONSTANT err_time : TIME ) IS
    VARIABLE l   : LINE;
    VARIABLE str : STRING(1 to 512);
  BEGIN
    IF MsgOn THEN
      IF ref_time /= 0 ns THEN
      WRITE( l, InstancePath&"/R128X16M1 ");
        WRITE( l, msg);
        WRITE( l, STRING'(";"&LF));
        WRITE( l, STRING'("  Expected := "));
        WRITE( l, exp_time);
        WRITE( l, STRING'("; Observed := "));
        WRITE( l, err_time);
        WRITE( l, STRING'("; At "));
        WRITE( l, ref_time);
        FOR i IN l'range LOOP
          str(i)   := l(i);
          str(i+1) := NUL;
        END LOOP;
        ASSERT FALSE REPORT str SEVERITY WARNING;
      END IF;
    END IF;
  END TmgErrMsg;
  FUNCTION SelectVal( no_edge, each_edge : time) RETURN time IS
    VARIABLE result : time;
  BEGIN
    result := no_edge;
    IF no_edge=-999 ns THEN
      result := each_edge;
    END IF;
    RETURN( result);
  END SelectVal;
  PROCEDURE CheckSetup(
      CONSTANT MsgOn      : IN    BOOLEAN;
      CONSTANT Ref_Name   : IN    STRING;
      CONSTANT Test_Name  : IN    STRING;
      SIGNAL   Test_Pin   : IN    STD_ULOGIC;
      VARIABLE Tsetup_pos : IN    TIME;
      VARIABLE Tsetup_neg : IN    TIME;
      VARIABLE Thold_pos  : IN    TIME;
      VARIABLE Thold_neg  : IN    TIME;
      VARIABLE HoldBy_pos : INOUT TIME;
      VARIABLE HoldBy_neg : INOUT TIME;
      VARIABLE Tmg_error  : INOUT STD_ULOGIC ) IS
  BEGIN
    -- posedge Test_Pin
    IF (Test_Pin'last_value='0' AND Test_Pin/='0') OR
       (Test_Pin'last_value='X' AND Test_Pin='1')  THEN
      IF Test_Pin'last_event<Tsetup_pos THEN
        TmgErrMsg( MsgOn,
            "Setup Violation on "&Test_Name&" with respect to "&Ref_Name,
            NOW, Tsetup_pos, Test_Pin'last_event);
        Tmg_error := Tmg_error OR '1';
      END IF;
      HoldBy_pos := NOW + Thold_pos;
      HoldBy_neg := NOW + Thold_neg;
    END IF;
    -- negedge Test_Pin
    IF (Test_Pin'last_value='1' AND Test_Pin/='1') OR
       (Test_Pin'last_value='X' AND Test_Pin='0')  THEN
      IF Test_Pin'last_event<Tsetup_neg THEN
        TmgErrMsg( MsgOn,
            "Setup Violation on "&Test_Name&" with respect to "&Ref_Name,
            NOW, Tsetup_neg, Test_Pin'last_event);
        Tmg_error := Tmg_error OR '1';
      END IF;
      HoldBy_pos := NOW + Thold_pos;
      HoldBy_neg := NOW + Thold_neg;
    END IF;
  END CheckSetup;
  PROCEDURE CheckHold(
      CONSTANT MsgOn      : IN    BOOLEAN;
      CONSTANT Ref_Name   : IN    STRING;
      CONSTANT Test_Name  : IN    STRING;
      SIGNAL   Test_Pin   : IN    STD_ULOGIC;
      VARIABLE Thold_pos  : IN    TIME;
      VARIABLE Thold_neg  : IN    TIME;
      VARIABLE HoldBy_pos : INOUT TIME;
      VARIABLE HoldBy_neg : INOUT TIME;
      VARIABLE Tmg_error  : INOUT STD_ULOGIC ) IS
  BEGIN
    IF Test_Pin'event THEN
      -- posedge Test_Pin
      IF (Test_Pin'last_value='0' AND Test_Pin/='0') OR
         (Test_Pin'last_value='X' AND Test_Pin='1')  THEN
        IF HoldBy_pos>NOW THEN
          TmgErrMsg( MsgOn,
              "Hold Violation on "&Test_Name&" with respect to "&Ref_Name,
              NOW, Thold_pos, Thold_pos - (HoldBy_pos - NOW));
          Tmg_error := Tmg_error OR '1';
          HoldBy_pos := 0 ns;
          HoldBy_neg := 0 ns;
        END IF;
      END IF;
      -- negedge Test_Pin
      IF (Test_Pin'last_value='1' AND Test_Pin/='1') OR
         (Test_Pin'last_value='X' AND Test_Pin='0')  THEN
        IF HoldBy_neg>NOW THEN
          TmgErrMsg( MsgOn,
              "Hold Violation on "&Test_Name&" with respect to "&Ref_Name,
              NOW, Thold_neg, Thold_neg - (HoldBy_neg - NOW));
          Tmg_error := Tmg_error OR '1';
          HoldBy_pos := 0 ns;
          HoldBy_neg := 0 ns;
        END IF;
      END IF;
    END IF;
  END CheckHold;
  FUNCTION MIN( t1,t2 : time) RETURN time IS
    VARIABLE result : time;
  BEGIN
    result := t1;
    IF t1>t2 THEN
      result := t2;
    END IF;
    RETURN( result);
  END MIN;
  FUNCTION MAX( t1,t2 : time) RETURN time IS
    VARIABLE result : time;
  BEGIN
    result := t1;
    IF t1<t2 THEN
      result := t2;
    END IF;
    RETURN( result);
  END MAX;
  FUNCTION VCT2I( x : std_ulogic) RETURN integer IS
    VARIABLE result : integer;
  BEGIN
    CASE x IS
      WHEN '1'    => result := 1;
      WHEN '0'    => result := 0;
      WHEN OTHERS => RETURN( -1);
    END CASE;
    RETURN( result);
  END VCT2I;
  FUNCTION VCT2I( x : std_ulogic_vector) RETURN integer IS
    VARIABLE result : integer;
  BEGIN
    result := 0;
    FOR i IN x'range loop
      CASE x(i) IS
        WHEN '1'    => result := 2 * result + 1;
        WHEN '0'    => result := 2 * result;
        WHEN OTHERS => RETURN( -1);
      END CASE;
    END LOOP;
    RETURN( result);
  END VCT2I;
  FUNCTION ItoIndex( val : integer) RETURN string IS
    VARIABLE result    : string(1 to 10);
    VARIABLE buff      : string(10 downto 1);
    VARIABLE lval, pos : integer;
  BEGIN
    lval := val;
    pos  := 1;
    LOOP
      buff(pos) := character'val(character'pos('0') + (lval MOD 10));
      pos  := pos + 1;
      lval := lval / 10;
      EXIT WHEN lval = 0;
    END LOOP;
    result(1)        := '(';
    result(2 to pos) := buff(pos-1 downto 1);
    result(pos+1)    := ')';
    RETURN( result(1 to pos+1));
  END ItoIndex;
  FUNCTION MuxedSig( dt0, dt1, sel : std_ulogic) RETURN std_ulogic IS
    VARIABLE result : std_ulogic;
  BEGIN
    IF sel='0' THEN
      result := dt0;
    ELSIF sel='1' THEN
      result := dt1;
    ELSE
      result := dt0;
      IF dt0/=dt1 THEN
        result := 'X';
      END IF;
    END IF;
    RETURN( result);
  END MuxedSig;
  FUNCTION MuxedSig( dt0, dt1 : std_ulogic_vector;
                     sel      : std_ulogic) RETURN std_ulogic_vector IS
    ALIAS    ldt0   : std_ulogic_vector(dt0'LENGTH downto 1) IS dt0;
    ALIAS    ldt1   : std_ulogic_vector(dt1'LENGTH downto 1) IS dt1;
    VARIABLE result : std_ulogic_vector(dt0'LENGTH downto 1);
  BEGIN
    FOR i IN 1 to ldt0'LENGTH LOOP
      result(i) := MuxedSig( ldt0(i), ldt1(i), sel);
    END LOOP;
    RETURN( result);
  END MuxedSig;
  FUNCTION EvalRising( SIGNAL sig : std_ulogic) RETURN std_ulogic IS
    VARIABLE result : std_ulogic;
  BEGIN
    result := '0';
    IF sig'last_event=0 ns THEN
      IF (sig'last_value='X' AND sig='1') OR
         (sig'last_value='0' AND sig='X') OR
         (sig'last_value='X' AND sig='X') THEN
        result := 'X';
      ELSIF sig'last_value='0' AND sig='1' THEN
        result := '1';
      END IF;
    END IF;
    RETURN( result);
  END EvalRising;
  FUNCTION EvalFalling( SIGNAL sig : std_ulogic) RETURN std_ulogic IS
    VARIABLE result : std_ulogic;
  BEGIN
    result := '0';
    IF sig'last_event=0 ns THEN
      IF (sig'last_value='X' AND sig='0') OR
         (sig'last_value='1' AND sig='X') OR
         (sig'last_value='X' AND sig='X') THEN
        result := 'X';
      ELSIF sig'last_value='1' AND sig='0' THEN
        result := '1';
      END IF;
    END IF;
    RETURN( result);
  END EvalFalling;
  FUNCTION LatchedSig( clk_sts, reg, dat : std_ulogic) RETURN std_ulogic IS
    VARIABLE result : std_ulogic;
  BEGIN
    IF clk_sts='1' THEN         -- rising  edge of clk
      result := dat;
    ELSIF clk_sts='0' THEN
      result := reg;
    ELSE                        -- unknown edge of clk
--    result := reg;		---- prevent the latching X
--    IF reg/=dat THEN          ----
        result := 'X';
--    END IF;			----
    END IF;
    RETURN( result);
  END LatchedSig;
  FUNCTION LatchedSig( clk_sts  : std_ulogic;
                       reg, dat : std_ulogic_vector) RETURN std_ulogic_vector IS
    ALIAS    lreg   : std_ulogic_vector(reg'LENGTH downto 1) IS reg;
    ALIAS    ldat   : std_ulogic_vector(dat'LENGTH downto 1) IS dat;
    VARIABLE result : std_ulogic_vector(reg'LENGTH downto 1);
  BEGIN
    FOR i IN 1 to lreg'LENGTH LOOP
      result(i) := LatchedSig( clk_sts, lreg(i), ldat(i));
    END LOOP;
    RETURN( result);
  END LatchedSig;
  FUNCTION CompVectorX( l,r : X01_vector) RETURN boolean IS
    VARIABLE result     : boolean;
    VARIABLE lbit       : integer;
    VARIABLE x01l, x01r : std_ulogic_vector(l'LENGTH-1 downto 0);
  BEGIN
    result := TRUE;
    lbit   := 0;
    x01l   := To_X01( l);
    x01r   := To_X01( r);
    WHILE lbit<l'LENGTH AND result LOOP
      IF x01l(lbit)/='X' AND x01r(lbit)/='X' AND x01l(lbit)/=x01r(lbit) THEN
        result := FALSE;
      END IF;
      lbit := lbit + 1;
    END LOOP;
    RETURN( result);
  END CompVectorX;
  FUNCTION CountX( x : std_ulogic_vector) RETURN integer IS
    VARIABLE num : integer;
  BEGIN
    num := 0;
    FOR i IN x'range loop
      IF x(i)='X' THEN
        num := num + 1;
      END IF;
    END LOOP;
    RETURN( num);
  END CountX;
  PROCEDURE ResetCounter( value : INOUT std_ulogic_vector ) IS
    ALIAS lvalue : std_ulogic_vector(value'LENGTH downto 1) IS value;
  BEGIN
    FOR i IN 1 to value'LENGTH LOOP
      lvalue(i) := '0';
    END LOOP;
  END ResetCounter;
  PROCEDURE CountUp( value : INOUT std_ulogic_vector ) IS
    ALIAS    lvalue : std_ulogic_vector(value'LENGTH-1 downto 0) IS value;
    VARIABLE lcarry : std_ulogic;
    VARIABLE lbit   : integer;
  BEGIN
    lcarry := '1';
    lbit   := 0;
    WHILE lbit<value'LENGTH AND lcarry='1' LOOP
      IF lvalue(lbit)='1' AND lcarry='1' THEN
        lvalue(lbit) := '0';
        lcarry       := '1';
      ELSIF lvalue(lbit)='0' AND lcarry='1' THEN
        lvalue(lbit) := '1';
        lcarry       := '0';
      END IF;
      lbit := lbit + 1;
    END LOOP;
  END CountUp;
  PROCEDURE CombAddress( address    : IN  std_ulogic_vector;
                         pattern    : IN  std_ulogic_vector;
                         newAddress : OUT std_ulogic_vector ) IS
    ALIAS    lptns : std_ulogic_vector(pattern'LENGTH-1 downto 0) IS pattern;
    ALIAS    ladrs : std_ulogic_vector(address'LENGTH-1 downto 0) IS address;
    VARIABLE lbptn : integer;
    VARIABLE lbadr : integer;
    VARIABLE lnadr : std_ulogic_vector(address'LENGTH-1 downto 0);
  BEGIN
    lbptn := 0;
    lbadr := 0;
    lnadr := ladrs;
    WHILE lbadr<address'LENGTH AND lbptn<pattern'LENGTH LOOP
      IF lnadr(lbadr)='X' THEN
        lnadr(lbadr) := lptns(lbptn);
        lbptn := lbptn + 1;
      END IF;
      lbadr := lbadr + 1;
    END LOOP;
    newAddress := lnadr;
  END CombAddress;
  PROCEDURE MemoryRead(
            memory  : INOUT MEM;
            depth   : IN    integer;
            clk_sts : IN    std_ulogic;
            re      : IN    std_ulogic;
            adrs    : IN    std_ulogic_vector;
            data    : INOUT std_ulogic_vector ) IS
    VARIABLE ladrs  : std_ulogic_vector(adrs'LENGTH-1 downto 0);
    VARIABLE xcnt   : integer;
    VARIABLE cnt    : std_ulogic_vector(adrs'LENGTH downto 0);
    VARIABLE xadrs  : std_ulogic_vector(adrs'LENGTH-1 downto 0);
    VARIABLE lxadrs : integer;
    VARIABLE ldata  : std_ulogic_vector(data'LENGTH-1 downto 0);
  BEGIN
    IF clk_sts/='0' THEN
      IF re/='0' THEN
        ladrs := adrs;
        ldata := data;
        IF re='X' THEN			-- memory access with input X
          ldata := (others=>'X');	--
        END IF;				--
        IF VCT2I(adrs)<0 THEN		-- memory access with input X
          ladrs := (others=>'X');	--
          ldata := (others=>'X');	--
        END IF;				--
        ResetCounter( cnt);
        xcnt := CountX( ladrs);
        CombAddress( ladrs, cnt, xadrs);
        lxadrs := VCT2I( xadrs);
        IF lxadrs<depth THEN
          IF clk_sts='1' AND re='1' THEN
            ldata := memory(lxadrs);
          END IF;
          WHILE cnt(xcnt)='0' LOOP
            CombAddress( ladrs, cnt, xadrs);
            lxadrs := VCT2I( xadrs);
            IF lxadrs<depth THEN
              FOR ld IN 0 to ldata'length-1 LOOP
                IF ld<ldata'LENGTH THEN
                  IF memory(lxadrs)(ld)/=ldata(ld) THEN
                    ldata(ld) := 'X';
                  END IF;
                END IF;
              END LOOP;
            END IF;
            CountUp( cnt);
          END LOOP;
        ELSE                            -- out of range
          ldata := (others=>'X');       --
        END IF;
        data := ldata;
      END IF;
    END IF;
  END MemoryRead;
  PROCEDURE MemoryWrite(
            memory  : INOUT MEM;
            depth   : IN    integer;
            clk_sts : IN    std_ulogic;
            we      : IN    std_ulogic;
            bwe     : IN    std_ulogic_vector;
            adrs    : IN    std_ulogic_vector;
            data    : IN    std_ulogic_vector ) IS
    VARIABLE lbwe   : std_ulogic_vector(bwe'LENGTH-1  downto 0);
    VARIABLE ladrs  : std_ulogic_vector(adrs'LENGTH-1 downto 0);
    VARIABLE xcnt   : integer;
    VARIABLE cnt    : std_ulogic_vector(adrs'LENGTH downto 0);
    VARIABLE xadrs  : std_ulogic_vector(adrs'LENGTH-1 downto 0);
    VARIABLE lxadrs : integer;
    VARIABLE ldata  : std_ulogic_vector(data'LENGTH-1 downto 0);
  BEGIN
    IF clk_sts/='0' THEN
      IF we/='0' THEN
        ladrs := adrs;
        lbwe  := bwe;
        ldata := data;
        IF we='X' THEN			-- memory access with input X
          ldata := (others=>'X');	--
        END IF;				--
--      IF VCT2I(bwe)<0 THEN		-- memory access with input X
--        lbwe := (others=>'X');	--
--        ldata := (others=>'X');	--
--      END IF;				--
        IF VCT2I(adrs)<0 THEN		-- memory access with input X
          ladrs := (others=>'X');	--
          ldata := (others=>'X');	--
        END IF;				--
        ResetCounter( cnt);
        xcnt := CountX( ladrs);
        CombAddress( ladrs, cnt, xadrs);
        lxadrs := VCT2I( xadrs);
        IF lxadrs<depth THEN
          IF xcnt>0 THEN
            MemoryRead( memory, depth, 'X', '1', adrs, ldata);
          END IF;
          WHILE cnt(xcnt)='0' LOOP
            CombAddress( ladrs, cnt, xadrs);
            lxadrs := VCT2I( xadrs);
            IF lxadrs<depth THEN
              FOR lb IN 0 to (ldata'LENGTH-1)/8 LOOP
                IF lbwe(lb)/='0' THEN
                  FOR ld IN lb*8 to (lb+1)*8-1 LOOP
                    IF ld<ldata'LENGTH THEN
                      IF xcnt=0 AND clk_sts='1' AND we='1' AND lbwe(lb)='1' THEN
                        memory(lxadrs)(ld) := ldata(ld);
                      ELSE
                        memory(lxadrs)(ld) := 'X';
                      END IF;
                    END IF;
                  END LOOP;
                END IF;
              END LOOP;
            END IF;
            CountUp( cnt);
          END LOOP;
        END IF;
      END IF;
    END IF;
  END MemoryWrite;
  PROCEDURE MemoryWrite(
            memory  : INOUT MEM;
            depth   : IN    integer;
            clk_sts : IN    std_ulogic;
            we      : IN    std_ulogic;
            adrs    : IN    std_ulogic_vector;
            data    : IN    std_ulogic_vector ) IS
    VARIABLE bwe : std_ulogic_vector(1 downto 0);
  BEGIN
    bwe := (others=>'1');
    MemoryWrite( memory, depth, clk_sts, we, bwe, adrs, data);
  END MemoryWrite;

BEGIN

------------------------------------------------------------------------
-- INPUT DELAY SECTION
------------------------------------------------------------------------
  WireDelay : BLOCK
  BEGIN
    VitalWireDelay( RCK_ipd, RCK, tipd_RCK);
    VitalWireDelay( REN_ipd, REN, tipd_REN);
    WD_RADR : FOR n IN RADR'range GENERATE
      VitalWireDelay( RADR_ipd(n), RADR(n), tipd_RADR(n));
    END GENERATE;
    VitalWireDelay( WCK_ipd, WCK, tipd_WCK);
    VitalWireDelay( WEN_ipd, WEN, tipd_WEN);
    WD_WADR : FOR n IN WADR'range GENERATE
      VitalWireDelay( WADR_ipd(n), WADR(n), tipd_WADR(n));
    END GENERATE;
    WD_DI : FOR n IN DI'range GENERATE
      VitalWireDelay( DI_ipd(n), DI(n), tipd_DI(n));
    END GENERATE;
  END BLOCK;

------------------------------------------------------------------------
-- SIMPLIFIED SIGNALS SECTION
------------------------------------------------------------------------
  Simplified_Sigs : PROCESS( RCK_ipd, REN_ipd,
                             WCK_ipd, WEN_ipd,
                             RADR_ipd, WADR_ipd, DI_ipd )
  BEGIN
    RCK_X01    <= To_X01( RCK_ipd);
    REN_X01    <= To_X01( REN_ipd);
    WCK_X01    <= To_X01( WCK_ipd);
    WEN_X01    <= To_X01( WEN_ipd);
    RADR_X01   <= To_X01( RADR_ipd);
    WADR_X01   <= To_X01( WADR_ipd);
    DI_X01     <= To_X01( DI_ipd);

    int_rd_clock <= To_X01( RCK_ipd);
    int_wr_clock <= To_X01( WCK_ipd);
  END PROCESS;

------------------------------------------------------------------------
-- TIMING CHECK SECTION
------------------------------------------------------------------------
  TimingCheck : PROCESS( RCK_X01, WCK_X01, REN_X01, WEN_X01, BWEN_X01,
                         RADR_X01, WADR_X01, DI_X01, OEN_X01,
                         TCE_X01, TSE_X01, TRCN_X01, TWCK_X01, TIREN_X01, TIWEN_X01,
                         TIRADR_X01, TIWADR_X01, TID_X01, BYP_X01, int_wr_clock )
    -- define local timing values
    VARIABLE Initialized                   : BOOLEAN        := TRUE;
    VARIABLE tc_tsetup_REN_RCK_posedge     : VitalDelayType := 0 ns;
    VARIABLE tc_tsetup_REN_RCK_negedge     : VitalDelayType := 0 ns;
    VARIABLE tc_thold_REN_RCK_posedge      : VitalDelayType := 0 ns;
    VARIABLE tc_thold_REN_RCK_negedge      : VitalDelayType := 0 ns;
    VARIABLE tc_tsetup_RADR_RCK_posedge    : VitalDelayArrayType(6 downto 0) := (others=>0 ns);
    VARIABLE tc_tsetup_RADR_RCK_negedge    : VitalDelayArrayType(6 downto 0) := (others=>0 ns);
    VARIABLE tc_thold_RADR_RCK_posedge     : VitalDelayArrayType(6 downto 0) := (others=>0 ns);
    VARIABLE tc_thold_RADR_RCK_negedge     : VitalDelayArrayType(6 downto 0) := (others=>0 ns);
    VARIABLE tc_tsetup_WEN_WCK_posedge     : VitalDelayType := 0 ns;
    VARIABLE tc_tsetup_WEN_WCK_negedge     : VitalDelayType := 0 ns;
    VARIABLE tc_thold_WEN_WCK_posedge      : VitalDelayType := 0 ns;
    VARIABLE tc_thold_WEN_WCK_negedge      : VitalDelayType := 0 ns;
    VARIABLE tc_tsetup_WADR_WCK_posedge    : VitalDelayArrayType(6 downto 0) := (others=>0 ns);
    VARIABLE tc_tsetup_WADR_WCK_negedge    : VitalDelayArrayType(6 downto 0) := (others=>0 ns);
    VARIABLE tc_thold_WADR_WCK_posedge     : VitalDelayArrayType(6 downto 0) := (others=>0 ns);
    VARIABLE tc_thold_WADR_WCK_negedge     : VitalDelayArrayType(6 downto 0) := (others=>0 ns);
    VARIABLE tc_tsetup_DI_WCK_posedge      : VitalDelayArrayType(15 downto 0) := (others=>0 ns);
    VARIABLE tc_tsetup_DI_WCK_negedge      : VitalDelayArrayType(15 downto 0) := (others=>0 ns);
    VARIABLE tc_thold_DI_WCK_posedge       : VitalDelayArrayType(15 downto 0) := (others=>0 ns);
    VARIABLE tc_thold_DI_WCK_negedge       : VitalDelayArrayType(15 downto 0) := (others=>0 ns);
    VARIABLE tc_tperiod_RCK      : VitalDelayType := 0 ns;
    VARIABLE tc_tperiod_WCK      : VitalDelayType := 0 ns;
    VARIABLE tc_tpw_RCK_posedge  : VitalDelayType := 0 ns;
    VARIABLE tc_tpw_RCK_negedge  : VitalDelayType := 0 ns;
    VARIABLE tc_tpw_WCK_posedge  : VitalDelayType := 0 ns;
    VARIABLE tc_tpw_WCK_negedge  : VitalDelayType := 0 ns;
    VARIABLE tc_tw_RCK_WCK       : VitalDelayType := 0 ns;
    VARIABLE tc_tw_WCK_RCK       : VitalDelayType := 0 ns;
    -- define timing violation flags and working variables
    TYPE ArrayTIME IS ARRAY (NATURAL RANGE <>) OF TIME;
    VARIABLE RCK_period_HoldBy  : TIME := 0 ns;
    VARIABLE RCK_negedge_HoldBy : TIME := 0 ns;
    VARIABLE WCK_period_HoldBy  : TIME := 0 ns;
    VARIABLE WCK_negedge_HoldBy : TIME := 0 ns;
    VARIABLE REN_RCK_posedge_HoldBy      : TIME := 0 ns;
    VARIABLE REN_RCK_negedge_HoldBy      : TIME := 0 ns;
    VARIABLE RADR_RCK_posedge_HoldBy     : ArrayTIME(6 downto 0) := (others=>0 ns);
    VARIABLE RADR_RCK_negedge_HoldBy     : ArrayTIME(6 downto 0) := (others=>0 ns);
    VARIABLE WEN_WCK_posedge_HoldBy      : TIME := 0 ns;
    VARIABLE WEN_WCK_negedge_HoldBy      : TIME := 0 ns;
    VARIABLE WADR_WCK_posedge_HoldBy     : ArrayTIME(6 downto 0) := (others=>0 ns);
    VARIABLE WADR_WCK_negedge_HoldBy     : ArrayTIME(6 downto 0) := (others=>0 ns);
    VARIABLE DI_WCK_posedge_HoldBy       : ArrayTIME(15 downto 0) := (others=>0 ns);
    VARIABLE DI_WCK_negedge_HoldBy       : ArrayTIME(15 downto 0) := (others=>0 ns);
    VARIABLE RCK_WCK_HoldBy  : TIME := 0 ns;
    VARIABLE RCK_WCK_Adrs    : STD_ULOGIC_VECTOR(6 downto 0);
    VARIABLE WCK_RCK_HoldBy  : TIME := 0 ns;
    VARIABLE WCK_RCK_Adrs    : STD_ULOGIC_VECTOR(6 downto 0);
    VARIABLE Tviol_REN_RCK     : STD_ULOGIC := '0';
    VARIABLE Tviol_RADR_RCK    : STD_ULOGIC_VECTOR(6 downto 0) := (others=>'0');
    VARIABLE Tviol_WADR_WCK    : STD_ULOGIC_VECTOR(6 downto 0) := (others=>'0');
    VARIABLE Tviol_DI_WCK      : STD_ULOGIC_VECTOR(15 downto 0) := (others=>'0');
    VARIABLE Tviol_WEN_WCK     : STD_ULOGIC := '0';
    VARIABLE Pviol_RCK         : STD_ULOGIC := '0';
    VARIABLE Pviol_WCK         : STD_ULOGIC := '0';
    VARIABLE Tviol_RCK_WCK     : STD_ULOGIC := '0';
    VARIABLE Tviol_WCK_RCK     : STD_ULOGIC := '0';
    VARIABLE Tviol_RADR_RCK_sum  : STD_ULOGIC;
    VARIABLE Tviol_WADR_WCK_sum  : STD_ULOGIC;
    VARIABLE Tviol_DI_WCK_sum    : STD_ULOGIC;
  BEGIN
    IF TimingChecksOn AND NOW>0 ns THEN
      IF Initialized THEN
        tc_tsetup_REN_RCK_posedge     := selectVal( tsetup_REN_RCK_noedge_posedge, tsetup_REN_RCK_posedge_posedge) * SUHDF;
        tc_tsetup_REN_RCK_negedge     := selectVal( tsetup_REN_RCK_noedge_posedge, tsetup_REN_RCK_negedge_posedge) * SUHDF;
        tc_thold_REN_RCK_posedge      := selectVal( thold_REN_RCK_noedge_posedge, thold_REN_RCK_posedge_posedge) * SUHDF;
        tc_thold_REN_RCK_negedge      := selectVal( thold_REN_RCK_noedge_posedge, thold_REN_RCK_negedge_posedge) * SUHDF;
        tc_tsetup_WEN_WCK_posedge     := selectVal( tsetup_WEN_WCK_noedge_posedge, tsetup_WEN_WCK_posedge_posedge) * SUHDF;
        tc_tsetup_WEN_WCK_negedge     := selectVal( tsetup_WEN_WCK_noedge_posedge, tsetup_WEN_WCK_negedge_posedge) * SUHDF;
        tc_thold_WEN_WCK_posedge      := selectVal( thold_WEN_WCK_noedge_posedge, thold_WEN_WCK_posedge_posedge) * SUHDF;
        tc_thold_WEN_WCK_negedge      := selectVal( thold_WEN_WCK_noedge_posedge, thold_WEN_WCK_negedge_posedge) * SUHDF;
        TMG_RADR : FOR i IN RADR'range LOOP
          tc_tsetup_RADR_RCK_posedge(i) := selectVal( tsetup_RADR_RCK_noedge_posedge(i), tsetup_RADR_RCK_posedge_posedge(i)) * SUHDF;
          tc_tsetup_RADR_RCK_negedge(i) := selectVal( tsetup_RADR_RCK_noedge_posedge(i), tsetup_RADR_RCK_negedge_posedge(i)) * SUHDF;
          tc_thold_RADR_RCK_posedge(i)  := selectVal( thold_RADR_RCK_noedge_posedge(i), thold_RADR_RCK_posedge_posedge(i)) * SUHDF;
          tc_thold_RADR_RCK_negedge(i)  := selectVal( thold_RADR_RCK_noedge_posedge(i), thold_RADR_RCK_negedge_posedge(i)) * SUHDF;
        END LOOP;
        TMG_WADR : FOR i IN WADR'range LOOP
          tc_tsetup_WADR_WCK_posedge(i) := selectVal( tsetup_WADR_WCK_noedge_posedge(i), tsetup_WADR_WCK_posedge_posedge(i)) * SUHDF;
          tc_tsetup_WADR_WCK_negedge(i) := selectVal( tsetup_WADR_WCK_noedge_posedge(i), tsetup_WADR_WCK_negedge_posedge(i)) * SUHDF;
          tc_thold_WADR_WCK_posedge(i)  := selectVal( thold_WADR_WCK_noedge_posedge(i), thold_WADR_WCK_posedge_posedge(i)) * SUHDF;
          tc_thold_WADR_WCK_negedge(i)  := selectVal( thold_WADR_WCK_noedge_posedge(i), thold_WADR_WCK_negedge_posedge(i)) * SUHDF;
        END LOOP;
        TMG_DI : FOR i IN DI'range LOOP
          tc_tsetup_DI_WCK_posedge(i) := selectVal( tsetup_DI_WCK_noedge_posedge(i), tsetup_DI_WCK_posedge_posedge(i)) * SUHDF;
          tc_tsetup_DI_WCK_negedge(i) := selectVal( tsetup_DI_WCK_noedge_posedge(i), tsetup_DI_WCK_negedge_posedge(i)) * SUHDF;
          tc_thold_DI_WCK_posedge(i)  := selectVal( thold_DI_WCK_noedge_posedge(i), thold_DI_WCK_posedge_posedge(i)) * SUHDF;
          tc_thold_DI_WCK_negedge(i)  := selectVal( thold_DI_WCK_noedge_posedge(i), thold_DI_WCK_negedge_posedge(i)) * SUHDF;
        END LOOP;
        tc_tperiod_RCK      := tperiod_RCK_posedge * SUHDF;
        tc_tperiod_WCK      := tperiod_WCK_posedge * SUHDF;
        tc_tpw_RCK_posedge  := selectVal( tpw_RCK_noedge, tpw_RCK_posedge) * SUHDF;
        tc_tpw_RCK_negedge  := selectVal( tpw_RCK_noedge, tpw_RCK_negedge) * SUHDF;
        tc_tpw_WCK_posedge  := selectVal( tpw_WCK_noedge, tpw_WCK_posedge) * SUHDF;
        tc_tpw_WCK_negedge  := selectVal( tpw_WCK_noedge, tpw_WCK_negedge) * SUHDF;
        tc_tw_RCK_WCK       := selectVal( tsetup_RCK_WCK_noedge_posedge, tsetup_RCK_WCK_posedge_rflag_posedge) * SUHDF;
         tc_tw_WCK_RCK       := selectVal( tsetup_WCK_RCK_noedge_posedge, tsetup_WCK_RCK_posedge_wflag_posedge) * SUHDF;


        Initialized := FALSE;
      END IF;

    -- timing checks
      Tviol_REN_RCK         := '0';
      Tviol_RADR_RCK        := (others=>'0');
      Tviol_WADR_WCK        := (others=>'0');
      Tviol_DI_WCK          := (others=>'0');
      Tviol_WEN_WCK         := '0';
      Pviol_RCK             := '0';
      Pviol_WCK             := '0';
      Tviol_RCK_WCK         := '0';
      Tviol_WCK_RCK         := '0';
      Tviol_RADR_RCK_sum    := '0';
      Tviol_WADR_WCK_sum    := '0';
      Tviol_DI_WCK_sum      := '0';

      IF EvalRising(RCK_X01)/='0' THEN
        IF NOW<RCK_period_HoldBy THEN
          TmgErrMsg( MsgOn, "Period Violation on RCK",
              NOW, tc_tperiod_RCK, (NOW-RCK_RisedAt));
          Pviol_RCK := Pviol_RCK OR '1';
        END IF;
        IF (NOW-RCK_FalledAt)<tc_tpw_RCK_negedge THEN
          TmgErrMsg( MsgOn, "Pulse width Violation on RCK",
              NOW, tc_tpw_RCK_negedge, (NOW-RCK_FalledAt));
          Pviol_RCK := Pviol_RCK OR '1';
        END IF;
        RCK_negedge_HoldBy := NOW + tc_tpw_RCK_posedge;
        RCK_period_HoldBy  := NOW + tc_tperiod_RCK;
        RCK_RisedAt <= NOW;
      END IF;
      IF EvalFalling(RCK_X01)/='0' THEN
        IF NOW<RCK_negedge_HoldBy THEN
          TmgErrMsg( MsgOn, "Pulse width Violation on RCK",
              NOW, tc_tpw_RCK_posedge, (NOW-RCK_RisedAt));
          Pviol_RCK := Pviol_RCK OR '1';
        END IF;
        RCK_negedge_HoldBy := 0 ns;
        RCK_FalledAt <= NOW;
      END IF;
      IF EvalRising(WCK_X01)/='0' THEN
        IF TCE_X01/='1' THEN
          IF NOW<WCK_period_HoldBy THEN
            TmgErrMsg( MsgOn, "Period Violation on WCK",
                NOW, tc_tperiod_WCK, (NOW-WCK_RisedAt));
            Pviol_WCK := Pviol_WCK OR '1';
          END IF;
          IF (NOW-WCK_FalledAt)<tc_tpw_WCK_negedge THEN
            TmgErrMsg( MsgOn, "Pulse width Violation on WCK",
                NOW, tc_tpw_WCK_negedge, (NOW-WCK_FalledAt));
            Pviol_WCK := Pviol_WCK OR '1';
          END IF;
          WCK_negedge_HoldBy := NOW + tc_tpw_WCK_posedge;
          WCK_period_HoldBy  := NOW + tc_tperiod_WCK;
        END IF;
        WCK_RisedAt <= NOW;
      END IF;
      IF EvalFalling(WCK_X01)/='0' THEN
        IF NOW<WCK_negedge_HoldBy THEN
          TmgErrMsg( MsgOn, "Pulse width Violation on WCK",
              NOW, tc_tpw_WCK_posedge, (NOW-WCK_RisedAt));
          Pviol_WCK := Pviol_WCK OR '1';
        END IF;
        WCK_negedge_HoldBy := 0 ns;
        WCK_FalledAt <= NOW;
      END IF;

-- Hold timing checks
--  REN
      CheckHold( MsgOn, "RCK", "REN", REN_X01,
          tc_thold_REN_RCK_posedge, tc_thold_REN_RCK_negedge,
          REN_RCK_posedge_HoldBy,   REN_RCK_negedge_HoldBy,   Tviol_REN_RCK);
--  RADR
      CheckHold( MsgOn, "RCK", "RADR(0)", RADR_X01(0),
          tc_thold_RADR_RCK_posedge(0), tc_thold_RADR_RCK_negedge(0),
          RADR_RCK_posedge_HoldBy(0),   RADR_RCK_negedge_HoldBy(0),   Tviol_RADR_RCK(0));
      Tviol_RADR_RCK_sum := Tviol_RADR_RCK_sum OR Tviol_RADR_RCK(0);
      CheckHold( MsgOn, "RCK", "RADR(1)", RADR_X01(1),
          tc_thold_RADR_RCK_posedge(1), tc_thold_RADR_RCK_negedge(1),
          RADR_RCK_posedge_HoldBy(1),   RADR_RCK_negedge_HoldBy(1),   Tviol_RADR_RCK(1));
      Tviol_RADR_RCK_sum := Tviol_RADR_RCK_sum OR Tviol_RADR_RCK(1);
      CheckHold( MsgOn, "RCK", "RADR(2)", RADR_X01(2),
          tc_thold_RADR_RCK_posedge(2), tc_thold_RADR_RCK_negedge(2),
          RADR_RCK_posedge_HoldBy(2),   RADR_RCK_negedge_HoldBy(2),   Tviol_RADR_RCK(2));
      Tviol_RADR_RCK_sum := Tviol_RADR_RCK_sum OR Tviol_RADR_RCK(2);
      CheckHold( MsgOn, "RCK", "RADR(3)", RADR_X01(3),
          tc_thold_RADR_RCK_posedge(3), tc_thold_RADR_RCK_negedge(3),
          RADR_RCK_posedge_HoldBy(3),   RADR_RCK_negedge_HoldBy(3),   Tviol_RADR_RCK(3));
      Tviol_RADR_RCK_sum := Tviol_RADR_RCK_sum OR Tviol_RADR_RCK(3);
      CheckHold( MsgOn, "RCK", "RADR(4)", RADR_X01(4),
          tc_thold_RADR_RCK_posedge(4), tc_thold_RADR_RCK_negedge(4),
          RADR_RCK_posedge_HoldBy(4),   RADR_RCK_negedge_HoldBy(4),   Tviol_RADR_RCK(4));
      Tviol_RADR_RCK_sum := Tviol_RADR_RCK_sum OR Tviol_RADR_RCK(4);
      CheckHold( MsgOn, "RCK", "RADR(5)", RADR_X01(5),
          tc_thold_RADR_RCK_posedge(5), tc_thold_RADR_RCK_negedge(5),
          RADR_RCK_posedge_HoldBy(5),   RADR_RCK_negedge_HoldBy(5),   Tviol_RADR_RCK(5));
      Tviol_RADR_RCK_sum := Tviol_RADR_RCK_sum OR Tviol_RADR_RCK(5);
      CheckHold( MsgOn, "RCK", "RADR(6)", RADR_X01(6),
          tc_thold_RADR_RCK_posedge(6), tc_thold_RADR_RCK_negedge(6),
          RADR_RCK_posedge_HoldBy(6),   RADR_RCK_negedge_HoldBy(6),   Tviol_RADR_RCK(6));
      Tviol_RADR_RCK_sum := Tviol_RADR_RCK_sum OR Tviol_RADR_RCK(6);
--  WEN
      CheckHold( MsgOn, "WCK", "WEN", WEN_X01,
          tc_thold_WEN_WCK_posedge, tc_thold_WEN_WCK_negedge,
          WEN_WCK_posedge_HoldBy,   WEN_WCK_negedge_HoldBy,   Tviol_WEN_WCK);
--  WADR
      CheckHold( MsgOn, "WCK", "WADR(0)", WADR_X01(0),
          tc_thold_WADR_WCK_posedge(0), tc_thold_WADR_WCK_negedge(0),
          WADR_WCK_posedge_HoldBy(0),   WADR_WCK_negedge_HoldBy(0),   Tviol_WADR_WCK(0));
      Tviol_WADR_WCK_sum := Tviol_WADR_WCK_sum OR Tviol_WADR_WCK(0);
      CheckHold( MsgOn, "WCK", "WADR(1)", WADR_X01(1),
          tc_thold_WADR_WCK_posedge(1), tc_thold_WADR_WCK_negedge(1),
          WADR_WCK_posedge_HoldBy(1),   WADR_WCK_negedge_HoldBy(1),   Tviol_WADR_WCK(1));
      Tviol_WADR_WCK_sum := Tviol_WADR_WCK_sum OR Tviol_WADR_WCK(1);
      CheckHold( MsgOn, "WCK", "WADR(2)", WADR_X01(2),
          tc_thold_WADR_WCK_posedge(2), tc_thold_WADR_WCK_negedge(2),
          WADR_WCK_posedge_HoldBy(2),   WADR_WCK_negedge_HoldBy(2),   Tviol_WADR_WCK(2));
      Tviol_WADR_WCK_sum := Tviol_WADR_WCK_sum OR Tviol_WADR_WCK(2);
      CheckHold( MsgOn, "WCK", "WADR(3)", WADR_X01(3),
          tc_thold_WADR_WCK_posedge(3), tc_thold_WADR_WCK_negedge(3),
          WADR_WCK_posedge_HoldBy(3),   WADR_WCK_negedge_HoldBy(3),   Tviol_WADR_WCK(3));
      Tviol_WADR_WCK_sum := Tviol_WADR_WCK_sum OR Tviol_WADR_WCK(3);
      CheckHold( MsgOn, "WCK", "WADR(4)", WADR_X01(4),
          tc_thold_WADR_WCK_posedge(4), tc_thold_WADR_WCK_negedge(4),
          WADR_WCK_posedge_HoldBy(4),   WADR_WCK_negedge_HoldBy(4),   Tviol_WADR_WCK(4));
      Tviol_WADR_WCK_sum := Tviol_WADR_WCK_sum OR Tviol_WADR_WCK(4);
      CheckHold( MsgOn, "WCK", "WADR(5)", WADR_X01(5),
          tc_thold_WADR_WCK_posedge(5), tc_thold_WADR_WCK_negedge(5),
          WADR_WCK_posedge_HoldBy(5),   WADR_WCK_negedge_HoldBy(5),   Tviol_WADR_WCK(5));
      Tviol_WADR_WCK_sum := Tviol_WADR_WCK_sum OR Tviol_WADR_WCK(5);
      CheckHold( MsgOn, "WCK", "WADR(6)", WADR_X01(6),
          tc_thold_WADR_WCK_posedge(6), tc_thold_WADR_WCK_negedge(6),
          WADR_WCK_posedge_HoldBy(6),   WADR_WCK_negedge_HoldBy(6),   Tviol_WADR_WCK(6));
      Tviol_WADR_WCK_sum := Tviol_WADR_WCK_sum OR Tviol_WADR_WCK(6);
--  DI
      CheckHold( MsgOn, "WCK", "DI(0)", DI_X01(0),
          tc_thold_DI_WCK_posedge(0), tc_thold_DI_WCK_negedge(0),
          DI_WCK_posedge_HoldBy(0),   DI_WCK_negedge_HoldBy(0),   Tviol_DI_WCK(0));
      Tviol_DI_WCK_sum := Tviol_DI_WCK_sum OR Tviol_DI_WCK(0);
      CheckHold( MsgOn, "WCK", "DI(1)", DI_X01(1),
          tc_thold_DI_WCK_posedge(1), tc_thold_DI_WCK_negedge(1),
          DI_WCK_posedge_HoldBy(1),   DI_WCK_negedge_HoldBy(1),   Tviol_DI_WCK(1));
      Tviol_DI_WCK_sum := Tviol_DI_WCK_sum OR Tviol_DI_WCK(1);
      CheckHold( MsgOn, "WCK", "DI(2)", DI_X01(2),
          tc_thold_DI_WCK_posedge(2), tc_thold_DI_WCK_negedge(2),
          DI_WCK_posedge_HoldBy(2),   DI_WCK_negedge_HoldBy(2),   Tviol_DI_WCK(2));
      Tviol_DI_WCK_sum := Tviol_DI_WCK_sum OR Tviol_DI_WCK(2);
      CheckHold( MsgOn, "WCK", "DI(3)", DI_X01(3),
          tc_thold_DI_WCK_posedge(3), tc_thold_DI_WCK_negedge(3),
          DI_WCK_posedge_HoldBy(3),   DI_WCK_negedge_HoldBy(3),   Tviol_DI_WCK(3));
      Tviol_DI_WCK_sum := Tviol_DI_WCK_sum OR Tviol_DI_WCK(3);
      CheckHold( MsgOn, "WCK", "DI(4)", DI_X01(4),
          tc_thold_DI_WCK_posedge(4), tc_thold_DI_WCK_negedge(4),
          DI_WCK_posedge_HoldBy(4),   DI_WCK_negedge_HoldBy(4),   Tviol_DI_WCK(4));
      Tviol_DI_WCK_sum := Tviol_DI_WCK_sum OR Tviol_DI_WCK(4);
      CheckHold( MsgOn, "WCK", "DI(5)", DI_X01(5),
          tc_thold_DI_WCK_posedge(5), tc_thold_DI_WCK_negedge(5),
          DI_WCK_posedge_HoldBy(5),   DI_WCK_negedge_HoldBy(5),   Tviol_DI_WCK(5));
      Tviol_DI_WCK_sum := Tviol_DI_WCK_sum OR Tviol_DI_WCK(5);
      CheckHold( MsgOn, "WCK", "DI(6)", DI_X01(6),
          tc_thold_DI_WCK_posedge(6), tc_thold_DI_WCK_negedge(6),
          DI_WCK_posedge_HoldBy(6),   DI_WCK_negedge_HoldBy(6),   Tviol_DI_WCK(6));
      Tviol_DI_WCK_sum := Tviol_DI_WCK_sum OR Tviol_DI_WCK(6);
      CheckHold( MsgOn, "WCK", "DI(7)", DI_X01(7),
          tc_thold_DI_WCK_posedge(7), tc_thold_DI_WCK_negedge(7),
          DI_WCK_posedge_HoldBy(7),   DI_WCK_negedge_HoldBy(7),   Tviol_DI_WCK(7));
      Tviol_DI_WCK_sum := Tviol_DI_WCK_sum OR Tviol_DI_WCK(7);
      CheckHold( MsgOn, "WCK", "DI(8)", DI_X01(8),
          tc_thold_DI_WCK_posedge(8), tc_thold_DI_WCK_negedge(8),
          DI_WCK_posedge_HoldBy(8),   DI_WCK_negedge_HoldBy(8),   Tviol_DI_WCK(8));
      Tviol_DI_WCK_sum := Tviol_DI_WCK_sum OR Tviol_DI_WCK(8);
      CheckHold( MsgOn, "WCK", "DI(9)", DI_X01(9),
          tc_thold_DI_WCK_posedge(9), tc_thold_DI_WCK_negedge(9),
          DI_WCK_posedge_HoldBy(9),   DI_WCK_negedge_HoldBy(9),   Tviol_DI_WCK(9));
      Tviol_DI_WCK_sum := Tviol_DI_WCK_sum OR Tviol_DI_WCK(9);
      CheckHold( MsgOn, "WCK", "DI(10)", DI_X01(10),
          tc_thold_DI_WCK_posedge(10), tc_thold_DI_WCK_negedge(10),
          DI_WCK_posedge_HoldBy(10),   DI_WCK_negedge_HoldBy(10),   Tviol_DI_WCK(10));
      Tviol_DI_WCK_sum := Tviol_DI_WCK_sum OR Tviol_DI_WCK(10);
      CheckHold( MsgOn, "WCK", "DI(11)", DI_X01(11),
          tc_thold_DI_WCK_posedge(11), tc_thold_DI_WCK_negedge(11),
          DI_WCK_posedge_HoldBy(11),   DI_WCK_negedge_HoldBy(11),   Tviol_DI_WCK(11));
      Tviol_DI_WCK_sum := Tviol_DI_WCK_sum OR Tviol_DI_WCK(11);
      CheckHold( MsgOn, "WCK", "DI(12)", DI_X01(12),
          tc_thold_DI_WCK_posedge(12), tc_thold_DI_WCK_negedge(12),
          DI_WCK_posedge_HoldBy(12),   DI_WCK_negedge_HoldBy(12),   Tviol_DI_WCK(12));
      Tviol_DI_WCK_sum := Tviol_DI_WCK_sum OR Tviol_DI_WCK(12);
      CheckHold( MsgOn, "WCK", "DI(13)", DI_X01(13),
          tc_thold_DI_WCK_posedge(13), tc_thold_DI_WCK_negedge(13),
          DI_WCK_posedge_HoldBy(13),   DI_WCK_negedge_HoldBy(13),   Tviol_DI_WCK(13));
      Tviol_DI_WCK_sum := Tviol_DI_WCK_sum OR Tviol_DI_WCK(13);
      CheckHold( MsgOn, "WCK", "DI(14)", DI_X01(14),
          tc_thold_DI_WCK_posedge(14), tc_thold_DI_WCK_negedge(14),
          DI_WCK_posedge_HoldBy(14),   DI_WCK_negedge_HoldBy(14),   Tviol_DI_WCK(14));
      Tviol_DI_WCK_sum := Tviol_DI_WCK_sum OR Tviol_DI_WCK(14);
      CheckHold( MsgOn, "WCK", "DI(15)", DI_X01(15),
          tc_thold_DI_WCK_posedge(15), tc_thold_DI_WCK_negedge(15),
          DI_WCK_posedge_HoldBy(15),   DI_WCK_negedge_HoldBy(15),   Tviol_DI_WCK(15));
      Tviol_DI_WCK_sum := Tviol_DI_WCK_sum OR Tviol_DI_WCK(15);

-- Setup timing checks
      IF EvalRising(RCK_X01)/='0' THEN
--  REN
          CheckSetup( MsgOn, "RCK", "REN", REN_X01,
              tc_tsetup_REN_RCK_posedge, tc_tsetup_REN_RCK_negedge,
              tc_thold_REN_RCK_posedge, tc_thold_REN_RCK_negedge,
              REN_RCK_posedge_HoldBy,   REN_RCK_negedge_HoldBy,   Tviol_REN_RCK);
        IF REN_X01/='1' THEN
--  RADR
          CheckSetup( MsgOn, "RCK", "RADR(0)", RADR_X01(0),
              tc_tsetup_RADR_RCK_posedge(0), tc_tsetup_RADR_RCK_negedge(0),
              tc_thold_RADR_RCK_posedge(0), tc_thold_RADR_RCK_negedge(0),
              RADR_RCK_posedge_HoldBy(0),   RADR_RCK_negedge_HoldBy(0),   Tviol_RADR_RCK(0));
          Tviol_RADR_RCK_sum := Tviol_RADR_RCK_sum OR Tviol_RADR_RCK(0);
          CheckSetup( MsgOn, "RCK", "RADR(1)", RADR_X01(1),
              tc_tsetup_RADR_RCK_posedge(1), tc_tsetup_RADR_RCK_negedge(1),
              tc_thold_RADR_RCK_posedge(1), tc_thold_RADR_RCK_negedge(1),
              RADR_RCK_posedge_HoldBy(1),   RADR_RCK_negedge_HoldBy(1),   Tviol_RADR_RCK(1));
          Tviol_RADR_RCK_sum := Tviol_RADR_RCK_sum OR Tviol_RADR_RCK(1);
          CheckSetup( MsgOn, "RCK", "RADR(2)", RADR_X01(2),
              tc_tsetup_RADR_RCK_posedge(2), tc_tsetup_RADR_RCK_negedge(2),
              tc_thold_RADR_RCK_posedge(2), tc_thold_RADR_RCK_negedge(2),
              RADR_RCK_posedge_HoldBy(2),   RADR_RCK_negedge_HoldBy(2),   Tviol_RADR_RCK(2));
          Tviol_RADR_RCK_sum := Tviol_RADR_RCK_sum OR Tviol_RADR_RCK(2);
          CheckSetup( MsgOn, "RCK", "RADR(3)", RADR_X01(3),
              tc_tsetup_RADR_RCK_posedge(3), tc_tsetup_RADR_RCK_negedge(3),
              tc_thold_RADR_RCK_posedge(3), tc_thold_RADR_RCK_negedge(3),
              RADR_RCK_posedge_HoldBy(3),   RADR_RCK_negedge_HoldBy(3),   Tviol_RADR_RCK(3));
          Tviol_RADR_RCK_sum := Tviol_RADR_RCK_sum OR Tviol_RADR_RCK(3);
          CheckSetup( MsgOn, "RCK", "RADR(4)", RADR_X01(4),
              tc_tsetup_RADR_RCK_posedge(4), tc_tsetup_RADR_RCK_negedge(4),
              tc_thold_RADR_RCK_posedge(4), tc_thold_RADR_RCK_negedge(4),
              RADR_RCK_posedge_HoldBy(4),   RADR_RCK_negedge_HoldBy(4),   Tviol_RADR_RCK(4));
          Tviol_RADR_RCK_sum := Tviol_RADR_RCK_sum OR Tviol_RADR_RCK(4);
          CheckSetup( MsgOn, "RCK", "RADR(5)", RADR_X01(5),
              tc_tsetup_RADR_RCK_posedge(5), tc_tsetup_RADR_RCK_negedge(5),
              tc_thold_RADR_RCK_posedge(5), tc_thold_RADR_RCK_negedge(5),
              RADR_RCK_posedge_HoldBy(5),   RADR_RCK_negedge_HoldBy(5),   Tviol_RADR_RCK(5));
          Tviol_RADR_RCK_sum := Tviol_RADR_RCK_sum OR Tviol_RADR_RCK(5);
          CheckSetup( MsgOn, "RCK", "RADR(6)", RADR_X01(6),
              tc_tsetup_RADR_RCK_posedge(6), tc_tsetup_RADR_RCK_negedge(6),
              tc_thold_RADR_RCK_posedge(6), tc_thold_RADR_RCK_negedge(6),
              RADR_RCK_posedge_HoldBy(6),   RADR_RCK_negedge_HoldBy(6),   Tviol_RADR_RCK(6));
          Tviol_RADR_RCK_sum := Tviol_RADR_RCK_sum OR Tviol_RADR_RCK(6);
        END IF;
--  WCK & RCK
        IF REN_X01/='1' THEN
          IF compVectorX(RADR_X01,RCK_WCK_Adrs) THEN
            IF RCK_WCK_HoldBy>NOW THEN
              TmgErrMsg( MsgOn, "Violation between WCK and RCK for a Simultaneous Read/Write",
                  NOW, tc_tw_WCK_RCK, tc_tw_WCK_RCK - (RCK_WCK_HoldBy - NOW));
              Tviol_WCK_RCK  := Tviol_WCK_RCK OR '1';
              RCK_WCK_HoldBy := 0 ns;
            END IF;
          END IF;
          WCK_RCK_Adrs   := RADR_X01;
          WCK_RCK_HoldBy := NOW + tc_tw_RCK_WCK;
        END IF;
      END IF;
      IF EvalRising(int_wr_clock)/='0' THEN
--  WEN
              CheckSetup( MsgOn, "WCK", "WEN", WEN_X01,
                  tc_tsetup_WEN_WCK_posedge, tc_tsetup_WEN_WCK_negedge,
                  tc_thold_WEN_WCK_posedge, tc_thold_WEN_WCK_negedge,
                  WEN_WCK_posedge_HoldBy,   WEN_WCK_negedge_HoldBy,   Tviol_WEN_WCK);
          IF WEN_X01/='1' THEN
--  WADR
            CheckSetup( MsgOn, "WCK", "WADR(0)", WADR_X01(0),
                tc_tsetup_WADR_WCK_posedge(0), tc_tsetup_WADR_WCK_negedge(0),
                tc_thold_WADR_WCK_posedge(0), tc_thold_WADR_WCK_negedge(0),
                WADR_WCK_posedge_HoldBy(0),   WADR_WCK_negedge_HoldBy(0),   Tviol_WADR_WCK(0));
            Tviol_WADR_WCK_sum := Tviol_WADR_WCK_sum OR Tviol_WADR_WCK(0);
            CheckSetup( MsgOn, "WCK", "WADR(1)", WADR_X01(1),
                tc_tsetup_WADR_WCK_posedge(1), tc_tsetup_WADR_WCK_negedge(1),
                tc_thold_WADR_WCK_posedge(1), tc_thold_WADR_WCK_negedge(1),
                WADR_WCK_posedge_HoldBy(1),   WADR_WCK_negedge_HoldBy(1),   Tviol_WADR_WCK(1));
            Tviol_WADR_WCK_sum := Tviol_WADR_WCK_sum OR Tviol_WADR_WCK(1);
            CheckSetup( MsgOn, "WCK", "WADR(2)", WADR_X01(2),
                tc_tsetup_WADR_WCK_posedge(2), tc_tsetup_WADR_WCK_negedge(2),
                tc_thold_WADR_WCK_posedge(2), tc_thold_WADR_WCK_negedge(2),
                WADR_WCK_posedge_HoldBy(2),   WADR_WCK_negedge_HoldBy(2),   Tviol_WADR_WCK(2));
            Tviol_WADR_WCK_sum := Tviol_WADR_WCK_sum OR Tviol_WADR_WCK(2);
            CheckSetup( MsgOn, "WCK", "WADR(3)", WADR_X01(3),
                tc_tsetup_WADR_WCK_posedge(3), tc_tsetup_WADR_WCK_negedge(3),
                tc_thold_WADR_WCK_posedge(3), tc_thold_WADR_WCK_negedge(3),
                WADR_WCK_posedge_HoldBy(3),   WADR_WCK_negedge_HoldBy(3),   Tviol_WADR_WCK(3));
            Tviol_WADR_WCK_sum := Tviol_WADR_WCK_sum OR Tviol_WADR_WCK(3);
            CheckSetup( MsgOn, "WCK", "WADR(4)", WADR_X01(4),
                tc_tsetup_WADR_WCK_posedge(4), tc_tsetup_WADR_WCK_negedge(4),
                tc_thold_WADR_WCK_posedge(4), tc_thold_WADR_WCK_negedge(4),
                WADR_WCK_posedge_HoldBy(4),   WADR_WCK_negedge_HoldBy(4),   Tviol_WADR_WCK(4));
            Tviol_WADR_WCK_sum := Tviol_WADR_WCK_sum OR Tviol_WADR_WCK(4);
            CheckSetup( MsgOn, "WCK", "WADR(5)", WADR_X01(5),
                tc_tsetup_WADR_WCK_posedge(5), tc_tsetup_WADR_WCK_negedge(5),
                tc_thold_WADR_WCK_posedge(5), tc_thold_WADR_WCK_negedge(5),
                WADR_WCK_posedge_HoldBy(5),   WADR_WCK_negedge_HoldBy(5),   Tviol_WADR_WCK(5));
            Tviol_WADR_WCK_sum := Tviol_WADR_WCK_sum OR Tviol_WADR_WCK(5);
            CheckSetup( MsgOn, "WCK", "WADR(6)", WADR_X01(6),
                tc_tsetup_WADR_WCK_posedge(6), tc_tsetup_WADR_WCK_negedge(6),
                tc_thold_WADR_WCK_posedge(6), tc_thold_WADR_WCK_negedge(6),
                WADR_WCK_posedge_HoldBy(6),   WADR_WCK_negedge_HoldBy(6),   Tviol_WADR_WCK(6));
            Tviol_WADR_WCK_sum := Tviol_WADR_WCK_sum OR Tviol_WADR_WCK(6);
--  DI
            CheckSetup( MsgOn, "WCK", "DI(0)", DI_X01(0),
                tc_tsetup_DI_WCK_posedge(0), tc_tsetup_DI_WCK_negedge(0),
                tc_thold_DI_WCK_posedge(0), tc_thold_DI_WCK_negedge(0),
                DI_WCK_posedge_HoldBy(0),   DI_WCK_negedge_HoldBy(0),   Tviol_DI_WCK(0));
            Tviol_DI_WCK_sum := Tviol_DI_WCK_sum OR Tviol_DI_WCK(0);
            CheckSetup( MsgOn, "WCK", "DI(1)", DI_X01(1),
                tc_tsetup_DI_WCK_posedge(1), tc_tsetup_DI_WCK_negedge(1),
                tc_thold_DI_WCK_posedge(1), tc_thold_DI_WCK_negedge(1),
                DI_WCK_posedge_HoldBy(1),   DI_WCK_negedge_HoldBy(1),   Tviol_DI_WCK(1));
            Tviol_DI_WCK_sum := Tviol_DI_WCK_sum OR Tviol_DI_WCK(1);
            CheckSetup( MsgOn, "WCK", "DI(2)", DI_X01(2),
                tc_tsetup_DI_WCK_posedge(2), tc_tsetup_DI_WCK_negedge(2),
                tc_thold_DI_WCK_posedge(2), tc_thold_DI_WCK_negedge(2),
                DI_WCK_posedge_HoldBy(2),   DI_WCK_negedge_HoldBy(2),   Tviol_DI_WCK(2));
            Tviol_DI_WCK_sum := Tviol_DI_WCK_sum OR Tviol_DI_WCK(2);
            CheckSetup( MsgOn, "WCK", "DI(3)", DI_X01(3),
                tc_tsetup_DI_WCK_posedge(3), tc_tsetup_DI_WCK_negedge(3),
                tc_thold_DI_WCK_posedge(3), tc_thold_DI_WCK_negedge(3),
                DI_WCK_posedge_HoldBy(3),   DI_WCK_negedge_HoldBy(3),   Tviol_DI_WCK(3));
            Tviol_DI_WCK_sum := Tviol_DI_WCK_sum OR Tviol_DI_WCK(3);
            CheckSetup( MsgOn, "WCK", "DI(4)", DI_X01(4),
                tc_tsetup_DI_WCK_posedge(4), tc_tsetup_DI_WCK_negedge(4),
                tc_thold_DI_WCK_posedge(4), tc_thold_DI_WCK_negedge(4),
                DI_WCK_posedge_HoldBy(4),   DI_WCK_negedge_HoldBy(4),   Tviol_DI_WCK(4));
            Tviol_DI_WCK_sum := Tviol_DI_WCK_sum OR Tviol_DI_WCK(4);
            CheckSetup( MsgOn, "WCK", "DI(5)", DI_X01(5),
                tc_tsetup_DI_WCK_posedge(5), tc_tsetup_DI_WCK_negedge(5),
                tc_thold_DI_WCK_posedge(5), tc_thold_DI_WCK_negedge(5),
                DI_WCK_posedge_HoldBy(5),   DI_WCK_negedge_HoldBy(5),   Tviol_DI_WCK(5));
            Tviol_DI_WCK_sum := Tviol_DI_WCK_sum OR Tviol_DI_WCK(5);
            CheckSetup( MsgOn, "WCK", "DI(6)", DI_X01(6),
                tc_tsetup_DI_WCK_posedge(6), tc_tsetup_DI_WCK_negedge(6),
                tc_thold_DI_WCK_posedge(6), tc_thold_DI_WCK_negedge(6),
                DI_WCK_posedge_HoldBy(6),   DI_WCK_negedge_HoldBy(6),   Tviol_DI_WCK(6));
            Tviol_DI_WCK_sum := Tviol_DI_WCK_sum OR Tviol_DI_WCK(6);
            CheckSetup( MsgOn, "WCK", "DI(7)", DI_X01(7),
                tc_tsetup_DI_WCK_posedge(7), tc_tsetup_DI_WCK_negedge(7),
                tc_thold_DI_WCK_posedge(7), tc_thold_DI_WCK_negedge(7),
                DI_WCK_posedge_HoldBy(7),   DI_WCK_negedge_HoldBy(7),   Tviol_DI_WCK(7));
            Tviol_DI_WCK_sum := Tviol_DI_WCK_sum OR Tviol_DI_WCK(7);
            CheckSetup( MsgOn, "WCK", "DI(8)", DI_X01(8),
                tc_tsetup_DI_WCK_posedge(8), tc_tsetup_DI_WCK_negedge(8),
                tc_thold_DI_WCK_posedge(8), tc_thold_DI_WCK_negedge(8),
                DI_WCK_posedge_HoldBy(8),   DI_WCK_negedge_HoldBy(8),   Tviol_DI_WCK(8));
            Tviol_DI_WCK_sum := Tviol_DI_WCK_sum OR Tviol_DI_WCK(8);
            CheckSetup( MsgOn, "WCK", "DI(9)", DI_X01(9),
                tc_tsetup_DI_WCK_posedge(9), tc_tsetup_DI_WCK_negedge(9),
                tc_thold_DI_WCK_posedge(9), tc_thold_DI_WCK_negedge(9),
                DI_WCK_posedge_HoldBy(9),   DI_WCK_negedge_HoldBy(9),   Tviol_DI_WCK(9));
            Tviol_DI_WCK_sum := Tviol_DI_WCK_sum OR Tviol_DI_WCK(9);
            CheckSetup( MsgOn, "WCK", "DI(10)", DI_X01(10),
                tc_tsetup_DI_WCK_posedge(10), tc_tsetup_DI_WCK_negedge(10),
                tc_thold_DI_WCK_posedge(10), tc_thold_DI_WCK_negedge(10),
                DI_WCK_posedge_HoldBy(10),   DI_WCK_negedge_HoldBy(10),   Tviol_DI_WCK(10));
            Tviol_DI_WCK_sum := Tviol_DI_WCK_sum OR Tviol_DI_WCK(10);
            CheckSetup( MsgOn, "WCK", "DI(11)", DI_X01(11),
                tc_tsetup_DI_WCK_posedge(11), tc_tsetup_DI_WCK_negedge(11),
                tc_thold_DI_WCK_posedge(11), tc_thold_DI_WCK_negedge(11),
                DI_WCK_posedge_HoldBy(11),   DI_WCK_negedge_HoldBy(11),   Tviol_DI_WCK(11));
            Tviol_DI_WCK_sum := Tviol_DI_WCK_sum OR Tviol_DI_WCK(11);
            CheckSetup( MsgOn, "WCK", "DI(12)", DI_X01(12),
                tc_tsetup_DI_WCK_posedge(12), tc_tsetup_DI_WCK_negedge(12),
                tc_thold_DI_WCK_posedge(12), tc_thold_DI_WCK_negedge(12),
                DI_WCK_posedge_HoldBy(12),   DI_WCK_negedge_HoldBy(12),   Tviol_DI_WCK(12));
            Tviol_DI_WCK_sum := Tviol_DI_WCK_sum OR Tviol_DI_WCK(12);
            CheckSetup( MsgOn, "WCK", "DI(13)", DI_X01(13),
                tc_tsetup_DI_WCK_posedge(13), tc_tsetup_DI_WCK_negedge(13),
                tc_thold_DI_WCK_posedge(13), tc_thold_DI_WCK_negedge(13),
                DI_WCK_posedge_HoldBy(13),   DI_WCK_negedge_HoldBy(13),   Tviol_DI_WCK(13));
            Tviol_DI_WCK_sum := Tviol_DI_WCK_sum OR Tviol_DI_WCK(13);
            CheckSetup( MsgOn, "WCK", "DI(14)", DI_X01(14),
                tc_tsetup_DI_WCK_posedge(14), tc_tsetup_DI_WCK_negedge(14),
                tc_thold_DI_WCK_posedge(14), tc_thold_DI_WCK_negedge(14),
                DI_WCK_posedge_HoldBy(14),   DI_WCK_negedge_HoldBy(14),   Tviol_DI_WCK(14));
            Tviol_DI_WCK_sum := Tviol_DI_WCK_sum OR Tviol_DI_WCK(14);
            CheckSetup( MsgOn, "WCK", "DI(15)", DI_X01(15),
                tc_tsetup_DI_WCK_posedge(15), tc_tsetup_DI_WCK_negedge(15),
                tc_thold_DI_WCK_posedge(15), tc_thold_DI_WCK_negedge(15),
                DI_WCK_posedge_HoldBy(15),   DI_WCK_negedge_HoldBy(15),   Tviol_DI_WCK(15));
            Tviol_DI_WCK_sum := Tviol_DI_WCK_sum OR Tviol_DI_WCK(15);
          END IF;
--  WCK & RCK
        IF WEN_X01/='1' THEN
          IF compVectorX(WADR_X01,WCK_RCK_Adrs) THEN
            IF WCK_RCK_HoldBy>NOW THEN
              TmgErrMsg( MsgOn, "Violation between RCK and WCK for a Simultaneous Read/Write",
                  NOW, tc_tw_RCK_WCK, tc_tw_RCK_WCK - (WCK_RCK_HoldBy - NOW));
              Tviol_RCK_WCK  := Tviol_RCK_WCK OR '1';
              WCK_RCK_HoldBy := 0 ns;
            END IF;
          END IF;
          RCK_WCK_Adrs   := WADR_X01;
          RCK_WCK_HoldBy := NOW + tc_tw_WCK_RCK;
        END IF;
      END IF;


      int_tmg_error_sh_ren     <= Tviol_REN_RCK;
      int_tmg_error_sh_radr    <= Tviol_RADR_RCK;
      int_tmg_error_sh_wenw    <= Tviol_WEN_WCK;
      int_tmg_error_sh_wadrw   <= Tviol_WADR_WCK;
      int_tmg_error_sh_diw     <= Tviol_DI_WCK;
      int_tmg_error_pw_rck     <= Pviol_RCK;
      int_tmg_error_pw_wck     <= Pviol_WCK;
      int_tmg_error_rwclk      <= Tviol_RCK_WCK;
      int_tmg_error_wrclk      <= Tviol_WCK_RCK;
      int_rd_tmg_error <= Tviol_REN_RCK or Tviol_RADR_RCK_sum or Pviol_RCK or Tviol_RCK_WCK;
      int_wr_tmg_error <= Tviol_WEN_WCK or Tviol_WADR_WCK_sum or Tviol_DI_WCK_sum or
                          Pviol_WCK or Tviol_WCK_RCK;
      int_tmg_error <=    Tviol_REN_RCK or Tviol_RADR_RCK_sum or Pviol_RCK or
                          Tviol_WEN_WCK or Tviol_WADR_WCK_sum or Tviol_DI_WCK_sum or
                          Tviol_RCK_WCK or Tviol_WCK_RCK or Pviol_WCK;
    END IF;
  END PROCESS;

------------------------------------------------------------------------
-- SIGNAL-CHECK SECTION
------------------------------------------------------------------------
  CheckSignals : PROCESS( RCK_X01, WCK_X01, REN_X01, WEN_X01, BYP_X01,
    RADR_X01, WADR_X01, DI_X01, TCE_X01, TSE_X01, TRCN_X01, TWCK_X01,
    TIREN_X01, TIWEN_X01, TIRADR_X01, TIWADR_X01, TID_X01, int_wr_clock )
    VARIABLE cs_ra : INTEGER;
    VARIABLE cs_wa : INTEGER;
  BEGIN
    IF MsgOn AND NOW>0 ns THEN
      cs_ra  := VCT2I( RADR_X01);
      cs_wa  := VCT2I( WADR_X01);
      IF EvalRising(RCK_X01)/='0' THEN
        IF REN_X01/='1' AND (RCK_X01'last_value='X' OR RCK_X01='X') THEN
          Msg( MsgOn, "UNKNOWN EDGE Detected on RCK", WARNING);
        END IF;
          IF REN_X01='X' THEN
            Msg( MsgOn, "UNKNOWN Detected on REN", WARNING);
          END IF;
          IF REN_X01/='1' THEN
            SC_RADR : FOR i IN RADR'range LOOP
              IF RADR_X01(i)='X' THEN
                Msg( MsgOn, "UNKNOWN Detected on RADR"&ItoIndex(i), WARNING);
              END IF;
            END LOOP;
            IF cs_ra>=128 THEN
              Msg( MsgOn, "OUT OF RANGE Value Detected on RADR", WARNING);
            END IF;
          END IF;
      END IF;
      IF EvalRising(WCK_X01)/='0' THEN
        IF (WCK_X01'last_value='X' OR WCK_X01='X') THEN
          Msg( MsgOn, "UNKNOWN EDGE Detected on WCK", WARNING);
        END IF;
      END IF;
      IF EvalRising(int_wr_clock)/='0' THEN
          IF WEN_X01='X' THEN
            Msg( MsgOn, "UNKNOWN Detected on WEN", WARNING);
          END IF;
          IF WEN_X01/='1' THEN
            SC_WADR : FOR i IN WADR'range LOOP
              IF WADR_X01(i)='X' THEN
                Msg( MsgOn, "UNKNOWN Detected on WADR"&ItoIndex(i), WARNING);
              END IF;
            END LOOP;
            IF cs_wa>=128 THEN
              Msg( MsgOn, "OUT OF RANGE Value Detected on WADR", WARNING);
            END IF;
            SC_DI : FOR i IN DI'range LOOP
              IF DI_X01(i)='X' THEN
                Msg( MsgOn, "UNKNOWN Detected on DI"&ItoIndex(i), WARNING);
              END IF;
            END LOOP;
          END IF;
      END IF;
    END IF;
  END PROCESS;

------------------------------------------------------------------------
-- OUTPUTS SECTION
------------------------------------------------------------------------
  Pre_output_out : PROCESS( int_dataout )
    TYPE GlitchArrayDataType IS ARRAY (NATURAL RANGE <>) OF VitalGlitchDataType;
    VARIABLE Initialize : BOOLEAN := TRUE;
    VARIABLE os_tpd_RCK_DOUT : VitalDelayArrayType01z(15 downto 0);
    VARIABLE os_RCK_toXdly   : TIME;
    VARIABLE GlitchData_Z : GlitchArrayDataType(15 downto 0);
  BEGIN
    IF Initialize THEN
      FOR i IN DOUT'range LOOP
        os_tpd_RCK_DOUT(i)(tr01) := tpd_rck_dout_posedge(i)(tr01) * DF;
        os_tpd_RCK_DOUT(i)(tr10) := tpd_rck_dout_posedge(i)(tr10) * DF;
        os_tpd_RCK_DOUT(i)(tr0z) := tpd_rck_dout_posedge(i)(tr0z) * DF;
        os_tpd_RCK_DOUT(i)(trz1) := tpd_rck_dout_posedge(i)(trz1) * DF;
        os_tpd_RCK_DOUT(i)(tr1z) := tpd_rck_dout_posedge(i)(tr1z) * DF;
        os_tpd_RCK_DOUT(i)(trz0) := tpd_rck_dout_posedge(i)(trz0) * DF;
      END LOOP;
      Initialize := FALSE;
    END IF;

    VitalPathDelay01z(
        OutSignal     => pre_dataout(0),
        GlitchData    => GlitchData_Z(0),
        OutSignalName => "",
        OutTemp       => int_dataout(0),
        Paths         => (
            0 => ( RCK_ipd'LAST_EVENT, os_tpd_RCK_DOUT(0), TRUE)
        ),
        DefaultDelay  => VitalZeroDelay01z,
        Mode          => VitalTransport,
        XOn           => TRUE,
        MsgOn         => FALSE,
        MsgSeverity   => WARNING);
    VitalPathDelay01z(
        OutSignal     => pre_dataout(1),
        GlitchData    => GlitchData_Z(1),
        OutSignalName => "",
        OutTemp       => int_dataout(1),
        Paths         => (
            0 => ( RCK_ipd'LAST_EVENT, os_tpd_RCK_DOUT(1), TRUE)
        ),
        DefaultDelay  => VitalZeroDelay01z,
        Mode          => VitalTransport,
        XOn           => TRUE,
        MsgOn         => FALSE,
        MsgSeverity   => WARNING);
    VitalPathDelay01z(
        OutSignal     => pre_dataout(2),
        GlitchData    => GlitchData_Z(2),
        OutSignalName => "",
        OutTemp       => int_dataout(2),
        Paths         => (
            0 => ( RCK_ipd'LAST_EVENT, os_tpd_RCK_DOUT(2), TRUE)
        ),
        DefaultDelay  => VitalZeroDelay01z,
        Mode          => VitalTransport,
        XOn           => TRUE,
        MsgOn         => FALSE,
        MsgSeverity   => WARNING);
    VitalPathDelay01z(
        OutSignal     => pre_dataout(3),
        GlitchData    => GlitchData_Z(3),
        OutSignalName => "",
        OutTemp       => int_dataout(3),
        Paths         => (
            0 => ( RCK_ipd'LAST_EVENT, os_tpd_RCK_DOUT(3), TRUE)
        ),
        DefaultDelay  => VitalZeroDelay01z,
        Mode          => VitalTransport,
        XOn           => TRUE,
        MsgOn         => FALSE,
        MsgSeverity   => WARNING);
    VitalPathDelay01z(
        OutSignal     => pre_dataout(4),
        GlitchData    => GlitchData_Z(4),
        OutSignalName => "",
        OutTemp       => int_dataout(4),
        Paths         => (
            0 => ( RCK_ipd'LAST_EVENT, os_tpd_RCK_DOUT(4), TRUE)
        ),
        DefaultDelay  => VitalZeroDelay01z,
        Mode          => VitalTransport,
        XOn           => TRUE,
        MsgOn         => FALSE,
        MsgSeverity   => WARNING);
    VitalPathDelay01z(
        OutSignal     => pre_dataout(5),
        GlitchData    => GlitchData_Z(5),
        OutSignalName => "",
        OutTemp       => int_dataout(5),
        Paths         => (
            0 => ( RCK_ipd'LAST_EVENT, os_tpd_RCK_DOUT(5), TRUE)
        ),
        DefaultDelay  => VitalZeroDelay01z,
        Mode          => VitalTransport,
        XOn           => TRUE,
        MsgOn         => FALSE,
        MsgSeverity   => WARNING);
    VitalPathDelay01z(
        OutSignal     => pre_dataout(6),
        GlitchData    => GlitchData_Z(6),
        OutSignalName => "",
        OutTemp       => int_dataout(6),
        Paths         => (
            0 => ( RCK_ipd'LAST_EVENT, os_tpd_RCK_DOUT(6), TRUE)
        ),
        DefaultDelay  => VitalZeroDelay01z,
        Mode          => VitalTransport,
        XOn           => TRUE,
        MsgOn         => FALSE,
        MsgSeverity   => WARNING);
    VitalPathDelay01z(
        OutSignal     => pre_dataout(7),
        GlitchData    => GlitchData_Z(7),
        OutSignalName => "",
        OutTemp       => int_dataout(7),
        Paths         => (
            0 => ( RCK_ipd'LAST_EVENT, os_tpd_RCK_DOUT(7), TRUE)
        ),
        DefaultDelay  => VitalZeroDelay01z,
        Mode          => VitalTransport,
        XOn           => TRUE,
        MsgOn         => FALSE,
        MsgSeverity   => WARNING);
    VitalPathDelay01z(
        OutSignal     => pre_dataout(8),
        GlitchData    => GlitchData_Z(8),
        OutSignalName => "",
        OutTemp       => int_dataout(8),
        Paths         => (
            0 => ( RCK_ipd'LAST_EVENT, os_tpd_RCK_DOUT(8), TRUE)
        ),
        DefaultDelay  => VitalZeroDelay01z,
        Mode          => VitalTransport,
        XOn           => TRUE,
        MsgOn         => FALSE,
        MsgSeverity   => WARNING);
    VitalPathDelay01z(
        OutSignal     => pre_dataout(9),
        GlitchData    => GlitchData_Z(9),
        OutSignalName => "",
        OutTemp       => int_dataout(9),
        Paths         => (
            0 => ( RCK_ipd'LAST_EVENT, os_tpd_RCK_DOUT(9), TRUE)
        ),
        DefaultDelay  => VitalZeroDelay01z,
        Mode          => VitalTransport,
        XOn           => TRUE,
        MsgOn         => FALSE,
        MsgSeverity   => WARNING);
    VitalPathDelay01z(
        OutSignal     => pre_dataout(10),
        GlitchData    => GlitchData_Z(10),
        OutSignalName => "",
        OutTemp       => int_dataout(10),
        Paths         => (
            0 => ( RCK_ipd'LAST_EVENT, os_tpd_RCK_DOUT(10), TRUE)
        ),
        DefaultDelay  => VitalZeroDelay01z,
        Mode          => VitalTransport,
        XOn           => TRUE,
        MsgOn         => FALSE,
        MsgSeverity   => WARNING);
    VitalPathDelay01z(
        OutSignal     => pre_dataout(11),
        GlitchData    => GlitchData_Z(11),
        OutSignalName => "",
        OutTemp       => int_dataout(11),
        Paths         => (
            0 => ( RCK_ipd'LAST_EVENT, os_tpd_RCK_DOUT(11), TRUE)
        ),
        DefaultDelay  => VitalZeroDelay01z,
        Mode          => VitalTransport,
        XOn           => TRUE,
        MsgOn         => FALSE,
        MsgSeverity   => WARNING);
    VitalPathDelay01z(
        OutSignal     => pre_dataout(12),
        GlitchData    => GlitchData_Z(12),
        OutSignalName => "",
        OutTemp       => int_dataout(12),
        Paths         => (
            0 => ( RCK_ipd'LAST_EVENT, os_tpd_RCK_DOUT(12), TRUE)
        ),
        DefaultDelay  => VitalZeroDelay01z,
        Mode          => VitalTransport,
        XOn           => TRUE,
        MsgOn         => FALSE,
        MsgSeverity   => WARNING);
    VitalPathDelay01z(
        OutSignal     => pre_dataout(13),
        GlitchData    => GlitchData_Z(13),
        OutSignalName => "",
        OutTemp       => int_dataout(13),
        Paths         => (
            0 => ( RCK_ipd'LAST_EVENT, os_tpd_RCK_DOUT(13), TRUE)
        ),
        DefaultDelay  => VitalZeroDelay01z,
        Mode          => VitalTransport,
        XOn           => TRUE,
        MsgOn         => FALSE,
        MsgSeverity   => WARNING);
    VitalPathDelay01z(
        OutSignal     => pre_dataout(14),
        GlitchData    => GlitchData_Z(14),
        OutSignalName => "",
        OutTemp       => int_dataout(14),
        Paths         => (
            0 => ( RCK_ipd'LAST_EVENT, os_tpd_RCK_DOUT(14), TRUE)
        ),
        DefaultDelay  => VitalZeroDelay01z,
        Mode          => VitalTransport,
        XOn           => TRUE,
        MsgOn         => FALSE,
        MsgSeverity   => WARNING);
    VitalPathDelay01z(
        OutSignal     => pre_dataout(15),
        GlitchData    => GlitchData_Z(15),
        OutSignalName => "",
        OutTemp       => int_dataout(15),
        Paths         => (
            0 => ( RCK_ipd'LAST_EVENT, os_tpd_RCK_DOUT(15), TRUE)
        ),
        DefaultDelay  => VitalZeroDelay01z,
        Mode          => VitalTransport,
        XOn           => TRUE,
        MsgOn         => FALSE,
        MsgSeverity   => WARNING);
  END PROCESS;

  Pre_output_in : PROCESS( int_datain )
    TYPE GlitchArrayDataType IS ARRAY (NATURAL RANGE <>) OF VitalGlitchDataType;
    VARIABLE Initialize : BOOLEAN := TRUE;
    VARIABLE os_tpd_WCK_DOUT  : VitalDelayArrayType01z(15 downto 0);
    VARIABLE os_WCK_toXdly    : TIME;
    VARIABLE GlitchData_Z : GlitchArrayDataType(15 downto 0);
  BEGIN
    IF Initialize THEN
      FOR i IN DOUT'range LOOP
        os_tpd_WCK_DOUT(i)(tr01)  := tpd_wck_dout_posedge(i)(tr01) * DF;
        os_tpd_WCK_DOUT(i)(tr10)  := tpd_wck_dout_posedge(i)(tr10) * DF;
        os_tpd_WCK_DOUT(i)(tr0z)  := tpd_wck_dout_posedge(i)(tr0z) * DF;
        os_tpd_WCK_DOUT(i)(trz1)  := tpd_wck_dout_posedge(i)(trz1) * DF;
        os_tpd_WCK_DOUT(i)(tr1z)  := tpd_wck_dout_posedge(i)(tr1z) * DF;
        os_tpd_WCK_DOUT(i)(trz0)  := tpd_wck_dout_posedge(i)(trz0) * DF;
      END LOOP;
      Initialize := FALSE;
    END IF;

    VitalPathDelay01z(
        OutSignal     => pre_datain(0),
        GlitchData    => GlitchData_Z(0),
        OutSignalName => "",
        OutTemp       => int_datain(0),
        Paths         => (
            0 => ( WCK_ipd'LAST_EVENT, os_tpd_WCK_DOUT(0), TRUE)
        ),
        DefaultDelay  => VitalZeroDelay01z,
        Mode          => VitalTransport,
        XOn           => TRUE,
        MsgOn         => FALSE,
        MsgSeverity   => WARNING);
    VitalPathDelay01z(
        OutSignal     => pre_datain(1),
        GlitchData    => GlitchData_Z(1),
        OutSignalName => "",
        OutTemp       => int_datain(1),
        Paths         => (
            0 => ( WCK_ipd'LAST_EVENT, os_tpd_WCK_DOUT(1), TRUE)
        ),
        DefaultDelay  => VitalZeroDelay01z,
        Mode          => VitalTransport,
        XOn           => TRUE,
        MsgOn         => FALSE,
        MsgSeverity   => WARNING);
    VitalPathDelay01z(
        OutSignal     => pre_datain(2),
        GlitchData    => GlitchData_Z(2),
        OutSignalName => "",
        OutTemp       => int_datain(2),
        Paths         => (
            0 => ( WCK_ipd'LAST_EVENT, os_tpd_WCK_DOUT(2), TRUE)
        ),
        DefaultDelay  => VitalZeroDelay01z,
        Mode          => VitalTransport,
        XOn           => TRUE,
        MsgOn         => FALSE,
        MsgSeverity   => WARNING);
    VitalPathDelay01z(
        OutSignal     => pre_datain(3),
        GlitchData    => GlitchData_Z(3),
        OutSignalName => "",
        OutTemp       => int_datain(3),
        Paths         => (
            0 => ( WCK_ipd'LAST_EVENT, os_tpd_WCK_DOUT(3), TRUE)
        ),
        DefaultDelay  => VitalZeroDelay01z,
        Mode          => VitalTransport,
        XOn           => TRUE,
        MsgOn         => FALSE,
        MsgSeverity   => WARNING);
    VitalPathDelay01z(
        OutSignal     => pre_datain(4),
        GlitchData    => GlitchData_Z(4),
        OutSignalName => "",
        OutTemp       => int_datain(4),
        Paths         => (
            0 => ( WCK_ipd'LAST_EVENT, os_tpd_WCK_DOUT(4), TRUE)
        ),
        DefaultDelay  => VitalZeroDelay01z,
        Mode          => VitalTransport,
        XOn           => TRUE,
        MsgOn         => FALSE,
        MsgSeverity   => WARNING);
    VitalPathDelay01z(
        OutSignal     => pre_datain(5),
        GlitchData    => GlitchData_Z(5),
        OutSignalName => "",
        OutTemp       => int_datain(5),
        Paths         => (
            0 => ( WCK_ipd'LAST_EVENT, os_tpd_WCK_DOUT(5), TRUE)
        ),
        DefaultDelay  => VitalZeroDelay01z,
        Mode          => VitalTransport,
        XOn           => TRUE,
        MsgOn         => FALSE,
        MsgSeverity   => WARNING);
    VitalPathDelay01z(
        OutSignal     => pre_datain(6),
        GlitchData    => GlitchData_Z(6),
        OutSignalName => "",
        OutTemp       => int_datain(6),
        Paths         => (
            0 => ( WCK_ipd'LAST_EVENT, os_tpd_WCK_DOUT(6), TRUE)
        ),
        DefaultDelay  => VitalZeroDelay01z,
        Mode          => VitalTransport,
        XOn           => TRUE,
        MsgOn         => FALSE,
        MsgSeverity   => WARNING);
    VitalPathDelay01z(
        OutSignal     => pre_datain(7),
        GlitchData    => GlitchData_Z(7),
        OutSignalName => "",
        OutTemp       => int_datain(7),
        Paths         => (
            0 => ( WCK_ipd'LAST_EVENT, os_tpd_WCK_DOUT(7), TRUE)
        ),
        DefaultDelay  => VitalZeroDelay01z,
        Mode          => VitalTransport,
        XOn           => TRUE,
        MsgOn         => FALSE,
        MsgSeverity   => WARNING);
    VitalPathDelay01z(
        OutSignal     => pre_datain(8),
        GlitchData    => GlitchData_Z(8),
        OutSignalName => "",
        OutTemp       => int_datain(8),
        Paths         => (
            0 => ( WCK_ipd'LAST_EVENT, os_tpd_WCK_DOUT(8), TRUE)
        ),
        DefaultDelay  => VitalZeroDelay01z,
        Mode          => VitalTransport,
        XOn           => TRUE,
        MsgOn         => FALSE,
        MsgSeverity   => WARNING);
    VitalPathDelay01z(
        OutSignal     => pre_datain(9),
        GlitchData    => GlitchData_Z(9),
        OutSignalName => "",
        OutTemp       => int_datain(9),
        Paths         => (
            0 => ( WCK_ipd'LAST_EVENT, os_tpd_WCK_DOUT(9), TRUE)
        ),
        DefaultDelay  => VitalZeroDelay01z,
        Mode          => VitalTransport,
        XOn           => TRUE,
        MsgOn         => FALSE,
        MsgSeverity   => WARNING);
    VitalPathDelay01z(
        OutSignal     => pre_datain(10),
        GlitchData    => GlitchData_Z(10),
        OutSignalName => "",
        OutTemp       => int_datain(10),
        Paths         => (
            0 => ( WCK_ipd'LAST_EVENT, os_tpd_WCK_DOUT(10), TRUE)
        ),
        DefaultDelay  => VitalZeroDelay01z,
        Mode          => VitalTransport,
        XOn           => TRUE,
        MsgOn         => FALSE,
        MsgSeverity   => WARNING);
    VitalPathDelay01z(
        OutSignal     => pre_datain(11),
        GlitchData    => GlitchData_Z(11),
        OutSignalName => "",
        OutTemp       => int_datain(11),
        Paths         => (
            0 => ( WCK_ipd'LAST_EVENT, os_tpd_WCK_DOUT(11), TRUE)
        ),
        DefaultDelay  => VitalZeroDelay01z,
        Mode          => VitalTransport,
        XOn           => TRUE,
        MsgOn         => FALSE,
        MsgSeverity   => WARNING);
    VitalPathDelay01z(
        OutSignal     => pre_datain(12),
        GlitchData    => GlitchData_Z(12),
        OutSignalName => "",
        OutTemp       => int_datain(12),
        Paths         => (
            0 => ( WCK_ipd'LAST_EVENT, os_tpd_WCK_DOUT(12), TRUE)
        ),
        DefaultDelay  => VitalZeroDelay01z,
        Mode          => VitalTransport,
        XOn           => TRUE,
        MsgOn         => FALSE,
        MsgSeverity   => WARNING);
    VitalPathDelay01z(
        OutSignal     => pre_datain(13),
        GlitchData    => GlitchData_Z(13),
        OutSignalName => "",
        OutTemp       => int_datain(13),
        Paths         => (
            0 => ( WCK_ipd'LAST_EVENT, os_tpd_WCK_DOUT(13), TRUE)
        ),
        DefaultDelay  => VitalZeroDelay01z,
        Mode          => VitalTransport,
        XOn           => TRUE,
        MsgOn         => FALSE,
        MsgSeverity   => WARNING);
    VitalPathDelay01z(
        OutSignal     => pre_datain(14),
        GlitchData    => GlitchData_Z(14),
        OutSignalName => "",
        OutTemp       => int_datain(14),
        Paths         => (
            0 => ( WCK_ipd'LAST_EVENT, os_tpd_WCK_DOUT(14), TRUE)
        ),
        DefaultDelay  => VitalZeroDelay01z,
        Mode          => VitalTransport,
        XOn           => TRUE,
        MsgOn         => FALSE,
        MsgSeverity   => WARNING);
    VitalPathDelay01z(
        OutSignal     => pre_datain(15),
        GlitchData    => GlitchData_Z(15),
        OutSignalName => "",
        OutTemp       => int_datain(15),
        Paths         => (
            0 => ( WCK_ipd'LAST_EVENT, os_tpd_WCK_DOUT(15), TRUE)
        ),
        DefaultDelay  => VitalZeroDelay01z,
        Mode          => VitalTransport,
        XOn           => TRUE,
        MsgOn         => FALSE,
        MsgSeverity   => WARNING);
  END PROCESS;

  Outputs_1 : PROCESS( BYP_X01, int_enable, pre_datain, pre_dataout )
    VARIABLE Initialize : BOOLEAN := TRUE;
    VARIABLE GlitchData_DOUT : GlitchArrayDataType(15 downto 0);
    VARIABLE muxed_DOUT_Z    : std_ulogic_vector(15 downto 0);
    VARIABLE DOUT_Z          : std_ulogic_vector(15 downto 0);
  BEGIN
    IF Initialize THEN
      Initialize := FALSE;
    END IF;

    muxed_DOUT_Z := MuxedSig( pre_dataout, pre_datain, BYP_X01);
    IF int_enable='0' THEN
      DOUT_Z := (others=>'Z');
    ELSIF int_enable='1' THEN
      DOUT_Z := muxed_DOUT_Z;
    ELSE
      DOUT_Z := (others=>'X');
    END IF;

    VitalPathDelay01z(
        OutSignal     => DOUT(0),
        GlitchData    => GlitchData_DOUT(0),
        OutSignalName => "DOUT",
        OutTemp       => DOUT_Z(0),
        Paths         => (
            0 => ( pre_dataout'LAST_EVENT, VitalZeroDelay01z, TRUE)
        ),
        DefaultDelay  => VitalZeroDelay01z,
        Mode          => VitalTransport,
        XOn           => TRUE,
        MsgOn         => FALSE,
        MsgSeverity   => WARNING);
    VitalPathDelay01z(
        OutSignal     => DOUT(1),
        GlitchData    => GlitchData_DOUT(1),
        OutSignalName => "DOUT",
        OutTemp       => DOUT_Z(1),
        Paths         => (
            0 => ( pre_dataout'LAST_EVENT, VitalZeroDelay01z, TRUE)
        ),
        DefaultDelay  => VitalZeroDelay01z,
        Mode          => VitalTransport,
        XOn           => TRUE,
        MsgOn         => FALSE,
        MsgSeverity   => WARNING);
    VitalPathDelay01z(
        OutSignal     => DOUT(2),
        GlitchData    => GlitchData_DOUT(2),
        OutSignalName => "DOUT",
        OutTemp       => DOUT_Z(2),
        Paths         => (
            0 => ( pre_dataout'LAST_EVENT, VitalZeroDelay01z, TRUE)
        ),
        DefaultDelay  => VitalZeroDelay01z,
        Mode          => VitalTransport,
        XOn           => TRUE,
        MsgOn         => FALSE,
        MsgSeverity   => WARNING);
    VitalPathDelay01z(
        OutSignal     => DOUT(3),
        GlitchData    => GlitchData_DOUT(3),
        OutSignalName => "DOUT",
        OutTemp       => DOUT_Z(3),
        Paths         => (
            0 => ( pre_dataout'LAST_EVENT, VitalZeroDelay01z, TRUE)
        ),
        DefaultDelay  => VitalZeroDelay01z,
        Mode          => VitalTransport,
        XOn           => TRUE,
        MsgOn         => FALSE,
        MsgSeverity   => WARNING);
    VitalPathDelay01z(
        OutSignal     => DOUT(4),
        GlitchData    => GlitchData_DOUT(4),
        OutSignalName => "DOUT",
        OutTemp       => DOUT_Z(4),
        Paths         => (
            0 => ( pre_dataout'LAST_EVENT, VitalZeroDelay01z, TRUE)
        ),
        DefaultDelay  => VitalZeroDelay01z,
        Mode          => VitalTransport,
        XOn           => TRUE,
        MsgOn         => FALSE,
        MsgSeverity   => WARNING);
    VitalPathDelay01z(
        OutSignal     => DOUT(5),
        GlitchData    => GlitchData_DOUT(5),
        OutSignalName => "DOUT",
        OutTemp       => DOUT_Z(5),
        Paths         => (
            0 => ( pre_dataout'LAST_EVENT, VitalZeroDelay01z, TRUE)
        ),
        DefaultDelay  => VitalZeroDelay01z,
        Mode          => VitalTransport,
        XOn           => TRUE,
        MsgOn         => FALSE,
        MsgSeverity   => WARNING);
    VitalPathDelay01z(
        OutSignal     => DOUT(6),
        GlitchData    => GlitchData_DOUT(6),
        OutSignalName => "DOUT",
        OutTemp       => DOUT_Z(6),
        Paths         => (
            0 => ( pre_dataout'LAST_EVENT, VitalZeroDelay01z, TRUE)
        ),
        DefaultDelay  => VitalZeroDelay01z,
        Mode          => VitalTransport,
        XOn           => TRUE,
        MsgOn         => FALSE,
        MsgSeverity   => WARNING);
    VitalPathDelay01z(
        OutSignal     => DOUT(7),
        GlitchData    => GlitchData_DOUT(7),
        OutSignalName => "DOUT",
        OutTemp       => DOUT_Z(7),
        Paths         => (
            0 => ( pre_dataout'LAST_EVENT, VitalZeroDelay01z, TRUE)
        ),
        DefaultDelay  => VitalZeroDelay01z,
        Mode          => VitalTransport,
        XOn           => TRUE,
        MsgOn         => FALSE,
        MsgSeverity   => WARNING);
    VitalPathDelay01z(
        OutSignal     => DOUT(8),
        GlitchData    => GlitchData_DOUT(8),
        OutSignalName => "DOUT",
        OutTemp       => DOUT_Z(8),
        Paths         => (
            0 => ( pre_dataout'LAST_EVENT, VitalZeroDelay01z, TRUE)
        ),
        DefaultDelay  => VitalZeroDelay01z,
        Mode          => VitalTransport,
        XOn           => TRUE,
        MsgOn         => FALSE,
        MsgSeverity   => WARNING);
    VitalPathDelay01z(
        OutSignal     => DOUT(9),
        GlitchData    => GlitchData_DOUT(9),
        OutSignalName => "DOUT",
        OutTemp       => DOUT_Z(9),
        Paths         => (
            0 => ( pre_dataout'LAST_EVENT, VitalZeroDelay01z, TRUE)
        ),
        DefaultDelay  => VitalZeroDelay01z,
        Mode          => VitalTransport,
        XOn           => TRUE,
        MsgOn         => FALSE,
        MsgSeverity   => WARNING);
    VitalPathDelay01z(
        OutSignal     => DOUT(10),
        GlitchData    => GlitchData_DOUT(10),
        OutSignalName => "DOUT",
        OutTemp       => DOUT_Z(10),
        Paths         => (
            0 => ( pre_dataout'LAST_EVENT, VitalZeroDelay01z, TRUE)
        ),
        DefaultDelay  => VitalZeroDelay01z,
        Mode          => VitalTransport,
        XOn           => TRUE,
        MsgOn         => FALSE,
        MsgSeverity   => WARNING);
    VitalPathDelay01z(
        OutSignal     => DOUT(11),
        GlitchData    => GlitchData_DOUT(11),
        OutSignalName => "DOUT",
        OutTemp       => DOUT_Z(11),
        Paths         => (
            0 => ( pre_dataout'LAST_EVENT, VitalZeroDelay01z, TRUE)
        ),
        DefaultDelay  => VitalZeroDelay01z,
        Mode          => VitalTransport,
        XOn           => TRUE,
        MsgOn         => FALSE,
        MsgSeverity   => WARNING);
    VitalPathDelay01z(
        OutSignal     => DOUT(12),
        GlitchData    => GlitchData_DOUT(12),
        OutSignalName => "DOUT",
        OutTemp       => DOUT_Z(12),
        Paths         => (
            0 => ( pre_dataout'LAST_EVENT, VitalZeroDelay01z, TRUE)
        ),
        DefaultDelay  => VitalZeroDelay01z,
        Mode          => VitalTransport,
        XOn           => TRUE,
        MsgOn         => FALSE,
        MsgSeverity   => WARNING);
    VitalPathDelay01z(
        OutSignal     => DOUT(13),
        GlitchData    => GlitchData_DOUT(13),
        OutSignalName => "DOUT",
        OutTemp       => DOUT_Z(13),
        Paths         => (
            0 => ( pre_dataout'LAST_EVENT, VitalZeroDelay01z, TRUE)
        ),
        DefaultDelay  => VitalZeroDelay01z,
        Mode          => VitalTransport,
        XOn           => TRUE,
        MsgOn         => FALSE,
        MsgSeverity   => WARNING);
    VitalPathDelay01z(
        OutSignal     => DOUT(14),
        GlitchData    => GlitchData_DOUT(14),
        OutSignalName => "DOUT",
        OutTemp       => DOUT_Z(14),
        Paths         => (
            0 => ( pre_dataout'LAST_EVENT, VitalZeroDelay01z, TRUE)
        ),
        DefaultDelay  => VitalZeroDelay01z,
        Mode          => VitalTransport,
        XOn           => TRUE,
        MsgOn         => FALSE,
        MsgSeverity   => WARNING);
    VitalPathDelay01z(
        OutSignal     => DOUT(15),
        GlitchData    => GlitchData_DOUT(15),
        OutSignalName => "DOUT",
        OutTemp       => DOUT_Z(15),
        Paths         => (
            0 => ( pre_dataout'LAST_EVENT, VitalZeroDelay01z, TRUE)
        ),
        DefaultDelay  => VitalZeroDelay01z,
        Mode          => VitalTransport,
        XOn           => TRUE,
        MsgOn         => FALSE,
        MsgSeverity   => WARNING);
  END PROCESS;

------------------------------------------------------------------------
-- RAM FUNCTION
------------------------------------------------------------------------
  int_delayed_tmg_error <= int_tmg_error;

  RAM_Behavior : PROCESS( int_rd_clock, int_wr_clock, int_delayed_tmg_error )
    VARIABLE memory : MEM;
    VARIABLE clk_status        : std_ulogic := 'X';
    VARIABLE rd_enable         : std_ulogic := 'X';
    VARIABLE rd_adr            : std_ulogic_vector(6 downto 0) := (others=>'X');
    VARIABLE wr_enable         : std_ulogic := 'X';
    VARIABLE wr_byte           : std_ulogic_vector(1 downto 0) := (others=>'X');
    VARIABLE wr_adr            : std_ulogic_vector(6 downto 0) := (others=>'X');
    VARIABLE wr_di_0           : std_ulogic_vector(15 downto 0) := (others=>'X');
    VARIABLE wr_di_1           : std_ulogic_vector(15 downto 0) := (others=>'X');
    VARIABLE wr_di             : std_ulogic_vector(15 downto 0) := (others=>'X');
    VARIABLE latched_rd_enable : std_ulogic := 'X';
    VARIABLE latched_wr_enable : std_ulogic := 'X';
    VARIABLE latched_wr_byte   : std_ulogic_vector(1 downto 0) := (others=>'X');
    VARIABLE latched_rd_adr    : std_ulogic_vector(6 downto 0) := (others=>'X');
    VARIABLE latched_wr_adr    : std_ulogic_vector(6 downto 0) := (others=>'X');
    VARIABLE latched_wr_di     : std_ulogic_vector(15 downto 0) := (others=>'X');
    VARIABLE local_dataout     : std_ulogic_vector(15 downto 0) := (others=>'X');
    VARIABLE err_bwe           : std_ulogic_vector(1 downto 0) := (others=>'X');
    VARIABLE err_adr           : std_ulogic_vector(6 downto 0) := (others=>'X');
    VARIABLE err_data          : std_ulogic_vector(15 downto 0) := (others=>'X');
    VARIABLE Initialize        : BOOLEAN := TRUE;
  BEGIN
--
  IF Initialize THEN
     for i in memory'high downto memory'low loop
           memory(i) := (others=>'U');
        end loop;
    Initialize := FALSE;
  END IF;
-- Read Cycle
--
    clk_status := EvalRising( int_rd_clock);
    IF clk_status/='0' AND int_tmg_error='0' THEN
      rd_enable := NOT MuxedSig( REN_X01, TIREN_X01, TSE_X01);
      rd_adr    :=     MuxedSig( RADR_X01, int_rd_adrs(6-1 downto 0)&TIRADR_X01, TSE_X01);

      latched_rd_enable := LatchedSig( clk_status, latched_rd_enable, rd_enable);
      latched_rd_adr    := LatchedSig( clk_status, latched_rd_adr,    rd_adr);

      MemoryRead( memory, 128, clk_status, latched_rd_enable, latched_rd_adr, local_dataout);
    END IF;
--
-- Write Cycle
--
    clk_status := EvalRising( int_wr_clock);
    IF clk_status/='0' AND int_tmg_error='0' THEN
      wr_enable :=  NOT MuxedSig( WEN_X01, TIWEN_X01, TSE_X01);
      wr_byte   :=  NOT MuxedSig( BWEN_X01, TIBWEN_X01, TSE_X01);
      wr_adr    :=      MuxedSig( WADR_X01, int_wr_adrs(6-1 downto 0)&TIWADR_X01, TSE_X01);
      wr_di_0   :=      MuxedSig( DI_X01, int_wr_data, WEN_X01);
      wr_di_1   :=      MuxedSig( int_dataout, int_wr_data(15-1 downto 0)&TID_X01, TRCN_X01);
      wr_di     :=      MuxedSig( wr_di_0, wr_di_1, TSE_X01);

      latched_wr_enable :=  LatchedSig( clk_status, latched_wr_enable, wr_enable);
      latched_wr_byte   :=  LatchedSig( clk_status, latched_wr_byte, wr_byte);
      latched_wr_adr    :=  LatchedSig( clk_status, latched_wr_adr, wr_adr);
      latched_wr_di     :=  LatchedSig( clk_status, latched_wr_di, wr_di);

      MemoryWrite( memory, 128, clk_status, latched_wr_enable, latched_wr_byte, latched_wr_adr, latched_wr_di);
    END IF;
--
-- Timing error
--
    IF Xon AND int_tmg_error/='0' THEN
      IF int_rd_tmg_error/='0' THEN
        IF int_tmg_error_pw_rck/='0' THEN
          latched_rd_enable := 'X';
          latched_rd_adr    := err_adr;
        END IF;
        IF int_tmg_error_sh_ren/='0' THEN
          latched_rd_enable := 'X';
        END IF;
        IF VCT2I(int_tmg_error_sh_radr)/=0 THEN
          latched_rd_adr := err_adr;
        END IF;
        IF int_tmg_error_rwclk/='0' THEN
        END IF;
        local_dataout := err_data;
      END IF;
      IF int_wr_tmg_error/='0' THEN
        IF int_tmg_error_pw_wck/='0' THEN
          latched_wr_enable := 'X';
          latched_wr_byte   := err_bwe;
          latched_wr_adr    := err_adr;
          latched_wr_di     := err_data;
          MemoryWrite( memory, 128, '1', latched_wr_enable, latched_wr_byte, latched_wr_adr, err_data);
        END IF;
        IF int_tmg_error_sh_wenw/='0' THEN
          latched_wr_enable := 'X';
          MemoryWrite( memory, 128, '1', latched_wr_enable, latched_wr_byte, latched_wr_adr, err_data);
        END IF;
        IF VCT2I(int_tmg_error_sh_wadrw)/=0 THEN
          latched_wr_adr    := err_adr;
          MemoryWrite( memory, 128, '1', latched_wr_enable, latched_wr_byte, latched_wr_adr, err_data);
        END IF;
        IF VCT2I(int_tmg_error_sh_diw)/=0 THEN
          latched_wr_di     := err_data;
          MemoryWrite( memory, 128, '1', latched_wr_enable, latched_wr_byte, latched_wr_adr, err_data);
        END IF;
        IF int_tmg_error_wrclk/='0' THEN
          local_dataout := err_data;
        END IF;
      END IF;
    END IF;

    int_rd_adrs <= latched_rd_adr;
    int_wr_adrs <= latched_wr_adr;
    int_wr_data <= latched_wr_di;

    int_datain  <= latched_wr_di;
    int_dataout <= local_dataout;
    int_toradr  <= latched_rd_adr(6);
    int_towadr  <= latched_wr_adr(6);
    int_toren   <= NOT latched_rd_enable;
    int_towen   <= NOT latched_wr_enable;
    int_tobwen  <= NOT latched_wr_byte;
    int_tod     <= latched_wr_di(15);

  END PROCESS;

END R128X16M1_behavior;
