#
# general include file for all Make scripts defining defaults
#

#
# Note: those Make scripts are not for consistend source dependency testing but
#       rather to have a consistent set of easy to maintain scripts for compiling
#       the chip


.PHONY:         all CheckReports CleanAll BCKDesign

.SUFFIXES:      .db .scr

.IGNORE:	%.db

SHELL   = /bin/csh
NICE    = 10
SRC     = ../SRC
SCRIPTS = SCRIPTS
NETLIST = NETLIST
REPT    = REPORTS

VPATH   = ${SCRIPTS}:{NETLIST}
ENCTR	= "`env | grep ENCOUNTER`"

#
# synopsys compile commands dependent upon compile script
#

%.db: %.scr
#	ifneq ${ENCTR}, ""
#	  echo "ERROR - FirstEncounter environment defined"
#	  echo "        FE environment is incompatiple with synopsys"
#	  echo "        restart with clean synopsys environment"
#	else
#	  - module list
	  - (time nice dc_shell -f $<) >& ${REPT}/.compile_$(basename $@).log
	  - logstrip -o ${REPT}/compile_$(basename $@).log ${REPT}/.compile_$(basename $@).log $<
	  - grep -i error ${REPT}/*_$(basename $@).*
#	endif

#
# check all reports and filter known, benine warnings
#
CheckReports:
	- grep -i warning ./${REP}/*.* |		\
	    grep -iv "small trippoint" | 		\
	    grep -iv "defining new variable" |		\
	    grep -iv "Inserting delay to fix min_delay"
	- grep -i error  ./${REP}/*.*
	- grep -i violated  ./${REP}/rt*.*

#
# create local copy of all output directories and synthesis scripts
# this is useful should something go wrong during make all
#

LASTVALID = LastValid

BCKDesign:
	- rm -Rf ${LASTVALID}
	- mkdir  ${LASTVALID}
	- cp -R ${NETLIST} ${REPT} ${SCRIPTS} ${LASTVALID}/
	- du -sk ${LASTVALID}
	- cd ${SRC}; rm -Rf ${LASTVALID}
	- cd ${SRC}; mkdir  ../${LASTVALID}
	- cd ${SRC}; cp -r * ../${LASTVALID}/
	- cd ${SRC}; mv ../${LASTVALID} ${LASTVALID}
	- cd ${SRC}; du -sk ${LASTVALID}

#
# clean entire design - remove all generated files
#
CleanAll:
	-@ touch xx.log; rm -f  *.log
	-@ touch ./${REPT}/xx ./${REPT}/x.c; rm -rf ./${REPT}/* ./${REPT}/.c*
	-@ touch ./WORK/xx; rm -rf ./WORK/* 
	-@ touch ./NETLIST/xx; rm -rf ./NETLIST/* 
